"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var CodeEditorLineBar_1 = require("./CodeEditorLineBar");
var CodeEditorModel_1 = require("./CodeEditorModel");
require("./style/index.less");
var CodeEditor = (function (_super) {
    __extends(CodeEditor, _super);
    function CodeEditor(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            lineData: []
        };
        _this.data = [];
        _this.editorId = _this.guid();
        _this.lineId = _this.guid();
        return _this;
    }
    CodeEditor.prototype.$inject = function () {
        this.data = this.model.obj.convertTextToLineData(this.props.text);
        this.state.lineData = this.model.obj.lineData;
    };
    CodeEditor.prototype.$didMount = function () {
        this.model.obj.setEditorContainer(this.dom[this.editorId]);
        this.model.obj.attachTextDataToDom(this.data);
        this.editorDom = this.dom[this.editorId];
        this.lineBarDom = this.dom[this.lineId];
        this.refreshLineBar();
    };
    CodeEditor.prototype.render = function () {
        return require("./views/editor.html");
    };
    CodeEditor.prototype.onLineClick = function (lineIndex, isActive) {
        if (this.choseLineIndex !== lineIndex && this.editorDom) {
            if (this.editorDom.children[this.choseLineIndex]) {
                this.$.removeClass(this.editorDom.children[this.choseLineIndex], "active");
            }
            if (this.editorDom.children[lineIndex]) {
                this.$.addClass(this.editorDom.children[lineIndex], "active");
            }
            this.choseLineIndex = lineIndex;
        }
        else if (this.choseLineIndex === lineIndex) {
            if (isActive) {
                if (this.editorDom.children[lineIndex]) {
                    this.$.addClass(this.editorDom.children[lineIndex], "active");
                }
            }
            else {
                if (this.editorDom.children[lineIndex]) {
                    this.$.removeClass(this.editorDom.children[lineIndex], "active");
                }
            }
        }
    };
    CodeEditor.prototype.onKeyDown = function (evt) {
        if (evt.nativeEvent.keyCode === 13) {
            evt.nativeEvent.preventDefault();
            this.model.obj.addNewLine(evt.nativeEvent.srcElement);
            this.refreshLineBar();
        }
        else if (evt.nativeEvent.keyCode === 8) {
            var lineDom = evt.nativeEvent.srcElement;
            var sourceText = lineDom.innerText;
            var htmlText = lineDom.innerHTML;
            if (sourceText.length === 1 && htmlText === "<br>") {
                var next = lineDom.previousSibling;
                if (next) {
                    next.click();
                }
                lineDom.parentElement && lineDom.parentElement.removeChild(lineDom);
                this.refreshLineBar();
            }
        }
    };
    CodeEditor.prototype.refreshLineBar = function () {
        this.lineBarDom.setState({
            data: this.model.obj.getLinesData()
        });
    };
    CodeEditor.propType = {
        lineHeight: {
            description: "设置行高",
            defaultValue: 20,
            rule: elmer_ui_core_1.PropTypes.number
        },
        text: {
            description: "加载内容",
            defaultValue: "// this is an line\n            class Test extends BaseComponent {\n                constructor() {\n                    // do something\n                }\n            }\n            function a() {\n                var a=1; // define object\n                console.log(\"abbccdd\");\n                if(abb>2) {\n                    console.log(\"hahah\");\n                }\n                aaa/*\n                elmer s j\n                aaa\n                */\n            }",
            rule: elmer_ui_core_1.PropTypes.string
        },
        isEdit: {
            description: "是否启用编辑功能",
            defaultValue: true,
            rule: elmer_ui_core_1.PropTypes.bool.isRequired
        },
        language: {
            description: "设置支持语言",
            defaultValue: "javascript",
            rule: elmer_ui_core_1.PropTypes.string
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], CodeEditor.prototype, "$", void 0);
    CodeEditor = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "CodeEditor",
            components: [
                {
                    selector: "CodeEditorLineBar",
                    component: CodeEditorLineBar_1.default
                }
            ],
            model: {
                obj: CodeEditorModel_1.default
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], CodeEditor);
    return CodeEditor;
}(elmer_ui_core_1.Component));
exports.default = CodeEditor;
