"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var CodeEditorLineBar = (function (_super) {
    __extends(CodeEditorLineBar, _super);
    function CodeEditorLineBar(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            data: [],
            lineSpanStyle: "line-height: 24px;"
        };
        _this.state.data = props.data;
        if (props.lineHeight > 0) {
            _this.state.lineSpanStyle = "line-height: " + props.lineHeight + "px;";
        }
        return _this;
    }
    CodeEditorLineBar.prototype.onLineClick = function (evt) {
        var index = evt.nativeEvent.target.getAttribute("data-index");
        if (this.isNumeric(index) && !this.isEmpty(index)) {
            var updateIndex = parseInt(index, 10);
            var newData = JSON.parse(JSON.stringify(this.state.data));
            var isActive = false;
            if (newData[updateIndex]) {
                if (updateIndex !== this.choseIndex) {
                    newData[updateIndex].className = "active";
                    if (newData[this.choseIndex]) {
                        newData[this.choseIndex].className = "";
                    }
                    isActive = true;
                }
                else {
                    if (!this.isEmpty(newData[updateIndex].className)) {
                        newData[updateIndex].className = "";
                        isActive = false;
                    }
                    else {
                        newData[updateIndex].className = "active";
                        isActive = true;
                    }
                }
            }
            this.choseIndex = updateIndex;
            this.setState({
                data: newData
            });
            typeof this.props.onLineClick === "function" && this.props.onLineClick(updateIndex, isActive);
        }
    };
    CodeEditorLineBar.prototype.onSelectStart = function (evt) {
        evt.nativeEvent.returnValue = false;
        return false;
    };
    CodeEditorLineBar.prototype.render = function () {
        return require("./views/lines.html");
    };
    CodeEditorLineBar.propType = {
        data: {
            defaultValue: [],
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        onLineClick: {
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    return CodeEditorLineBar;
}(elmer_ui_core_1.Component));
exports.default = CodeEditorLineBar;
