"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var UploadModel_1 = require("./UploadModel");
var UploadComponent = (function (_super) {
    __extends(UploadComponent, _super);
    function UploadComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            showAdd: true,
            choseable: true,
            fileList: []
        };
        _this.theme = "";
        _this.fileTypeIcons = {
            bmp: "/assets/icon_file_bmp.png",
            docx: "/assets/fileType/icon_file_docx.png",
            doc: "/assets/fileType/icon_file_doc.png",
            exe: "/assets/fileType/icon_file_exe.png",
            gif: "/assets/fileType/icon_file_gif.png",
            jpeg: "/assets/fileType/icon_file_jpeg.png",
            jpg: "/assets/fileType/icon_file_jpg.png",
            pdf: "/assets/fileType/icon_file_pdf.png",
            none: "/assets/fileType/icon_file_none.png",
            png: "/assets/fileType/icon_file_png.png",
            ppt: "/assets/fileType/icon_file_ppt.png",
            pptx: "/assets/fileType/icon_file_pptx.png",
            rar: "/assets/fileType/icon_file_rar.png",
            tif: "/assets/fileType/icon_file_tif.png",
            txt: "/assets/fileType/icon_file_txt.png",
            xls: "/assets/fileType/icon_file_xls.png",
            xlsx: "/assets/fileType/icon_file_xlsx.png",
            zip: "/assets/fileType/icon_file_zip.png",
        };
        _this.fileID = _this.getRandomID();
        _this.defaultFileList = [];
        _this.theme = props.theme || "";
        _this.defaultFileList = props.fileList || [];
        _this.updateDefaultFileList();
        return _this;
    }
    UploadComponent.prototype.$inject = function () {
        var valueKey = this.props.valueName || "abUrl";
        this.defineReadOnlyProperty(this.model.obj, "setState", this.setState.bind(this));
        this.defineReadOnlyProperty(this.model.obj, "uploadAction", this.props.action);
        this.defineReadOnlyProperty(this.model.obj, "formName", this.props.formName);
        this.defineReadOnlyProperty(this.model.obj, "handleSuccess", this.props.handleSuccess);
        this.defineReadOnlyProperty(this.model.obj, "handleFail", this.props.handleFail);
        this.defineReadOnlyProperty(this.model.obj, "valueKey", valueKey);
    };
    UploadComponent.prototype.updateDefaultFileList = function (refresh) {
        var fileList = this.defaultFileList || [];
        var newFileList = [];
        for (var _i = 0, fileList_1 = fileList; _i < fileList_1.length; _i++) {
            var tmpFile = fileList_1[_i];
            var isImage = /\.(jpg|jpeg|gif|bmp|png)$/i.test(tmpFile.url);
            newFileList.push({
                name: tmpFile.name,
                size: !this.isEmpty(tmpFile.size) ? tmpFile.size : "",
                header: isImage ? tmpFile.url : this.getFileTypeIcon(tmpFile.url),
                showProg: false,
                percent: 0,
                url: tmpFile.url,
                value: !this.isEmpty(tmpFile.value) ? tmpFile.value : tmpFile.url
            });
        }
        if (refresh) {
            this.setState({
                fileList: newFileList
            });
        }
        else {
            this.state.fileList = newFileList;
        }
    };
    UploadComponent.prototype.$onPropsChanged = function (newProps) {
        this.defaultFileList = newProps.fileList || [];
        this.theme = newProps.theme || "";
        this.updateDefaultFileList(true);
    };
    UploadComponent.prototype.handleOnUploadClick = function () {
        var dom = this.dom[this.fileID];
        if (this.state.choseable) {
            dom.click();
        }
    };
    UploadComponent.prototype.handleOnFileChanged = function (evt) {
        var files = evt.target.files;
        var newFileList = this.props.multi ? JSON.parse(JSON.stringify(this.state.fileList || [])) : [];
        if (files && files.length > 0) {
            for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                var file = files_1[_i];
                newFileList.push({
                    name: (file.name || "").replace(/\.[a-z0-9]*$/, ""),
                    header: this.getFileTypeIcon(file.name),
                    size: this.calcFileSize(file.size),
                    url: "~/fackpath/" + file.name,
                    showProg: true,
                    percent: 0
                });
                this.model.obj.appendUpload(file, newFileList.length - 1, this);
            }
            this.setState({
                fileList: newFileList,
                choseable: newFileList.length > 1
            });
        }
    };
    UploadComponent.prototype.getData = function () {
        if (this.props.multi) {
            var result = [];
            for (var _i = 0, _a = this.state.fileList; _i < _a.length; _i++) {
                var tmpFile = _a[_i];
                result.push((tmpFile.value || tmpFile.url));
            }
            return result;
        }
        else {
            return this.state.fileList && this.state.fileList[0] ? (this.state.fileList[0].value || this.state.fileList[0].url) : "";
        }
    };
    UploadComponent.prototype.reset = function () {
        this.defaultFileList = [];
        this.updateDefaultFileList(true);
    };
    UploadComponent.prototype.render = function () {
        return require("./index.html");
    };
    UploadComponent.prototype.calcFileSize = function (fileSize) {
        var result = fileSize + "Byte";
        if (fileSize < 1024) {
            result = fileSize.toFixed(2) + "Byte";
        }
        else if (fileSize >= 1024 && fileSize < Math.pow(1024, 2)) {
            result = (fileSize / 1024).toFixed(2) + "KB";
        }
        else if (fileSize >= Math.pow(1024, 2) && fileSize < Math.pow(1024, 3)) {
            result = (fileSize / 1024 / 1024).toFixed(2) + "M";
        }
        else if (fileSize >= Math.pow(1024, 3) && fileSize < Math.pow(1024, 4)) {
            result = (fileSize / 1024 / 1024 / 1024).toFixed(2) + "G";
        }
        else if (fileSize >= Math.pow(1024, 4)) {
            result = (fileSize / 1024 / 1024 / 1024 / 1024).toFixed(2) + "GB";
        }
        return result;
    };
    UploadComponent.prototype.getFileTypeIcon = function (fileName) {
        var fileType = "none";
        var checkFileName = fileName || "";
        var lIndex = checkFileName.lastIndexOf(".");
        if (lIndex >= 0) {
            fileType = checkFileName.substr(lIndex + 1).toLowerCase();
        }
        var fileTypeIcon = !this.isEmpty(this.fileTypeIcons[fileType]) ? this.fileTypeIcons[fileType] : "/assets/fileType/icon_file_none.png";
        return this.props.domain + fileTypeIcon;
    };
    UploadComponent.propType = {
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        style: {
            defaultValue: "",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        listType: {
            defaultValue: "item",
            description: "列表样式",
            rule: elmer_ui_core_1.propTypes.oneValueOf(["list", "item"]).isRequired
        },
        multi: {
            defaultValue: false,
            description: "是否多文件",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        domain: {
            defaultValue: ".",
            description: "文件类型图片域名",
            rule: elmer_ui_core_1.propTypes.string
        },
        action: {
            defaultValue: "http://39.105.32.169/data/User/admin/home/document/nanjin_tianyi/public/index.php/tianyi/apply/upload",
            description: "文件类型图片域名",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        formName: {
            defaultValue: "uploadFile",
            description: "form name",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        handleSuccess: {
            description: "上传成功结果分析，需要返回url和disUrl, 给组件自动处理结果显示",
            rule: elmer_ui_core_1.propTypes.func
        },
        handleFail: {
            description: "上传失败",
            rule: elmer_ui_core_1.propTypes.func
        },
        accept: {
            defaultValue: "image/*",
            description: "接受文件类型",
            rule: elmer_ui_core_1.propTypes.string
        },
        valueName: {
            defaultValue: "abUrl",
            description: "Response获取value的key值",
            rule: elmer_ui_core_1.propTypes.string
        },
        fileList: {
            defaultValue: [],
            description: "默认已有文件列表",
            rule: elmer_ui_core_1.propTypes.array
        }
    };
    UploadComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "Upload",
            model: {
                obj: UploadModel_1.UploadModel
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], UploadComponent);
    return UploadComponent;
}(elmer_ui_core_1.Component));
exports.UploadComponent = UploadComponent;
