"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadModel = void 0;
var elmer_common_1 = require("elmer-common");
var elmer_ui_core_1 = require("elmer-ui-core");
var toast_1 = require("../toast");
var UploadModel = (function (_super) {
    __extends(UploadModel, _super);
    function UploadModel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UploadModel.prototype.appendUpload = function (fileObj, fileIndex, sender) {
        var _this = this;
        var uploadAction = function (file, index, component) {
            var sData = JSON.parse(JSON.stringify(component.state.fileList || []));
            var formData = new FormData();
            formData.append(_this.formName, file);
            _this.service.sendRequest({
                url: _this.uploadAction,
                type: "POST",
                data: formData,
                header: {
                    "Content-Type": "multipart/form-data;charset=utf8"
                },
                uploadProgress: function (evt) {
                    sData = JSON.parse(JSON.stringify(component.state.fileList || []));
                    sData[index].percent = Math.ceil(evt.loaded / evt.total * 100) + "%";
                    component.setState({
                        fileList: sData
                    });
                }
            }).then(function (resp) {
                var success = false;
                var url = "";
                var displayUrl = "";
                var valueKey = _this["valueKey"];
                if (typeof _this.handleSuccess === "function") {
                    var result = _this.handleSuccess(resp);
                    success = result.success;
                    url = result.url;
                    displayUrl = result.disUrl;
                }
                else {
                    if (resp.success) {
                        success = true;
                        url = resp[valueKey];
                        displayUrl = resp.url;
                    }
                }
                if (success) {
                    sData = JSON.parse(JSON.stringify(component.state.fileList || []));
                    sData[index].url = displayUrl;
                    sData[index].value = url;
                    sData[index].showProg = false;
                    if (/\.(jpg|jpeg|gif|bmp|png)$/i.test(displayUrl)) {
                        sData[index].header = displayUrl;
                    }
                    component.setState({
                        fileList: sData,
                        choseable: true
                    });
                }
                else {
                    _this.onError(index, resp.info || resp.message || "上传文件失败");
                    component.setState({
                        choseable: true
                    });
                }
            }).catch(function (err) {
                _this.onError(index, err.statusText || err.message || "上传文件失败");
                component.setState({
                    choseable: true
                });
                console.error(err);
            });
        };
        return new uploadAction(fileObj, fileIndex, sender);
    };
    UploadModel.prototype.onError = function (index, msg) {
        if (typeof this.handleFail === "function") {
            this.handleFail(index, msg);
        }
        else {
            toast_1.showToast("Upload Error: [" + index + "]" + msg);
        }
        console.log("Upload Error: [" + index + "]", msg);
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerServiceRequest),
        __metadata("design:type", elmer_ui_core_1.ElmerServiceRequest)
    ], UploadModel.prototype, "service", void 0);
    UploadModel = __decorate([
        elmer_ui_core_1.Injectable("UploadModel")
    ], UploadModel);
    return UploadModel;
}(elmer_common_1.Common));
exports.UploadModel = UploadModel;
