"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminMenuComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var AdminMenuComponent = (function (_super) {
    __extends(AdminMenuComponent, _super);
    function AdminMenuComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            hasTitle: false,
            icon: "fa-bars",
            expandIcon: "fa-bars",
            collapseIcon: "fa-th-list",
            data: [],
            selectedData: null,
            hasExpand: true
        };
        _this.state.hasExpand = props.isExpand;
        _this.state.data = _this.getMenuData(props.data || []);
        _this.state.icon = !props.isExpand ? _this.state.expandIcon : _this.state.collapseIcon;
        _this.state.selectedData = props.selectedData;
        if (_this.state.selectedData && !_this.isEmpty(_this.state.selectedData)) {
            for (var key in _this.state.data) {
                var menuData = _this.state.data[key];
                var isMatched = false;
                if (menuData.items && menuData.items.length > 0) {
                    for (var subKey in menuData.items) {
                        var subMenuData = menuData.items[subKey];
                        if (subMenuData.url === _this.state.selectedData.url) {
                            isMatched = true;
                            break;
                        }
                    }
                }
                if (isMatched) {
                    _this.state.data[key].expand = true;
                    break;
                }
            }
        }
        return _this;
    }
    AdminMenuComponent.prototype.handleOnItemClick = function (evt) {
        var itemData = JSON.parse(JSON.stringify(evt.data.item));
        if (itemData.items && itemData.items.length > 0) {
            if (this.state.hasExpand) {
                var newData = JSON.parse(JSON.stringify(this.state.data));
                itemData.expand = !itemData.expand;
                for (var i = 0, maxLen = newData.length; i < maxLen; i++) {
                    var tmpItem = newData[i];
                    if (tmpItem.id === itemData.id) {
                        newData[i] = itemData;
                        break;
                    }
                }
                this.setState({
                    data: newData
                });
            }
        }
        else {
            this.setState({
                selectedData: itemData
            });
            typeof this.props.onChange === "function" && this.props.onChange({
                data: itemData,
                nativeEvent: evt.nativeEvent,
                target: evt.target
            });
        }
    };
    AdminMenuComponent.prototype.handleOnSubItemClick = function (evt) {
        var itemData = JSON.parse(JSON.stringify(evt.data.subItem));
        this.setState({
            selectedData: itemData
        });
        typeof this.props.onChange === "function" && this.props.onChange({
            data: itemData,
            nativeEvent: evt.nativeEvent,
            target: evt.target
        });
    };
    AdminMenuComponent.prototype.handleOnExpandClick = function (evt) {
        var newStateExpand = !this.state.hasExpand;
        this.setState({
            hasExpand: newStateExpand,
            icon: newStateExpand ? this.state.expandIcon : this.state.collapseIcon
        });
        typeof this.props.onModeChange === "function" && this.props.onModeChange({
            data: newStateExpand,
            nativeEvent: evt.nativeEvent,
            target: evt.target
        });
    };
    AdminMenuComponent.prototype.$onPropsChanged = function (props) {
        var updateState = {};
        var hasChangeValue = false;
        if (JSON.stringify(props.data) !== JSON.stringify(this.state.data)) {
            updateState.data = this.getMenuData(props.data || []);
            hasChangeValue = true;
        }
        if (props.isExpand !== this.state.hasExpand) {
            updateState.hasExpand = props.isExpand;
            updateState.icon = props.isExpand ? this.state.expandIcon : this.state.collapseIcon;
            hasChangeValue = true;
        }
        hasChangeValue && this.setState(updateState);
    };
    AdminMenuComponent.prototype.handleOnClick = function (evt) {
        evt.data = this.props.data;
        typeof this.props.onClick === "function" && this.props.onClick(evt);
    };
    AdminMenuComponent.prototype.render = function () {
        return require("./index.html");
    };
    AdminMenuComponent.prototype.getMenuData = function (menuData) {
        var menu = menuData || [];
        var mLen = menu.length;
        for (var i = 0; i < mLen; i++) {
            var menuItem = menu[i];
            if (this.isEmpty(menuItem.id)) {
                menu[i].id = "menu" + i;
            }
            if (menuItem.items && menuItem.items.length > 0) {
                for (var j = 0, subLen = menuItem.items.length; j < subLen; j++) {
                    var subItem = menuItem.items[j];
                    if (this.isEmpty(subItem.id)) {
                        menu[i].items[j].id = "subMenu" + i + j;
                    }
                }
            }
        }
        return menu;
    };
    AdminMenuComponent.propType = {
        disabled: {
            defaultValue: false,
            description: "是否可用",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        isExpand: {
            defaultValue: true,
            description: "是否显示按钮图标",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        style: {
            defaultValue: " ",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        onChange: {
            description: "单击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onClick: {
            description: "单击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onModeChange: {
            description: "菜单类型切换",
            rule: elmer_ui_core_1.propTypes.func
        },
        data: {
            description: "临时存储的数据",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        selectedData: {
            description: "默认选择菜单项",
            rule: elmer_ui_core_1.propTypes.object
        }
    };
    AdminMenuComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "adminMenu"
        }),
        __metadata("design:paramtypes", [Object])
    ], AdminMenuComponent);
    return AdminMenuComponent;
}(elmer_ui_core_1.Component));
exports.AdminMenuComponent = AdminMenuComponent;
