"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminTopMenuComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var AdminTopMenuComponent = (function (_super) {
    __extends(AdminTopMenuComponent, _super);
    function AdminTopMenuComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            hasTitle: false,
            icon: "fa-bars",
            expandIcon: "fa-bars",
            collapseIcon: "fa-th-list",
            data: [],
            selectedData: null,
            hasExpand: true
        };
        _this.state.hasTitle = !_this.isEmpty(props.title);
        _this.state.data = _this.getMenuData(props.data || []);
        _this.state.icon = props.hasExpand ? _this.state.expandIcon : _this.state.collapseIcon;
        return _this;
    }
    AdminTopMenuComponent.prototype.handleOnItemClick = function (evt) {
        var itemData = JSON.parse(JSON.stringify(evt.data.item));
        if (itemData.items && itemData.items.length > 0) {
            if (this.state.hasExpand) {
                var newData = JSON.parse(JSON.stringify(this.state.data));
                itemData.expand = !itemData.expand;
                for (var i = 0, maxLen = newData.length; i < maxLen; i++) {
                    var tmpItem = newData[i];
                    if (tmpItem.id === itemData.id) {
                        newData[i] = itemData;
                        break;
                    }
                }
                this.setState({
                    data: newData
                });
            }
        }
        else {
            typeof this.props.onChange === "function" && this.props.onChange({
                data: itemData,
                nativeEvent: evt.nativeEvent,
                target: evt.target
            });
        }
    };
    AdminTopMenuComponent.prototype.handleOnSubItemClick = function (evt) {
        var itemData = JSON.parse(JSON.stringify(evt.data.subItem));
        typeof this.props.onChange === "function" && this.props.onChange({
            data: itemData,
            nativeEvent: evt.nativeEvent,
            target: evt.target
        });
    };
    AdminTopMenuComponent.prototype.render = function () {
        return require("./index.html");
    };
    AdminTopMenuComponent.prototype.getMenuData = function (menuData) {
        var menu = menuData || [];
        var mLen = menu.length;
        for (var i = 0; i < mLen; i++) {
            var menuItem = menu[i];
            if (this.isEmpty(menuItem.id)) {
                menu[i].id = "menu" + i;
            }
            if (menuItem.items && menuItem.items.length > 0) {
                for (var j = 0, subLen = menuItem.items.length; j < subLen; j++) {
                    var subItem = menuItem.items[j];
                    if (this.isEmpty(subItem.id)) {
                        menu[i].items[j].id = "subMenu" + i + j;
                    }
                }
            }
        }
        return menu;
    };
    AdminTopMenuComponent.propType = {
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        isExpand: {
            defaultValue: true,
            description: "是否显示按钮图标",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        style: {
            defaultValue: " ",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        onChange: {
            description: "单击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        data: {
            description: "临时存储的数据",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        logoText: {
            defaultValue: "后台管理系统",
            description: "logo文本",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        logoImage: {
            defaultValue: "./assets/logo.png",
            description: "logo图片",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        showLogoImage: {
            defaultValue: true,
            description: "logo显示图片还是文本",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        }
    };
    AdminTopMenuComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "adminTopMenu"
        }),
        __metadata("design:paramtypes", [Object])
    ], AdminTopMenuComponent);
    return AdminTopMenuComponent;
}(elmer_ui_core_1.Component));
exports.AdminTopMenuComponent = AdminTopMenuComponent;
