"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ButtonComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var ButtonComponent = (function (_super) {
    __extends(ButtonComponent, _super);
    function ButtonComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            hasTitle: false,
            buttonType: "button"
        };
        _this.state.hasTitle = !_this.isEmpty(props.title);
        if (!_this.isEmpty(props.type)) {
            _this.state.buttonType = props.type;
        }
        return _this;
    }
    ButtonComponent.prototype.$onPropsChanged = function (newProps) {
        this.setState({
            hasTitle: !this.isEmpty(newProps.title)
        }, true);
    };
    ButtonComponent.prototype.handleOnClick = function (evt) {
        if (!evt.data) {
            evt.data = this.props.data;
        }
        else if (this.props.data) {
            evt.data = __assign(__assign({}, evt.data), this.props.data);
        }
        typeof this.props.onClick === "function" && this.props.onClick(evt);
    };
    ButtonComponent.prototype.render = function () {
        return require("./index.html");
    };
    ButtonComponent.propType = {
        disabled: {
            defaultValue: false,
            description: "是否可用",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        theme: {
            defaultValue: "eui-button-default",
            description: "按钮样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        title: {
            defaultValue: "",
            description: "按钮标题",
            rule: elmer_ui_core_1.propTypes.string
        },
        icon: {
            defaultValue: "",
            description: "按钮图标样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        hasIcon: {
            defaultValue: false,
            description: "是否显示按钮图标",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        type: {
            defaultValue: "button",
            description: "按钮类型",
            rule: elmer_ui_core_1.propTypes.string
        },
        style: {
            defaultValue: " ",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        loading: {
            defaultValue: false,
            description: "是否显示loading",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        onClick: {
            description: "单击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        data: {
            description: "临时存储的数据",
            rule: elmer_ui_core_1.propTypes.any
        }
    };
    ButtonComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "button"
        }),
        __metadata("design:paramtypes", [Object])
    ], ButtonComponent);
    return ButtonComponent;
}(elmer_ui_core_1.Component));
exports.ButtonComponent = ButtonComponent;
