import { Component, IElmerEvent } from "elmer-ui-core";
import "./style/index.less";
export interface ICalendarDate {
    text?: string;
    value?: string | number;
    year?: string | number;
    month?: string | number;
    date?: string | number;
    week?: number;
    disabled?: boolean;
    theme?: string;
    checked?: boolean;
    isToday?: boolean;
}
export interface ICalendarWeek {
    data: ICalendarDate[];
    index: string;
}
export declare enum EnumCalendarSelectMode {
    Single = "Single",
    Multiple = "Multiple",
    Range = "Range"
}
export declare class CalendarComponent extends Component {
    static propType: any;
    props: any;
    style: string;
    week: string;
    year: string;
    month: string;
    date: string;
    allWeekTitle: any[];
    monthText: string[];
    todayText: string;
    selectText: string;
    todayTheme: string;
    selectedTheme: string;
    selectedDate: string[];
    nextDate: Date;
    nextMonthData: ICalendarWeek[];
    nextStyle: string;
    nextAnimation: string;
    nextMonthText: string;
    nextID: string;
    currentID: string;
    currentMonthData: ICalendarWeek[];
    currentDate: Date;
    currentAnimation: string;
    currentStyle: string;
    isAnimation: boolean;
    selectMode: string;
    state: any;
    timeID: string;
    timeHourID: string;
    timeMinuteID: string;
    showTimePicker: boolean;
    private $;
    constructor(props: any);
    $onPropsChanged(newProps: any): void;
    $after(): void;
    handleOnBodyClick(): void;
    onCalendarClick(evt: IElmerEvent): void;
    handleOnCurrentAnimationEnd(): void;
    render(): string;
    handleOnToPrevMonth(evt: IElmerEvent): void;
    handleOnToNextMonth(evt: IElmerEvent): void;
    handleOnCalendarClick(evt: IElmerEvent): void;
    handleOnTimeHourClick(): void;
    handleOnTimeMinuteClick(): void;
    handleOnTimeHourListItemClick(evt: IElmerEvent): void;
    handleOnTimeMinuteListItemClick(evt: IElmerEvent): void;
    getData(): any[];
    private checkSelectedDateStatus;
    private calcCalendarData;
    private getPrevMonthData;
    private getNextMonthData;
    private checkDateStatus;
    private getTimeListData;
    private handleOnTimeDomAnimationEnd;
}
