"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalendarComponent = exports.EnumCalendarSelectMode = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./style/index.less");
var EnumCalendarSelectMode;
(function (EnumCalendarSelectMode) {
    EnumCalendarSelectMode["Single"] = "Single";
    EnumCalendarSelectMode["Multiple"] = "Multiple";
    EnumCalendarSelectMode["Range"] = "Range";
})(EnumCalendarSelectMode = exports.EnumCalendarSelectMode || (exports.EnumCalendarSelectMode = {}));
var CalendarComponent = (function (_super) {
    __extends(CalendarComponent, _super);
    function CalendarComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.style = "";
        _this.week = "Monday";
        _this.year = "2019";
        _this.month = "";
        _this.date = "7";
        _this.allWeekTitle = [
            { title: "Sun", value: "Sun" },
            { title: "Mon", value: "Mon" },
            { title: "Tue", value: "Tue" },
            { title: "Wed", value: "Wed" },
            { title: "Thu", value: "Thu" },
            { title: "Fri", value: "Fri" },
            { title: "Sat", value: "Sat" }
        ];
        _this.monthText = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
        _this.todayText = "Today";
        _this.selectText = "Select";
        _this.todayTheme = "eui-calendar-today";
        _this.selectedTheme = "eui-calendar-checked";
        _this.selectedDate = [];
        _this.nextMonthData = [];
        _this.nextStyle = "left: 100%;";
        _this.nextAnimation = "";
        _this.nextMonthText = "";
        _this.nextID = _this.getRandomID();
        _this.currentID = _this.getRandomID();
        _this.currentMonthData = [];
        _this.currentAnimation = "";
        _this.currentStyle = "";
        _this.isAnimation = false;
        _this.selectMode = EnumCalendarSelectMode.Single;
        _this.state = {
            choseTimeTitle: "",
            choseHourListData: [],
            choseMinuteListData: [],
            choseHour: "",
            choseMinute: "",
            timeAnimation: ""
        };
        _this.timeID = _this.getRandomID();
        _this.timeHourID = _this.getRandomID();
        _this.timeMinuteID = _this.getRandomID();
        _this.showTimePicker = false;
        var now = new Date();
        var hour = now.getHours();
        var minute = now.getMinutes();
        _this.currentDate = props.date;
        _this.style = !_this.isEmpty(props.style) ? props.style : "";
        _this.currentMonthData = _this.calcCalendarData(_this.currentDate);
        _this.selectedDate = props.selectedDate || [];
        if (props.weekendTitle && props.weekendTitle.length > 0) {
            _this.allWeekTitle = props.weekendTitle;
        }
        if (props.monthTitle && props.monthTitle.length > 0) {
            _this.monthText = props.monthTitle;
        }
        _this.state.choseHour = hour > 9 ? hour.toString() : "0" + hour;
        _this.state.choseMinute = minute > 9 ? minute.toString() : "0" + minute;
        _this.state.choseTimeTitle = props.choseTimeTitle;
        _this.state.choseHourListData = _this.getTimeListData(24);
        _this.state.choseMinuteListData = _this.getTimeListData(60);
        _this.todayText = !_this.isEmpty(props.tagTodayText) ? props.tagTodayText : "Today";
        _this.selectText = !_this.isEmpty(props.tagSelectText) ? props.tagSelectText : "Select";
        _this.month = _this.monthText[_this.currentDate.getMonth()];
        _this.showTimePicker = props.selectMode === EnumCalendarSelectMode.Single && props.showTimePicker;
        return _this;
    }
    CalendarComponent.prototype.$onPropsChanged = function (newProps) {
        var updateData = {
            currentDate: newProps.date || (new Date()),
            currentMonthData: this.calcCalendarData(newProps.date || (new Date())),
            showTimePicker: newProps.selectMode === EnumCalendarSelectMode.Single && newProps.showTimePicker
        };
        if (newProps.weekendTitle && newProps.weekendTitle.length > 0) {
            updateData.allWeekTitle = newProps.weekendTitle;
        }
        if (newProps.monthTitle && newProps.monthTitle.length > 0) {
            updateData.monthText = newProps.monthTitle;
        }
        if (!this.isEmpty(newProps.tagTodayText)) {
            updateData.todayText = newProps.tagTodayText;
        }
        if (!this.isEmpty(newProps.tagSelectText)) {
            updateData.selectText = newProps.tagSelectText;
        }
        if (!this.isEmpty(newProps.style)) {
            updateData.style = newProps.style || "";
        }
        if (this.isArray(newProps.selectedDate)) {
            updateData.selectedDate = newProps.selectedDate;
        }
        this.setData(updateData, true);
    };
    CalendarComponent.prototype.$after = function () {
        this.addEvent(this, document.body, "click", this.handleOnBodyClick);
    };
    CalendarComponent.prototype.handleOnBodyClick = function () {
        typeof this.props.onOutClick === "function" && this.props.onOutClick();
    };
    CalendarComponent.prototype.onCalendarClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
    };
    CalendarComponent.prototype.handleOnCurrentAnimationEnd = function () {
        var currentStyle = "left: 0;transform:translateX(0);-webkit-transform:translateX(0);-moz-transform:translateX(0);-ms-transform:translateX(0);";
        var nextStyle = "left: 100%;transform:translateX(0);-webkit-transform:translateX(0);-moz-transform:translateX(0);-ms-transform:translateX(0);";
        this.setData({
            currentAnimation: "",
            currentStyle: currentStyle,
            nextAnimation: "",
            nextStyle: nextStyle,
            currentMonthData: this.calcCalendarData(this.currentDate),
            year: this.currentDate.getFullYear(),
            month: this.monthText[this.currentDate.getMonth()],
            isAnimation: false
        });
    };
    CalendarComponent.prototype.render = function () {
        return require("./views/index.html");
    };
    CalendarComponent.prototype.handleOnToPrevMonth = function (evt) {
        if (!this.isAnimation) {
            var curDate = new Date(this.currentDate.toDateString());
            curDate.setMonth(curDate.getMonth() - 1);
            var data = this.calcCalendarData(curDate);
            var nextStyle = "left: 0;transform:translateX(-100%);-webkit-transform:translateX(-100%);-moz-transform:translateX(-100%);-ms-transform:translateX(-100%);";
            this.setData({
                currentDate: curDate,
                nextMonthData: data,
                nextMonthText: this.monthText[curDate.getMonth()],
                currentAnimation: "aniCalendarToPrev1",
                nextAnimation: "aniCalendarToPrev2",
                nextStyle: nextStyle,
                isAnimation: true
            });
        }
    };
    CalendarComponent.prototype.handleOnToNextMonth = function (evt) {
        if (!this.isAnimation) {
            var curDate = new Date(this.currentDate.toDateString());
            curDate.setMonth(curDate.getMonth() + 1);
            var data = this.calcCalendarData(curDate);
            var nextStyle = "left: 100%;transform:translateX(0);-webkit-transform:translateX(0);-moz-transform:translateX(0);-ms-transform:translateX(0);";
            this.setData({
                currentDate: curDate,
                nextMonthData: data,
                nextMonthText: this.monthText[curDate.getMonth()],
                currentAnimation: "aniCalendarToNext1",
                nextAnimation: "aniCalendarToNext2",
                isAnimation: true,
                nextStyle: nextStyle
            });
        }
    };
    CalendarComponent.prototype.handleOnCalendarClick = function (evt) {
        var date = evt.data.curDate;
        var dateValue = date.value;
        var selectedData = this.selectedDate || [];
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        if (this.props.selectMode !== EnumCalendarSelectMode.Single) {
            if (!date.disabled) {
                var dateIndex = selectedData.indexOf(dateValue);
                if (dateIndex >= 0) {
                    selectedData.splice(dateIndex, 1);
                }
                else {
                    selectedData.push(dateValue);
                }
                this.checkSelectedDateStatus("currentMonthData");
            }
        }
        else {
            this.selectedDate = [dateValue];
            this.checkSelectedDateStatus("currentMonthData");
            if (!this.props.showTimePicker) {
                typeof this.props.onChange === "function" && this.props.onChange(this.selectedDate);
            }
        }
        typeof this.props.onClick === "function" && this.props.onClick();
    };
    CalendarComponent.prototype.handleOnTimeHourClick = function () {
        if (this.isEmpty(this.state.timeAnimation)) {
            this.setState({
                timeAnimation: "aniCalendarTimeShow"
            });
        }
        else {
            this.setState({
                timeAnimation: ""
            });
        }
    };
    CalendarComponent.prototype.handleOnTimeMinuteClick = function () {
        if (this.isEmpty(this.state.timeAnimation)) {
            this.setState({
                timeAnimation: "aniCalendarTimeShow"
            });
        }
        else {
            this.setState({
                timeAnimation: ""
            });
        }
    };
    CalendarComponent.prototype.handleOnTimeHourListItemClick = function (evt) {
        this.setState({
            choseHour: evt.data.time.value
        });
    };
    CalendarComponent.prototype.handleOnTimeMinuteListItemClick = function (evt) {
        var minute = evt.data.time.value;
        if (this.props.selectMode === EnumCalendarSelectMode.Single) {
            if (this.selectedDate.length > 0) {
                var selectedDate = this.selectedDate[0];
                var time = this.state.choseHour + ":" + minute + ":00";
                var result = selectedDate + " " + time;
                this.selectedDate = [result];
                typeof this.props.onChange === "function" && this.props.onChange([result]);
            }
        }
        this.setState({
            choseMinute: evt.data.time.value,
            timeAnimation: ""
        });
    };
    CalendarComponent.prototype.getData = function () {
        return this.selectedDate;
    };
    CalendarComponent.prototype.checkSelectedDateStatus = function (checkListKey, returnData) {
        var _this = this;
        var checkData = this.isArray(this[checkListKey]) ? this[checkListKey] : [];
        checkData.map(function (tmpWeek, weekIndex) {
            tmpWeek.data.map(function (tmpDate, dateIndex) {
                if (_this.selectedDate.indexOf(tmpDate.value.toString()) >= 0) {
                    checkData[weekIndex].data[dateIndex].checked = true;
                    checkData[weekIndex].data[dateIndex].theme = _this.selectedTheme;
                }
                else {
                    checkData[weekIndex].data[dateIndex].checked = false;
                    checkData[weekIndex].data[dateIndex].theme = tmpDate.isToday ? _this.todayTheme : "";
                }
            });
        });
        if (!returnData) {
            var updateData = {};
            updateData[checkListKey] = checkData;
            this.setData(updateData, true);
        }
        return checkData;
    };
    CalendarComponent.prototype.calcCalendarData = function (updateDate) {
        var rows = 6;
        var cols = 7;
        var curDate = this.getType(updateDate) === "[object Date]" ? updateDate : new Date();
        var year = curDate.getFullYear(), month = curDate.getMonth();
        var firstDateText = [year, month + 1, "1"].join("/");
        var firstDate = new Date(firstDateText);
        var firstWeek = firstDate.getDay();
        var resultData = [];
        var dateCount = 30, checkIndex = 0, startIndex = 0;
        firstDate.setMonth(month + 1);
        firstDate.setDate(0);
        dateCount = firstDate.getDate();
        for (var i = 0; i < rows; i++) {
            var tmpRowData = {
                data: [],
                index: i.toString()
            };
            for (var j = 0; j < cols; j++) {
                if (checkIndex >= firstWeek && startIndex < dateCount) {
                    var curDateValue = (checkIndex - firstWeek + 1);
                    var curDateMonth = month + 1;
                    curDateMonth = curDateMonth > 9 ? curDateMonth : "0" + curDateMonth;
                    var dateStr = [year, curDateMonth, (curDateValue > 9 ? curDateValue : "0" + curDateValue)].join("/");
                    var checkStatus = this.checkDateStatus(new Date(dateStr), dateStr);
                    tmpRowData.data.push({
                        theme: checkStatus.theme,
                        value: dateStr,
                        text: curDateValue.toString(),
                        year: year,
                        month: parseInt(curDateMonth.toString(), 10),
                        date: parseInt(curDateValue.toString(), 10),
                        week: j,
                        disabled: false,
                        isToday: checkStatus.isToday
                    });
                    startIndex += 1;
                }
                else {
                    if (checkIndex < firstWeek) {
                        var prevDate = this.getPrevMonthData(new Date(firstDateText), checkIndex - firstWeek);
                        prevDate.disabled = true;
                        tmpRowData.data.push(prevDate);
                    }
                    else {
                        var nextDate = this.getNextMonthData(new Date(firstDateText), checkIndex - startIndex - firstWeek + 1);
                        nextDate.disabled = true;
                        tmpRowData.data.push(nextDate);
                    }
                }
                checkIndex += 1;
            }
            resultData.push(tmpRowData);
        }
        return resultData;
    };
    CalendarComponent.prototype.getPrevMonthData = function (curDate, effectValue) {
        curDate.setDate(1);
        var prevDate = new Date();
        prevDate.setTime(curDate.getTime());
        prevDate.setDate(prevDate.getDate() + effectValue);
        var month = prevDate.getMonth() + 1;
        var year = prevDate.getFullYear();
        var date = prevDate.getDate();
        date = date > 9 ? date.toString() : "0" + date;
        var dateStr = [year, (month > 9 ? month : "0" + month), date].join("/");
        var checkStatus = this.checkDateStatus(new Date(dateStr), dateStr);
        return {
            theme: checkStatus.theme,
            value: dateStr,
            text: date,
            year: year,
            month: month,
            date: parseInt(date, 10),
            week: (new Date([year, month, date].join("/"))).getDay(),
            isToday: checkStatus.isToday
        };
    };
    CalendarComponent.prototype.getNextMonthData = function (curDate, effectValue) {
        var nextDate = new Date();
        nextDate.setTime(curDate.getTime());
        nextDate.setMonth(nextDate.getMonth() + 1);
        nextDate.setDate(0);
        nextDate.setDate(nextDate.getDate() + effectValue);
        var year = nextDate.getFullYear();
        var month = nextDate.getMonth() + 1;
        var date = nextDate.getDate();
        var dateStr = [year, (month > 9 ? month : "0" + month), (date > 9 ? date : "0" + date)].join("/");
        var checkStatus = this.checkDateStatus(new Date(dateStr), dateStr);
        return {
            theme: checkStatus.theme,
            value: dateStr,
            text: effectValue.toString(),
            year: year,
            month: month,
            date: effectValue,
            week: (new Date(dateStr)).getDay(),
            isToday: checkStatus.isToday
        };
    };
    CalendarComponent.prototype.checkDateStatus = function (checkDate, dateStr) {
        var now = new Date();
        var result = {
            theme: "",
            isToday: false
        };
        if (now.getFullYear() === checkDate.getFullYear() && now.getMonth() === checkDate.getMonth() && now.getDate() === checkDate.getDate()) {
            result.theme = this.todayTheme;
            result.isToday = true;
        }
        if (this.selectedDate.indexOf(dateStr) >= 0) {
            result.theme = this.selectedTheme;
        }
        return result;
    };
    CalendarComponent.prototype.getTimeListData = function (maxValue) {
        if (maxValue === void 0) { maxValue = 12; }
        var maxI = maxValue > 0 ? maxValue : 12;
        var result = [];
        for (var i = 1; i <= maxI; i++) {
            result.push({
                value: i < 10 ? "0" + i : i.toString()
            });
        }
        result[result.length - 1] = {
            value: "00"
        };
        return result;
    };
    CalendarComponent.prototype.handleOnTimeDomAnimationEnd = function () {
        if (!this.isEmpty(this.state.timeAnimation)) {
            var hourDom = this.dom[this.timeHourID];
            var minuteDom = this.dom[this.timeMinuteID];
            var hourActiveDom = this.$.find(hourDom, ".active")[0];
            var minuteActiveDom = this.$.find(minuteDom, ".active")[0];
            if (hourActiveDom && hourDom.scrollTop < 10) {
                var cHeight = hourActiveDom.clientHeight;
                var key = hourActiveDom.getAttribute("data-key");
                key = this.isNumeric(key) ? parseInt(key, 10) : 0;
                hourDom.scroll({
                    top: cHeight * key
                });
            }
            if (minuteActiveDom && minuteDom.scrollTop < 10) {
                var cHeight = minuteActiveDom.clientHeight;
                var key = minuteActiveDom.getAttribute("data-key");
                key = this.isNumeric(key) ? parseInt(key, 10) : 0;
                minuteDom.scroll({
                    top: cHeight * key
                });
            }
        }
    };
    CalendarComponent.propType = {
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        style: {
            defaultValue: "",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        date: {
            defaultValue: new Date(),
            description: "当前日期",
            rule: elmer_ui_core_1.propTypes.date.isRequired
        },
        showTimePicker: {
            defaultValue: false,
            description: "显示时间选择",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        weekendTitle: {
            defaultValue: [],
            description: "星期几标题",
            rule: elmer_ui_core_1.propTypes.array
        },
        monthTitle: {
            defaultValue: [],
            description: "月份标题",
            rule: elmer_ui_core_1.propTypes.array
        },
        tagTodayText: {
            defaultValue: "Today",
            description: "今日标签文本",
            rule: elmer_ui_core_1.propTypes.string
        },
        tagSelectText: {
            defaultValue: "Select",
            description: "选择标签文本",
            rule: elmer_ui_core_1.propTypes.string
        },
        selectMode: {
            defaultValue: EnumCalendarSelectMode.Single,
            description: "选择标签文本",
            rule: elmer_ui_core_1.propTypes.oneValueOf([EnumCalendarSelectMode.Single, EnumCalendarSelectMode.Multiple, EnumCalendarSelectMode.Range])
        },
        selectedDate: {
            defaultValue: [],
            description: "选择的日期",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        choseTimeTitle: {
            defaultValue: "Chose Time",
            description: "选择时间标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        onOutClick: {
            description: "日历外点击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onChange: {
            description: "选择变化事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onClick: {
            description: "点击事件",
            rule: elmer_ui_core_1.propTypes.func
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], CalendarComponent.prototype, "$", void 0);
    CalendarComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "calendar"
        }),
        __metadata("design:paramtypes", [Object])
    ], CalendarComponent);
    return CalendarComponent;
}(elmer_ui_core_1.Component));
exports.CalendarComponent = CalendarComponent;
