"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var Checkbox = (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            checked: false,
            showTitle: false,
            title: "",
            className: ""
        };
        _this.state.checked = props.checked;
        _this.state.showTitle = props.showTitle;
        _this.state.title = props.title;
        _this.state.className = props.className;
        return _this;
    }
    Checkbox.prototype.$onPropsChanged = function (props) {
        this.setState({
            checked: props.checked,
            title: props.title,
            showTitle: props.showTitle,
            className: props.className
        });
    };
    Checkbox.prototype.onCheckedChange = function (evt) {
        var _this = this;
        var input = evt.target;
        var checkedValue = input.checked;
        this.setState({
            checked: checkedValue
        });
        var dataSet = {};
        Object.keys(this.props).map(function (attrKey) {
            if (/^data\-/i.test(attrKey)) {
                var dataKeyValue = attrKey.replace(/^data\-/i, "");
                dataSet[dataKeyValue] = _this.props[attrKey];
            }
        });
        typeof this.props.onChange === "function" && this.props.onChange({
            checked: checkedValue,
            data: dataSet
        });
    };
    Checkbox.prototype.render = function () {
        return require("./index.html");
    };
    Checkbox.propType = {
        title: {
            description: "标题",
            rule: elmer_ui_core_1.PropTypes.string
        },
        checked: {
            description: "是否选中",
            defaultValue: true,
            rule: elmer_ui_core_1.PropTypes.bool
        },
        showTitle: {
            description: "是否显示标题",
            defaultValue: true,
            rule: elmer_ui_core_1.PropTypes.bool
        },
        className: {
            description: "样式",
            defaultValue: "",
            rule: elmer_ui_core_1.PropTypes.string
        },
        onChange: {
            description: "状态改变事件",
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    Checkbox = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "checkbox"
        }),
        __metadata("design:paramtypes", [Object])
    ], Checkbox);
    return Checkbox;
}(elmer_ui_core_1.Component));
exports.default = Checkbox;
