import { Component, IElmerEvent, IElmerMouseEvent, IElmerTouchEvent, IPropCheckRule } from "elmer-ui-core";
import "./index.less";
declare type TypeColorPickerProps = {
    style: string;
    className: string;
    confirmText: string;
    cancelText: string;
    onConfirm: Function;
    onCancel: Function;
};
declare type TypeColorPickerPropsRule = {
    [P in keyof TypeColorPickerProps]: IPropCheckRule;
};
declare type TypeColorPickerState = {
    color: string;
    choseColor: string;
    choseColorData: TypePointColor;
    indicatorBarTop: string;
    opacity: string | number;
    showRgb: boolean;
    choseResultStyle?: string;
};
declare type TypePointColor = {
    r: number;
    g: number;
    b: number;
    a: number;
    rgba: string;
    rgb: string;
    hex: string;
};
export default class ColorPicker extends Component {
    static propType: TypeColorPickerPropsRule;
    opacityId: string;
    opacityBarId: string;
    pickerId: string;
    indicatorId: string;
    indicatorBarId: string;
    containerId: string;
    choseColorId: string;
    choseResultBackId: string;
    selectAreaId: string;
    selectAreaFocusId: string;
    inputResultId: string;
    inputRId: string;
    inputGId: string;
    inputBId: string;
    inputAId: string;
    state: TypeColorPickerState;
    props: TypeColorPickerProps;
    private rect;
    private selectRect;
    private pickerCanvas;
    private pickerCtv;
    private pickerWidth;
    private pickerHeight;
    private indicatorCanvas;
    private indicatorCtv;
    private indicatorWidth;
    private indicatorHeight;
    private indicatorBar;
    private isIndicatorCanMoved;
    private indicatorY;
    private indicatorTop;
    private isSelectAreaCanMoved;
    private selectAreaPoint;
    private opacityCanvas;
    private opacityCvt;
    private opacityBar;
    private isOpacityCanMoved;
    private opacityY;
    private opacityTop;
    private opacityHeight;
    constructor(props: any);
    onConfirmClick(): void;
    onCancelClick(): void;
    handleOnChangeDisplay(): void;
    handleOnInputResultClick(evt: IElmerEvent): void;
    onOpacityTouchStart(evt: IElmerTouchEvent | IElmerMouseEvent): void;
    onselectAreaStart(evt: IElmerTouchEvent | IElmerMouseEvent): void;
    onIndicatorTouchEnd(): void;
    onIndicatorMove(evt: IElmerTouchEvent | IElmerMouseEvent): void;
    onIndicatorTouchStart(evt: IElmerTouchEvent | IElmerMouseEvent): void;
    onDragstart(evt: IElmerEvent): any;
    onStopReturnValue(evt: IElmerEvent): any;
    $didMount(): void;
    $after(): void;
    private getAreaRect;
    private getSelectArea;
    private isInSelectArea;
    private getSelectOffset;
    private hexify;
    private choseColor;
    private getSelectAreaPoint;
    private isTouchEvent;
    private drawColorArea;
    private drawIndicatorArea;
    private getIndicatorPixelColor;
    private drawOpacityBar;
    private drawGridBk;
}
export {};
