"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var ColorPicker = (function (_super) {
    __extends(ColorPicker, _super);
    function ColorPicker(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            color: "#f6000c",
            choseColor: "#fff",
            choseColorData: {
                r: 245,
                g: 0,
                b: 35,
                a: 1,
                rgba: "rgba(245,0,35,1)",
                rgb: "rgb(245,0,35)",
                hex: "#f6000c"
            },
            indicatorBarTop: "0px",
            opacity: 1,
            showRgb: false,
            choseResultStyle: ""
        };
        _this.isIndicatorCanMoved = false;
        _this.indicatorY = 0;
        _this.indicatorTop = 0;
        _this.isSelectAreaCanMoved = false;
        _this.selectAreaPoint = {
            x: 0,
            y: 0
        };
        _this.isOpacityCanMoved = false;
        _this.opacityY = 0;
        _this.opacityTop = 0;
        _this.pickerId = _this.guid();
        _this.indicatorId = _this.guid();
        _this.indicatorBarId = _this.guid();
        _this.containerId = _this.guid();
        _this.inputRId = _this.guid();
        _this.inputGId = _this.guid();
        _this.inputBId = _this.guid();
        _this.inputAId = _this.guid();
        _this.choseColorId = _this.guid();
        _this.selectAreaId = _this.guid();
        _this.selectAreaFocusId = _this.guid();
        _this.inputResultId = _this.guid();
        _this.opacityId = _this.guid();
        _this.opacityBarId = _this.guid();
        _this.choseResultBackId = _this.guid();
        return _this;
    }
    ColorPicker.prototype.onConfirmClick = function () {
        typeof this.props.onConfirm === "function" && this.props.onConfirm(this.state.choseColorData);
    };
    ColorPicker.prototype.onCancelClick = function () {
        typeof this.props.onCancel === "function" && this.props.onCancel();
    };
    ColorPicker.prototype.handleOnChangeDisplay = function () {
        this.state.showRgb = !this.state.showRgb;
        this.choseColor(this.getIndicatorPixelColor(this.pickerCtv, this.selectAreaPoint.x, this.selectAreaPoint.y));
    };
    ColorPicker.prototype.handleOnInputResultClick = function (evt) {
        var target = evt.target;
        target.setSelectionRange(0, target.value.length);
    };
    ColorPicker.prototype.onOpacityTouchStart = function (evt) {
        if (this.isTouchEvent(evt)) {
            this.opacityY = evt.nativeEvent.touches[0].clientY;
        }
        else {
            this.opacityY = evt.nativeEvent.clientY;
        }
        this.isOpacityCanMoved = true;
    };
    ColorPicker.prototype.onselectAreaStart = function (evt) {
        var point;
        if (this.isTouchEvent(evt)) {
            point = {
                x: evt.nativeEvent.touches[0].clientX,
                y: evt.nativeEvent.touches[0].clientY
            };
        }
        else {
            point = {
                x: evt.nativeEvent.clientX,
                y: evt.nativeEvent.clientY
            };
        }
        if (this.isInSelectArea(point.x, point.y)) {
            var rect = this.getAreaRect();
            var offsetSize = this.getSelectOffset();
            this.selectAreaPoint = {
                x: point.x - rect.left - offsetSize.offsetLeft,
                y: point.y - rect.top - offsetSize.offsetTop
            };
            this.isSelectAreaCanMoved = true;
            this.choseColor(this.getIndicatorPixelColor(this.pickerCtv, this.selectAreaPoint.x, this.selectAreaPoint.y));
            this.drawColorArea();
        }
    };
    ColorPicker.prototype.onIndicatorTouchEnd = function () {
        this.isIndicatorCanMoved = false;
        this.isSelectAreaCanMoved = false;
        this.isOpacityCanMoved = false;
    };
    ColorPicker.prototype.onIndicatorMove = function (evt) {
        var posY = 0;
        if (this.isTouchEvent(evt)) {
            posY = evt.nativeEvent.touches[0].clientY;
        }
        else {
            posY = evt.nativeEvent.clientY;
        }
        evt.nativeEvent.cancelBubble = true;
        if (this.isIndicatorCanMoved) {
            var offsetY = posY - this.indicatorY;
            var offsetTop = this.indicatorTop + offsetY;
            if (offsetTop >= 0 && offsetTop < this.indicatorHeight) {
                this.indicatorBar.style.top = offsetTop + "px";
                this.indicatorTop = offsetTop;
                this.indicatorY = posY;
                this.state.color = this.getIndicatorPixelColor(this.indicatorCtv, 2, offsetTop).rgb;
                this.drawColorArea();
                this.choseColor(this.getIndicatorPixelColor(this.pickerCtv, this.selectAreaPoint.x, this.selectAreaPoint.y));
            }
        }
        if (this.isOpacityCanMoved) {
            var offsetY = posY - this.opacityY;
            var offsetTop = this.opacityTop + offsetY;
            if (offsetTop >= 0 && offsetTop < this.opacityHeight) {
                this.opacityBar.style.top = offsetTop + "px";
                this.opacityTop = offsetTop;
                this.opacityY = posY;
                this.state.opacity = (1 - parseFloat((offsetTop / this.opacityHeight).toFixed(2))).toFixed(2);
                this.choseColor(this.getIndicatorPixelColor(this.pickerCtv, this.selectAreaPoint.x, this.selectAreaPoint.y));
            }
        }
        if (this.isSelectAreaCanMoved) {
            var pos2X = 0, pos2Y = 0;
            if (this.isTouchEvent(evt)) {
                pos2X = evt.nativeEvent.touches[0].clientX;
                pos2Y = evt.nativeEvent.touches[0].clientY;
            }
            else {
                pos2X = evt.nativeEvent.clientX;
                pos2Y = evt.nativeEvent.clientY;
            }
            if (this.isInSelectArea(pos2X, pos2Y)) {
                var rect = this.getAreaRect();
                var offsetSize = this.getSelectOffset();
                this.selectAreaPoint = {
                    x: pos2X - rect.left - offsetSize.offsetLeft,
                    y: pos2Y - rect.top - offsetSize.offsetTop
                };
                this.choseColor(this.getIndicatorPixelColor(this.pickerCtv, this.selectAreaPoint.x, this.selectAreaPoint.y));
                this.drawColorArea();
            }
        }
    };
    ColorPicker.prototype.onIndicatorTouchStart = function (evt) {
        if (this.isTouchEvent(evt)) {
            this.indicatorY = evt.nativeEvent.touches[0].clientY;
        }
        else {
            this.indicatorY = evt.nativeEvent.clientY;
        }
        this.isIndicatorCanMoved = true;
    };
    ColorPicker.prototype.onDragstart = function (evt) {
        evt.nativeEvent.preventDefault();
        return false;
    };
    ColorPicker.prototype.onStopReturnValue = function (evt) {
        evt.nativeEvent.returnValue = false;
        evt.nativeEvent.preventDefault();
        return false;
    };
    ColorPicker.prototype.$didMount = function () {
        var outDiv = this.dom[this.containerId];
        var focusDiv = this.dom[this.selectAreaFocusId];
        this.rect = outDiv.getBoundingClientRect();
        this.pickerCanvas = this.dom[this.pickerId];
        this.pickerCtv = this.pickerCanvas.getContext("2d");
        this.pickerWidth = this.pickerCanvas.clientWidth;
        this.pickerHeight = this.pickerCanvas.clientHeight;
        this.pickerCanvas.width = this.pickerWidth;
        this.pickerCanvas.height = this.pickerHeight;
        this.selectRect = this.dom[this.selectAreaId].getBoundingClientRect();
        this.indicatorCanvas = this.dom[this.indicatorId];
        this.indicatorCtv = this.indicatorCanvas.getContext("2d");
        this.indicatorWidth = this.indicatorCanvas.clientWidth;
        this.indicatorHeight = this.indicatorCanvas.clientHeight;
        this.indicatorCanvas.width = this.indicatorWidth;
        this.indicatorCanvas.height = this.indicatorHeight;
        this.indicatorBar = this.dom[this.indicatorBarId];
        this.opacityCanvas = this.dom[this.opacityId];
        this.opacityCvt = this.opacityCanvas.getContext("2d");
        this.opacityBar = this.dom[this.opacityBarId];
        this.opacityHeight = this.opacityCanvas.clientHeight;
        this.opacityCanvas.width = this.opacityCanvas.clientWidth;
        this.opacityCanvas.height = this.opacityCanvas.clientHeight;
        this.selectAreaPoint = {
            x: this.selectRect.width - 2 - focusDiv.clientWidth / 2,
            y: 2 + focusDiv.clientHeight / 2
        };
        var dCanvas = this.dom[this.choseResultBackId];
        var cvt = dCanvas.getContext("2d");
        dCanvas.width = dCanvas.clientWidth;
        dCanvas.height = dCanvas.clientHeight;
        this.drawGridBk(cvt, dCanvas.clientWidth, dCanvas.clientHeight);
        this.drawColorArea();
        this.drawIndicatorArea();
        this.drawOpacityBar();
    };
    ColorPicker.prototype.$after = function () {
        this.addEvent(this, document.body, "touchend", this.onIndicatorTouchEnd.bind(this), {
            passive: false
        });
        this.addEvent(this, document.body, "mouseup", this.onIndicatorTouchEnd.bind(this), {
            passive: false
        });
    };
    ColorPicker.prototype.getAreaRect = function () {
        return this.dom[this.containerId].getBoundingClientRect();
    };
    ColorPicker.prototype.getSelectArea = function () {
        return this.dom[this.selectAreaId].getBoundingClientRect();
    };
    ColorPicker.prototype.isInSelectArea = function (x, y) {
        this.selectRect = this.getSelectArea();
        return x >= this.selectRect.left && x < this.selectRect.right && y >= this.selectRect.top && y < this.selectRect.bottom;
    };
    ColorPicker.prototype.getSelectOffset = function () {
        var outDiv = this.dom[this.containerId];
        var selectDiv = this.dom[this.selectAreaId];
        var outOffsetWidth = outDiv.offsetWidth - outDiv.clientWidth;
        var outOffsetHeight = outDiv.offsetHeight - outDiv.clientHeight;
        var offsetLeft = outDiv.children[0].offsetLeft;
        var offsetTop = outDiv.children[0].offsetTop;
        var borderWidth = outOffsetWidth / 2;
        return {
            offsetLeft: borderWidth + offsetLeft,
            offsetTop: outOffsetHeight / 2 + offsetTop
        };
    };
    ColorPicker.prototype.hexify = function (color) {
        var values = color
            .replace(/rgba?\(/, "")
            .replace(/\)/, "")
            .replace(/[\s+]/g, "")
            .split(",");
        var a = parseFloat(values[3] || "1"), r = Math.floor(a * parseInt(values[0], 10) + (1 - a) * 255), g = Math.floor(a * parseInt(values[1], 10) + (1 - a) * 255), b = Math.floor(a * parseInt(values[2], 10) + (1 - a) * 255);
        return "#" +
            ("0" + r.toString(16)).slice(-2) +
            ("0" + g.toString(16)).slice(-2) +
            ("0" + b.toString(16)).slice(-2);
    };
    ColorPicker.prototype.choseColor = function (colorResult) {
        var choseOffset = this.dom[this.selectAreaFocusId].offsetWidth / 2 + 1;
        var focusPositionStyle = "left: " + (this.selectAreaPoint.x - choseOffset) + "px;top:" + (this.selectAreaPoint.y - choseOffset) + "px;";
        colorResult.a = parseFloat(this.state.opacity.toString());
        colorResult.rgba = "rgba(" + colorResult.r + ", " + colorResult.g + ", " + colorResult.b + ", " + this.state.opacity + ")";
        if (colorResult.a !== 1) {
            colorResult.hex = this.hexify(colorResult.rgba);
        }
        this.state.choseColor = colorResult.rgba;
        this.state.choseColorData = colorResult;
        this.dom[this.choseColorId].style.background = colorResult.rgba;
        this.dom[this.inputRId].value = colorResult.r;
        this.dom[this.inputGId].value = colorResult.g;
        this.dom[this.inputBId].value = colorResult.b;
        this.dom[this.inputAId].value = colorResult.a;
        this.dom[this.selectAreaFocusId].style = focusPositionStyle;
        this.dom[this.inputResultId].value = this.state.showRgb ? (this.state.opacity < 1 ? colorResult.rgba : colorResult.rgb) : colorResult.hex;
    };
    ColorPicker.prototype.getSelectAreaPoint = function (srcX, srcY) {
        return {
            x: srcX - this.selectRect.left,
            y: srcY - this.selectRect.top
        };
    };
    ColorPicker.prototype.isTouchEvent = function (evt) {
        return evt.nativeEvent.touches;
    };
    ColorPicker.prototype.drawColorArea = function () {
        var cvt = this.pickerCtv;
        cvt.clearRect(0, 0, this.pickerWidth, this.pickerHeight);
        cvt.fillStyle = this.state.color;
        cvt.fillRect(0, 0, this.pickerWidth, this.pickerHeight);
        cvt.fill();
        cvt.save();
        var linearWhite = cvt.createLinearGradient(0, 0, this.pickerWidth, 0);
        linearWhite.addColorStop(0, "rgba(255,255,255,1)");
        linearWhite.addColorStop(1, "transparent");
        cvt.fillStyle = linearWhite;
        cvt.fillRect(0, 0, this.pickerWidth, this.pickerHeight);
        cvt.fill();
        cvt.save();
        var linearBlack = cvt.createLinearGradient(0, this.pickerHeight, 0, 0);
        linearBlack.addColorStop(0, "#000");
        linearBlack.addColorStop(1, "transparent");
        cvt.fillStyle = linearBlack;
        cvt.fillRect(0, 0, this.pickerWidth, this.pickerHeight);
        cvt.fill();
        cvt.save();
    };
    ColorPicker.prototype.drawIndicatorArea = function () {
        var cvt = this.indicatorCtv;
        var linearGradient = cvt.createLinearGradient(0, 0, 0, this.indicatorHeight);
        linearGradient.addColorStop(0, "#ff0108");
        linearGradient.addColorStop(0.125, "#ee02fa");
        linearGradient.addColorStop(0.125 * 2, "purple");
        linearGradient.addColorStop(0.125 * 3, "blue");
        linearGradient.addColorStop(0.125 * 4, "#02faee");
        linearGradient.addColorStop(0.125 * 5, "#02fa13");
        linearGradient.addColorStop(0.125 * 6, "yellow");
        linearGradient.addColorStop(1, "#fa0202");
        cvt.fillStyle = linearGradient;
        cvt.fillRect(0, 0, this.indicatorWidth, this.indicatorHeight);
        cvt.fill();
    };
    ColorPicker.prototype.getIndicatorPixelColor = function (cvt, x, y) {
        var imageData = cvt.getImageData(x, y, 1, 1);
        var pixel = imageData.data;
        var r = pixel[0];
        var g = pixel[1];
        var b = pixel[2];
        var a = pixel[3] / 255;
        a = Math.round(a * 100) / 100;
        var rHex = r.toString(16);
        r < 16 && (rHex = "0" + rHex);
        var gHex = g.toString(16);
        g < 16 && (gHex = "0" + gHex);
        var bHex = b.toString(16);
        b < 16 && (bHex = "0" + bHex);
        var rgbaColor = "rgba(" + r + "," + g + "," + b + "," + a + ")";
        var rgbColor = "rgb(" + r + "," + g + "," + b + ")";
        var hexColor = "#" + rHex + gHex + bHex;
        return {
            rgba: rgbaColor,
            rgb: rgbColor,
            hex: hexColor,
            r: r,
            g: g,
            b: b,
            a: a
        };
    };
    ColorPicker.prototype.drawOpacityBar = function () {
        var width = this.opacityCanvas.clientWidth;
        var height = this.opacityHeight;
        var cvt = this.opacityCvt;
        var linearGradient = cvt.createLinearGradient(0, 0, 0, this.opacityHeight);
        linearGradient.addColorStop(0.2, "#fff");
        linearGradient.addColorStop(1, "rgba(255,255,255,0");
        this.drawGridBk(cvt, width, height);
        cvt.restore();
        cvt.fillStyle = linearGradient;
        cvt.fillRect(0, 0, width, height);
        cvt.fill();
    };
    ColorPicker.prototype.drawGridBk = function (cvt, width, height) {
        var size = 5;
        var rows = Math.ceil(height / size);
        var cols = Math.ceil(width / size);
        for (var i = 0; i < rows; i++) {
            var isMode1 = i % 2 === 0;
            for (var j = 0; j < cols; j++) {
                cvt.beginPath();
                cvt.fillRect(j * size, i * size, size, size);
                if (isMode1) {
                    if (j % 2 === 0) {
                        cvt.fillStyle = "#fff";
                        cvt.fill();
                    }
                    else {
                        cvt.fillStyle = "gray";
                        cvt.fill();
                    }
                }
                else {
                    if (j % 2 !== 0) {
                        cvt.fillStyle = "#fff";
                        cvt.fill();
                    }
                    else {
                        cvt.fillStyle = "gray";
                        cvt.fill();
                    }
                }
                cvt.closePath();
                cvt.save();
            }
        }
    };
    ColorPicker.propType = {
        style: {
            description: "内联样式",
            defaultValue: "",
            rule: elmer_ui_core_1.PropTypes.string
        },
        confirmText: {
            description: "确定按钮文本",
            defaultValue: "确定",
            rule: elmer_ui_core_1.PropTypes.string
        },
        cancelText: {
            description: "取消按钮文本",
            defaultValue: "取消",
            rule: elmer_ui_core_1.PropTypes.string
        },
        className: {
            description: "自定义样式",
            defaultValue: "AniZoomIn",
            rule: elmer_ui_core_1.PropTypes.string
        },
        onConfirm: {
            description: "确定事件回调",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onCancel: {
            description: "取消事件回调",
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    ColorPicker = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "color-picker",
            template: {
                url: "./index.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], ColorPicker);
    return ColorPicker;
}(elmer_ui_core_1.Component));
exports.default = ColorPicker;
