import { Component, IElmerEvent, IPropCheckRule } from "elmer-ui-core";
import "./style/form.less";
declare type AnimationEndType = "ShowForm" | "CloseForm" | "Minimize" | "None" | "Maximize";
export declare type TypeWinFormProps = {
    bottom: string;
    bottomTheme: string;
    icon: string;
    onClose: Function;
    onMin: Function;
    onMax: Function;
    onFocus: Function;
    showBottom: boolean;
    showBarMax: boolean;
    showBarMin: boolean;
    showBarClose: boolean;
    showIcon: boolean;
    maxBarTheme: string;
    theme: string;
    title: string;
    titleTheme: string;
    width: number;
    height: number;
    visible: boolean;
    zIndex: number;
    position: string;
    emit: Function;
};
declare type TypeWinFormPropsRule = {
    [P in keyof TypeWinFormProps]?: IPropCheckRule;
};
declare type TypeWinFormState = {
    [P in Exclude<keyof TypeWinFormProps, "position" | "onFocus" | "onClose" | "onMin" | "onMax">]?: any;
} & {
    showAnimation: string;
    hidenAnimation: string;
    minAnimation: string;
    formAnimation: string;
    formStyle: string;
    showForm?: boolean;
    maxTheme?: string;
    mouseX?: number;
    mouseY?: number;
    isMax?: boolean;
    isMoved?: boolean;
    isPressed?: boolean;
    position?: "fixed" | "absolute";
    formLeft?: number;
    formTop?: number;
    formWidth?: number;
    formHeight?: number;
};
export declare class WinFormComponent extends Component<TypeWinFormProps> {
    static propType: TypeWinFormPropsRule;
    state: TypeWinFormState;
    formID: string;
    maxID: string;
    titleID: string;
    contentID: string;
    bottomID: string;
    formDom: HTMLElement;
    maxDom: HTMLElement;
    titleDom: HTMLElement;
    contentDom: HTMLElement;
    bottomDom: HTMLElement;
    animationEndType: AnimationEndType;
    private $;
    constructor(props: any);
    $onPropsChanged(props: any): void;
    render(): any;
    $didUpdate(): void;
    $didMount(): void;
    onFormClick(): void;
    ontitleBarMouseDown(evt: IElmerEvent): void;
    onMaxClick(evt: IElmerEvent): void;
    onMinClick(evt: IElmerEvent): void;
    btnClose(evt: IElmerEvent): void;
    show(): void;
    getOwnerDom(): HTMLElement;
    private formAnimationEnd;
    private onbodyMouseMove;
    private onbodyMouseUp;
    private getFormSizeStyle;
}
export {};
