"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WinFormComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./style/form.less");
var WinFormComponent = (function (_super) {
    __extends(WinFormComponent, _super);
    function WinFormComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            visible: true,
            showForm: false,
            showAnimation: "AniZoomIn",
            hidenAnimation: "AniZoomOut",
            minAnimation: "AnislideDownOut",
            formAnimation: "",
            formStyle: "opacity: 0;",
            maxTheme: ""
        };
        _this.formID = _this.getRandomID();
        _this.maxID = _this.getRandomID();
        _this.titleID = _this.getRandomID();
        _this.contentID = _this.getRandomID();
        _this.bottomID = _this.getRandomID();
        _this.animationEndType = "None";
        Object.keys(props).map(function (pKey) {
            if (props[pKey] !== undefined) {
                _this.state[pKey] = props[pKey];
            }
        });
        if (!props.showIcon) {
            _this.state.icon = "";
        }
        _this.state.formStyle = _this.getFormSizeStyle(props.zIndex) + "opacity:0;";
        return _this;
    }
    WinFormComponent.prototype.$onPropsChanged = function (props) {
        var updateState = {};
        for (var key in props) {
            if (!this.isFunction(props[key]) && props[key] !== this.state[key]) {
                updateState[key] = props[key];
            }
        }
        if (!props.showIcon) {
            updateState.icon = "";
        }
        if (this.animationEndType === "None") {
            if (props.visible !== this.state.visible) {
                if (props.visible) {
                    this.animationEndType = "ShowForm";
                    this.setState(__assign(__assign({}, updateState), { visible: props.visible, formAnimation: this.state.showAnimation }));
                }
                else {
                    this.animationEndType = "Minimize";
                    this.setData(__assign(__assign({}, updateState), { visible: props.visible, formAnimation: this.state.hidenAnimation }));
                }
                return;
            }
        }
        if (this.state.zIndex !== props.zIndex) {
            if (this.formDom) {
                if (!this.state.isMax) {
                    var nLeft = this.formDom.offsetLeft;
                    var nTop = this.formDom.offsetTop;
                    var formStyle = this.getFormSizeStyle(props.zIndex);
                    this.state.zIndex = props.zIndex;
                    this.setState(__assign(__assign({}, updateState), { formStyle: "left: " + nLeft + "px;top:" + nTop + "px;opacity:1;" + formStyle }));
                }
                else {
                    this.setState(__assign(__assign({}, updateState), { formStyle: "left: 0;top:0;opacity:1;z-index:" + props.zIndex + ";width:100%;height:100%;" }));
                }
            }
        }
    };
    WinFormComponent.prototype.render = function () {
        return require("./views/winForm.html");
    };
    WinFormComponent.prototype.$didUpdate = function () {
        this.addEvent(this, document.body, "mousemove", this.onbodyMouseMove.bind(this));
        this.addEvent(this, document.body, "mouseup", this.onbodyMouseUp.bind(this));
    };
    WinFormComponent.prototype.$didMount = function () {
        this.formDom = this.dom[this.formID];
        this.maxDom = this.dom[this.maxID];
        this.titleDom = this.dom[this.titleID];
        this.contentDom = this.dom[this.contentID];
        this.bottomDom = this.dom[this.bottomID];
        this.show();
    };
    WinFormComponent.prototype.onFormClick = function () {
        typeof this.props.onFocus === "function" && this.props.onFocus();
    };
    WinFormComponent.prototype.ontitleBarMouseDown = function (evt) {
        var thisEvent = evt.nativeEvent;
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.state.mouseX = thisEvent.clientX ? thisEvent.clientX :
            (thisEvent.touches ? thisEvent.touches[0].clientX : 0);
        this.state.mouseY = thisEvent.clientY ? thisEvent.clientY :
            (thisEvent.touches ? thisEvent.touches[0].clientY : 0);
        thisEvent.cancelBubble = true;
        if (!this.state.isMax) {
            this.state.isPressed = true;
        }
    };
    WinFormComponent.prototype.onMaxClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        var formDom = this.dom[this.formID];
        if (!this.state.isMax && formDom) {
            var formStyle = "left: 0;top:0;opacity:1;z-index:" + this.state.zIndex + ";width:100%;height:100%;" + this.state.position + ";";
            this.state.formLeft = formDom.offsetLeft;
            this.state.formTop = formDom.offsetTop;
            this.state.formWidth = formDom.clientWidth;
            this.state.formHeight = formDom.clientHeight;
            this.state.isMax = true;
            this.$.css(formDom, {
                left: 0,
                top: 0,
                width: "100%",
                height: "100%"
            });
            this.setState({
                maxTheme: this.state.maxBarTheme,
                formStyle: formStyle
            });
        }
        else {
            var formSizeStyle = this.getFormSizeStyle();
            var formStyle = "left: " + this.state.formLeft + "px;top:" + this.state.formTop + "px;" + formSizeStyle;
            this.state.isMax = false;
            this.$.css(formDom, {
                left: this.state.formLeft,
                top: this.state.formTop,
                width: this.state.formWidth,
                height: this.state.formHeight
            });
            this.setState({
                maxTheme: "",
                formStyle: formStyle
            });
        }
        typeof this.props.onMax === "function" && this.props.onMax(this.state.isMax);
    };
    WinFormComponent.prototype.onMinClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        var formStyle = this.state.formStyle;
        if (this.state.isMax) {
            formStyle = "left:0;top:0;width:100%;height:100%;z-index:" + this.state.zIndex + ";position:" + this.state.position + ";";
        }
        if (this.$.supportCss3 && !this.isEmpty(this.state.minAnimation)) {
            this.animationEndType = "Minimize";
            this.setState({
                formAnimation: this.state.minAnimation,
                formStyle: formStyle
            });
        }
        else {
            this.setState({
                showForm: false,
                visible: false,
                formStyle: formStyle
            });
            typeof this.props.onMin === "function" && this.props.onMin();
        }
    };
    WinFormComponent.prototype.btnClose = function (evt) {
        if (evt) {
            evt.nativeEvent.cancelBubble = true;
            evt.nativeEvent.stopPropagation();
        }
        if (this.$.supportCss3 && !this.isEmpty(this.state.hidenAnimation)) {
            this.animationEndType = "CloseForm";
            this.setState({
                formAnimation: this.state.hidenAnimation
            });
        }
        else {
            this.setState({
                visible: false,
                showFrom: false
            });
            typeof this.props.onClose === "function" && this.props.onClose();
        }
    };
    WinFormComponent.prototype.show = function () {
        if (this.formDom) {
            var left = this.formDom.style.left || "";
            var top_1 = this.formDom.style.top || "";
            left = left.replace(/[a-z\%]*$/i, "");
            top_1 = top_1.replace(/[a-z\%]*$/i, "");
            if (this.animationEndType === "None") {
                if (!this.isNumeric(left) || !this.isNumeric(top_1) || this.isEmpty(left) || this.isEmpty(top_1)) {
                    var mask = this.getOwnerDom();
                    var maskWidth = mask ? mask.clientWidth : null, maskHeight = mask ? mask.clientHeight : null;
                    var frmWidth = this.formDom.clientWidth;
                    var frmHeight = this.formDom.clientHeight;
                    var winWidth = maskWidth || window.innerWidth;
                    var winHeight = maskHeight || window.innerHeight;
                    var nLeft = (winWidth - frmWidth) / 2;
                    var nTop = (winHeight - frmHeight) / 2;
                    var formStyle = this.getFormSizeStyle();
                    this.animationEndType = "ShowForm";
                    this.setState({
                        formStyle: "left: " + nLeft + "px;top:" + nTop + "px;opacity:1;" + formStyle,
                        formAnimation: this.state.showAnimation
                    });
                }
                else {
                    this.animationEndType = "ShowForm";
                    this.setState({
                        formAnimation: this.state.showAnimation,
                    });
                }
                this.state.visible = true;
                this.state.showForm = true;
            }
        }
    };
    WinFormComponent.prototype.getOwnerDom = function () {
        if (this.state.position === "absolute" && this.formDom) {
            var dom = this.formDom;
            while (dom && dom.parentElement) {
                if (dom.parentElement.style.position !== "relative") {
                    dom = dom.parentElement;
                }
                else {
                    return dom.parentElement;
                }
            }
            return document.body;
        }
        else {
            return document.body;
        }
    };
    WinFormComponent.prototype.formAnimationEnd = function () {
        if (this.animationEndType === "CloseForm") {
            this.setState({
                visible: false,
                showFrom: false
            });
            typeof this.props.onClose === "function" && this.props.onClose();
        }
        else if (this.animationEndType === "Minimize") {
            this.setState({
                visible: false,
                showFrom: false
            });
            typeof this.props.onMin === "function" && this.props.onMin();
        }
        this.animationEndType = "None";
    };
    WinFormComponent.prototype.onbodyMouseMove = function (evt) {
        if (this.state.isPressed && this.formDom && !this.state.isMax) {
            var thisEvent = (window.event || evt);
            var posX = thisEvent.clientX ? thisEvent.clientX :
                (thisEvent.touches ? thisEvent.touches[0].clientX : 0);
            var posY = thisEvent.clientY ? thisEvent.clientY :
                (thisEvent.touches ? thisEvent.touches[0].clientY : 0);
            var formDom = this.formDom;
            var formStyle = this.getFormSizeStyle();
            var left = formDom.offsetLeft, top_2 = formDom.offsetTop, myLeft = left + (posX - this.state.mouseX), myTop = top_2 + (posY - this.state.mouseY);
            this.state.mouseX = posX;
            this.state.mouseY = posY;
            this.$.css(formDom, {
                left: myLeft,
                top: myTop
            });
            this.state.formStyle = "left: " + myLeft + "px;top:" + myTop + "px;opacity:1;" + formStyle;
        }
    };
    WinFormComponent.prototype.onbodyMouseUp = function () {
        this.state.isPressed = false;
    };
    WinFormComponent.prototype.getFormSizeStyle = function (zIndex) {
        var result = "";
        var pWidth = this.state.width;
        var pHeight = this.state.height;
        if (!this.isEmpty(pWidth)) {
            result = pWidth !== "auto" ? (!isNaN(pWidth) ? "width:" + pWidth + "px;" : "width:" + pWidth + ";") : "";
        }
        if (!this.isEmpty(pHeight)) {
            result += pHeight !== "auto" ? (!isNaN(pHeight) ? "height:" + pHeight + "px;" : "height:" + pHeight + ";") : "";
        }
        if (isNaN(zIndex)) {
            if (!this.isEmpty(this.state.zIndex) && !isNaN(this.state.zIndex)) {
                result += "z-index:" + this.state.zIndex + ";";
            }
        }
        else {
            result += "z-index:" + zIndex + ";";
        }
        if (!this.isEmpty(this.state.position)) {
            result += "position:" + this.state.position + ";";
        }
        return result;
    };
    WinFormComponent.propType = {
        bottom: {
            defaultValue: "",
            description: "Set html code to form bottom area",
            rule: elmer_ui_core_1.propTypes.string
        },
        bottomTheme: {
            defaultValue: "",
            description: "Set bottom area theme",
            rule: elmer_ui_core_1.propTypes.string
        },
        icon: {
            defaultValue: "fa fa-list-alt",
            description: "Set form icon",
            rule: elmer_ui_core_1.propTypes.string
        },
        maxBarTheme: {
            defaultValue: "elmerDialogFormTitleBarMaxResize",
            description: "maxBar press theme",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        onClose: {
            description: "form close callback",
            rule: elmer_ui_core_1.propTypes.func
        },
        onMin: {
            description: "on minBar click",
            rule: elmer_ui_core_1.propTypes.func
        },
        onMax: {
            description: "on maxBar click",
            rule: elmer_ui_core_1.propTypes.func
        },
        onFocus: {
            description: "form onfocus",
            rule: elmer_ui_core_1.propTypes.func
        },
        showBottom: {
            defaultValue: false,
            description: "Set bottom area visible",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        showBarMax: {
            defaultValue: true,
            description: "Set BarMax visible",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        showBarMin: {
            defaultValue: true,
            description: "Set BarMin visible",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        showBarClose: {
            defaultValue: true,
            description: "Set BarClose visible",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        showIcon: {
            defaultValue: true,
            description: "Set icon visible",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        theme: {
            defaultValue: "",
            description: "Set form theme",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        title: {
            defaultValue: "WinForm",
            description: "Set title",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        titleTheme: {
            defaultValue: "",
            description: "Set title theme",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        width: {
            defaultValue: "auto",
            description: "Set WinForm width",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.number, elmer_ui_core_1.propTypes.string])
        },
        height: {
            defaultValue: "auto",
            description: "Set WinForm Height",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.number, elmer_ui_core_1.propTypes.string])
        },
        visible: {
            defaultValue: true,
            description: "Set WinForm Visible",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        zIndex: {
            defaultValue: 1,
            description: "Set WinForm zIndex",
            rule: elmer_ui_core_1.propTypes.number
        },
        position: {
            defaultValue: "absolute",
            description: "position",
            rule: elmer_ui_core_1.propTypes.oneValueOf(["fixed", "absolute"]).isRequired
        },
        emit: {
            description: "raise event",
            rule: elmer_ui_core_1.propTypes.func
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], WinFormComponent.prototype, "$", void 0);
    WinFormComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "WinForm"
        }),
        __metadata("design:paramtypes", [Object])
    ], WinFormComponent);
    return WinFormComponent;
}(elmer_ui_core_1.Component));
exports.WinFormComponent = WinFormComponent;
