import { ElmerRender, IElmerEvent } from "elmer-ui-core";
import { IComponent } from "elmer-ui-core/lib/interface/IComponent";
import { TypeWinFormProps } from "./WinForm";
export declare type TypeCreateDialogFormAttrs = {
    [P in Exclude<keyof TypeWinFormProps, "position" | "onClose" | "onMin" | "onMax" | "onFocus">]?: any;
} & {
    events?: any;
};
export declare type TypeCreateDailogOptions = {
    parent?: HTMLElement;
    options?: TypeCreateDialogFormAttrs & {
        position?: "absolute" | "fixed";
        data?: any;
    };
    htmlCode?: string;
    showMask?: boolean;
    attrs?: any;
    events?: any;
    onClose?: Function;
    onMin?: Function;
    onMax?: Function;
    onFocus?: Function;
};
export declare type TypeCreateDialogResult = {
    render?: ElmerRender;
    component?: IComponent;
    options?: any;
    zIndex?: number;
    hide?: Function;
    setData?: Function;
    setState?: Function;
    setZIndex?(index: number, visible?: boolean): void;
    show?(options?: TypeCreateDailogOptions): void;
};
export declare const createDialog: (options: TypeCreateDailogOptions) => TypeCreateDialogResult;
export interface IDialogInputBeforeEvent extends IElmerEvent {
    cancel?: boolean;
    value?: any;
}
export declare type TypeDialogInputOptions = {
    title?: string;
    okText?: string;
    cancelText?: string;
    defaultValue?: string | number;
    placeHolder?: string;
    zIndex?: number;
    onOk?(value?: string): void;
    onCancel?(): void;
    onBefore?(evt?: IDialogInputBeforeEvent): void;
};
export declare const showInput: (options: TypeDialogInputOptions) => TypeCreateDialogResult;
export declare type TypeEnumAlertIcon = "Alert" | "Error" | "Information" | "Question" | "Success" | "Warning";
export declare type TypeEnumAlertMsg = "OKOnly" | "OkCancel" | "OkCancelRetry" | "YesOnly" | "YesNo" | "YesNoRetry";
export declare type TypeEnumAlertButton = "Ok" | "Cancel" | "Retry" | "None";
export declare type TypeOnAlertBeforeEvent = {
    button: TypeEnumAlertButton;
    cancel: boolean;
};
export declare type TypeAlertOptions = {
    title?: string;
    message?: string;
    content?: string;
    msgType?: TypeEnumAlertMsg;
    iconType?: TypeEnumAlertIcon;
    icon?: string;
    showTipIcon?: boolean;
    okText?: string;
    okTheme?: string;
    cancelText?: string;
    cancelTheme?: string;
    retryText?: string;
    retryTheme?: string;
    theme?: string;
    zIndex?: number;
    isMobile?: boolean;
    events?: any;
    attrs?: any;
    onOk?(): void;
    onCancel?(): void;
    onRetry?(): void;
    onBefore?(event: TypeOnAlertBeforeEvent): void;
};
export declare const eAlert: (options: TypeAlertOptions) => TypeCreateDialogResult;
declare const _default: {
    open: (options: TypeCreateDailogOptions) => TypeCreateDialogResult;
    input: (options: TypeDialogInputOptions) => TypeCreateDialogResult;
    alert: (options: TypeAlertOptions) => TypeCreateDialogResult;
};
export default _default;
