"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var euiAlertData_1 = require("./euiAlertData");
require("./style/form.less");
var AlertComponent = (function (_super) {
    __extends(AlertComponent, _super);
    function AlertComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.dialogConfig = {
            okTitle: "确定",
            cancelTitle: "取消",
            tryTitle: "重试",
            onOk: function () {
                var evt = {
                    button: 0,
                    cancel: false,
                    dom: _this.dom
                };
                typeof _this.props.onBeforeClick === "function" && _this.props.onBeforeClick(evt);
                _this.clickButton = 0;
                !evt.cancel && _this.dom[_this.formID].btnClose();
            },
            onCancel: function () {
                var evt = {
                    button: 1,
                    cancel: false,
                    dom: _this.dom
                };
                typeof _this.props.onBeforeClick === "function" && _this.props.onBeforeClick(evt);
                _this.clickButton = 1;
                !evt.cancel && _this.dom[_this.formID].btnClose();
            },
            onTry: function () {
                var evt = {
                    button: 1,
                    cancel: false,
                    dom: _this.dom
                };
                typeof _this.props.onBeforeClick === "function" && _this.props.onBeforeClick(evt);
                _this.clickButton = 2;
                !evt.cancel && _this.dom[_this.formID].btnClose();
            }
        };
        _this.bottomTheme = "";
        _this.bottomHtmlCode = "";
        _this.formID = _this.getRandomID();
        _this.contentID = _this.getRandomID();
        _this.noTipIconTheme = "";
        _this.clickButton = -1;
        _this.msgType = euiAlertData_1.EnumAlertMsgType.OKOnly;
        _this.msgType = props.msgType;
        _this.noTipIconTheme = props.noTipIcon ? "elmerAlertNoTipIcon" : "";
        _this.checkButtonTitle();
        _this.checkButtonType();
        _this.clickButton = -1;
        if (!_this.isEmpty(props.formID)) {
            _this.formID;
        }
        return _this;
    }
    AlertComponent.prototype.formClose = function () {
        if (this.clickButton === 0) {
            typeof this.props.onOk === "function" && this.props.onOk();
        }
        else if (this.clickButton === 2) {
            typeof this.props.onRetry === "function" && this.props.onRetry();
        }
        else {
            typeof this.props.onCancel === "function" && this.props.onCancel();
        }
        typeof this.props.onAfterClose === "function" && this.props.onAfterClose();
    };
    AlertComponent.prototype.$onPropsChanged = function (props) {
        this.msgType = props.msgType;
        this.noTipIconTheme = props.noTipIcon ? "elmerAlertNoTipIcon" : "";
        this.checkButtonTitle();
        this.checkButtonType();
        this.setData({}, true);
    };
    AlertComponent.prototype.checkButtonTitle = function () {
        if (this.isEmpty(this.props.okTitle)) {
            if ([euiAlertData_1.EnumAlertMsgType.YesOnly, euiAlertData_1.EnumAlertMsgType.YesNo, euiAlertData_1.EnumAlertMsgType.YesNoRetry].indexOf(this.msgType) > -1) {
                this.dialogConfig.okTitle = "是";
            }
        }
        else {
            this.dialogConfig.okTitle = this.props.okTitle;
        }
        if (this.isEmpty(this.props.cancelTitle)) {
            if (this.msgType === euiAlertData_1.EnumAlertMsgType.YesNo ||
                this.msgType === euiAlertData_1.EnumAlertMsgType.YesNoRetry) {
                this.dialogConfig.cancelTitle = "否";
            }
        }
        else {
            this.dialogConfig.cancelTitle = this.props.cancelTitle;
        }
        if (this.isEmpty(this.props.tryTitle)) {
            if (this.msgType === euiAlertData_1.EnumAlertMsgType.YesNoRetry) {
                this.dialogConfig.tryTitle = "否";
            }
        }
        else {
            this.dialogConfig.tryTitle = this.props.tryTitle;
        }
    };
    AlertComponent.prototype.checkButtonType = function () {
        var bottomHtml = "";
        if ([euiAlertData_1.EnumAlertMsgType.OKOnly, euiAlertData_1.EnumAlertMsgType.YesOnly, euiAlertData_1.EnumAlertMsgType.OneTBD].indexOf(this.msgType) > -1) {
            bottomHtml = "<button evt:click='props.config.onOk' class='alert-yes'>{{props.config.okTitle}}</button>";
            this.bottomTheme = "elmerAlertOneButton";
        }
        else if ([euiAlertData_1.EnumAlertMsgType.OkCancel, euiAlertData_1.EnumAlertMsgType.YesNo, euiAlertData_1.EnumAlertMsgType.TowTBD].indexOf(this.msgType) > -1) {
            bottomHtml = "<button evt:click='props.config.onOk' class='alert-yes'>{{props.config.okTitle}}</button><button evt:click='props.config.onCancel' class='alert-no'>{{props.config.cancelTitle}}</button>";
            this.bottomTheme = "elmerAlertTwoButton";
        }
        else if ([euiAlertData_1.EnumAlertMsgType.OkCancelRetry, euiAlertData_1.EnumAlertMsgType.YesNoRetry, euiAlertData_1.EnumAlertMsgType.ThreeTBD].indexOf(this.msgType) > -1) {
            bottomHtml = "<button evt:click='props.config.onOk' class='alert-yes'>{{props.config.okTitle}}</button><button evt:click='props.config.onCancel' class='alert-no'>{{props.config.cancelTitle}}</button><button evt:click='props.config.onTry' class='alert-try'>{{props.config.tryTitle}}</button>";
            this.bottomTheme = "elmerAlertThreeButton";
        }
        else {
            bottomHtml = "<button evt:click='props.config.onOk' class='alert-yes'>{{props.config.okTitle}}</button>";
            this.bottomTheme = "elmerAlertOneButton";
        }
        this.bottomHtmlCode = bottomHtml;
    };
    AlertComponent.prototype.getDom = function () {
        return this.dom;
    };
    AlertComponent.prototype.render = function () {
        return require("./views/euiAlert.html");
    };
    AlertComponent.propType = {
        hasIcon: {
            defaultValue: false,
            description: "是否有标题栏图标",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        icon: {
            defaultValue: "icon-question",
            description: "标题栏图标",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        title: {
            defaultValue: "提示",
            description: "标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        msgType: {
            defaultValue: euiAlertData_1.EnumAlertMsgType.OKOnly,
            description: "消息类型",
            rule: elmer_ui_core_1.propTypes.enumValueOf(euiAlertData_1.EnumAlertMsgType)
        },
        iconType: {
            defaultValue: euiAlertData_1.EnumAlertIconType.Information,
            description: "图标类型",
            rule: elmer_ui_core_1.propTypes.enumValueOf(euiAlertData_1.EnumAlertIconType)
        },
        onOk: {
            description: "确定按钮事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onCancel: {
            description: "确定按钮事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onRetry: {
            description: "确定按钮事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onAfterClose: {
            description: "窗口关闭后的事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onBeforeClick: {
            description: "单击按钮前事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        theme: {
            defaultValue: "",
            description: "窗口样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        formId: {
            defaultValue: "",
            description: "定义formId",
            rule: elmer_ui_core_1.propTypes.string
        }
    };
    AlertComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "alert"
        }),
        __metadata("design:paramtypes", [Object])
    ], AlertComponent);
    return AlertComponent;
}(elmer_ui_core_1.Component));
exports.AlertComponent = AlertComponent;
