export declare enum IElmerAlertButton {
    OKButton = 0,
    CancelButton = 1,
    RetryButton = 2
}
export interface IElmerAlertBeforeEvent {
    button: IElmerAlertButton;
    cancel: boolean;
    dom: any;
}
export declare enum EnumAlertMsgType {
    OKOnly = "OKOnly",
    OkCancel = "OkCancel",
    OkCancelRetry = "OkCancelRetry",
    YesOnly = "YesOnly",
    YesNo = "YesNo",
    YesNoRetry = "YesNoRetry",
    OneTBD = "OneTBD",
    TowTBD = "TowTBD",
    ThreeTBD = "ThreeTBD"
}
export declare enum EnumAlertIconType {
    Alert = "Alert",
    Error = "Error",
    Information = "information",
    Question = "Question",
    Success = "Success",
    Warning = "Warning"
}
export interface IElmerAlertOptions {
    title?: string;
    message: string;
    content?: string;
    msgType?: EnumAlertMsgType;
    iconType?: EnumAlertIconType;
    okTitle?: string;
    cancelTitle?: string;
    tryTitle?: string;
    hasClose?: boolean;
    hasIcon?: boolean;
    noTipIcon?: boolean;
    icon?: string;
    ok?: Function;
    cancel?: Function;
    retry?: Function;
    onOk?: Function;
    onCancel?: Function;
    onRetry?: Function;
    onBeforeClick?(event?: IElmerAlertBeforeEvent): void;
}
export declare const eAlert: (options: IElmerAlertOptions) => void;
