"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var IElmerAlertButton;
(function (IElmerAlertButton) {
    IElmerAlertButton[IElmerAlertButton["OKButton"] = 0] = "OKButton";
    IElmerAlertButton[IElmerAlertButton["CancelButton"] = 1] = "CancelButton";
    IElmerAlertButton[IElmerAlertButton["RetryButton"] = 2] = "RetryButton";
})(IElmerAlertButton = exports.IElmerAlertButton || (exports.IElmerAlertButton = {}));
var EnumAlertMsgType;
(function (EnumAlertMsgType) {
    EnumAlertMsgType["OKOnly"] = "OKOnly";
    EnumAlertMsgType["OkCancel"] = "OkCancel";
    EnumAlertMsgType["OkCancelRetry"] = "OkCancelRetry";
    EnumAlertMsgType["YesOnly"] = "YesOnly";
    EnumAlertMsgType["YesNo"] = "YesNo";
    EnumAlertMsgType["YesNoRetry"] = "YesNoRetry";
    EnumAlertMsgType["OneTBD"] = "OneTBD";
    EnumAlertMsgType["TowTBD"] = "TowTBD";
    EnumAlertMsgType["ThreeTBD"] = "ThreeTBD";
})(EnumAlertMsgType = exports.EnumAlertMsgType || (exports.EnumAlertMsgType = {}));
var EnumAlertIconType;
(function (EnumAlertIconType) {
    EnumAlertIconType["Alert"] = "Alert";
    EnumAlertIconType["Error"] = "Error";
    EnumAlertIconType["Information"] = "information";
    EnumAlertIconType["Question"] = "Question";
    EnumAlertIconType["Success"] = "Success";
    EnumAlertIconType["Warning"] = "Warning";
})(EnumAlertIconType = exports.EnumAlertIconType || (exports.EnumAlertIconType = {}));
exports.eAlert = function (options) {
    var config = {
        title: "提示",
        message: "",
        noTipIcon: false
    };
    var ui = elmer_ui_core_1.getUI();
    ui.extend(config, options);
    var data = {
        id: ui.getRandomID(),
        options: config,
        onOK: typeof config.onOk === "function" ? config.onOk : config.ok,
        onCancel: typeof config.onCancel === "function" ? config.onCancel : config.cancel,
        onRetry: typeof config.onRetry === "function" ? config.onRetry : config.retry,
        onAfterClose: function () {
            parent.parentElement && parent.parentElement.removeChild(parent);
            parent = null;
            ui = null;
            config = null;
            setTimeout(function () {
                uiRender.dispose();
                uiRender = null;
            }, 200);
        }
    };
    var parent = document.createElement("div");
    var uiRender = ui.render(parent, "<eui-alert id='{{id}}' title='{{options.title}}' message='{{options.message}}' " +
        "msgType='{{options.msgType}}' iconType='{{options.iconType}}' okTitle='{{options.okTitle}}' " +
        "cancelTitle='{{options.cancelTitle}}' tryTitle='{{options.tryTitle}}' hasClose='{{options.hasClose}}' hasIcon='{{options.hasIcon}}' icon='{{options.icon}}' " +
        "et:onOk='onOK' et:onCancel='onCancel' et:onRetry='onRetry' et:onAfterClose='onAfterClose' et:onBeforeClick='options.onBeforeClick' noTipIcon='{{options.noTipIcon}}'/>", data);
    document.body.appendChild(parent);
};
if (!window["eAlert"]) {
    elmer_ui_core_1.defineGlobalVar("eAlert", exports.eAlert);
}
