"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
require("./style/form.less");
var enumAnimationEndType;
(function (enumAnimationEndType) {
    enumAnimationEndType["ShowForm"] = "ShowForm";
    enumAnimationEndType["CloseForm"] = "CloseForm";
    enumAnimationEndType["Minimize"] = "Minimize";
    enumAnimationEndType["None"] = "None";
})(enumAnimationEndType || (enumAnimationEndType = {}));
var DialogForm = (function (_super) {
    __extends(DialogForm, _super);
    function DialogForm(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            isMoved: true,
            isPressed: false,
            isMax: false,
            isClosing: false,
            mouseX: 0,
            mouseY: 0,
            formDom: null,
            maxDom: null,
            titleDom: null,
            contentDom: null,
            bottomDom: null,
            formLeft: null,
            formTop: null,
            formWidth: null,
            formHeight: null,
            zIndex: 1
        };
        _this.formStyle = "opacity:0;";
        _this.visible = true;
        _this.icon = "";
        _this.width = "auto";
        _this.height = "auto";
        _this.maskClassName = "";
        _this.noMaskClassName = "elmerDialogNoMask";
        _this.maxClassName = "elmerDialogFormTitleBarMaxResize";
        _this.showAnimation = "AniZoomIn";
        _this.hidenAnimation = "AniZoomOut";
        _this.minAnimation = "AnislideDownOut";
        _this.formAnimation = "";
        _this.contentStyle = "";
        _this.ownerID = _this.getRandomID();
        _this.formID = _this.getRandomID();
        _this.maxID = _this.getRandomID();
        _this.titleID = _this.getRandomID();
        _this.contentID = _this.getRandomID();
        _this.bottomID = _this.getRandomID();
        _this.showFrom = false;
        _this.animationEndType = null;
        _this.maxTheme = "";
        _this.maskClassName = props.hasMask ? "" : _this.noMaskClassName;
        _this.icon = !_this.isEmpty(props.icon) && props.hasIcon ? props.icon : "";
        _this.visible = props.visible;
        _this.state.zIndex = props.zIndex;
        _this.formStyle = _this.getFormSizeStyle() + "opacity:0;";
        return _this;
    }
    DialogForm.prototype.$onPropsChanged = function (props) {
        if (this.animationEndType === enumAnimationEndType.None) {
            if (props.visible !== this.visible) {
                if (props.visible) {
                    this.setData({
                        visible: props.visible,
                        formAnimation: this.showAnimation,
                        animationEndType: enumAnimationEndType.ShowForm
                    });
                }
                else {
                    this.setData({
                        visible: props.visible,
                        formAnimation: this.hidenAnimation,
                        animationEndType: enumAnimationEndType.Minimize
                    });
                }
                return;
            }
        }
        if (this.state.zIndex !== props.zIndex) {
            if (this.state.formDom) {
                if (!this.state.isMax) {
                    var nLeft = this.state.formDom.offsetLeft;
                    var nTop = this.state.formDom.offsetTop;
                    var formStyle = this.getFormSizeStyle(props.zIndex);
                    this.state.zIndex = props.zIndex;
                    this.setData({
                        formStyle: "left: " + nLeft + "px;top:" + nTop + "px;opacity:1;" + formStyle
                    });
                }
                else {
                    this.setData({
                        formStyle: "left: 0;top:0;opacity:1;z-index:" + props.zIndex + ";width:100%;height:100%;"
                    });
                }
            }
        }
    };
    DialogForm.prototype.$after = function () {
        this.addEvent(this, document.body, "mousemove", this.onbodyMouseMove.bind(this));
        this.addEvent(this, document.body, "mouseup", this.onbodyMouseUp.bind(this));
        this.animationEnd(this.state.formDom, this.formAnimationEnd.bind(this));
        if (!this.state.isClosing) {
            this.state.formDom = this.dom[this.formID];
            this.state.maxDom = this.dom[this.maxID];
            this.state.titleDom = this.dom[this.titleID];
            this.state.contentDom = this.dom[this.contentID];
            this.state.bottomDom = this.dom[this.bottomID];
            this.show();
        }
    };
    DialogForm.prototype.show = function () {
        var left = this.state.formDom.style.left || "";
        var top = this.state.formDom.style.top || "";
        left = left.replace(/[a-z\%]*$/i, "");
        top = top.replace(/[a-z\%]*$/i, "");
        if (!this.showFrom) {
            if (!this.isNumeric(left) || !this.isNumeric(top) || this.isEmpty(left) || this.isEmpty(top)) {
                var mask = this.dom[this.ownerID];
                var maskWidth = mask ? mask.clientWidth : null, maskHeight = mask ? mask.clientHeight : null;
                var frmWidth = this.state.formDom.clientWidth;
                var frmHeight = this.state.formDom.clientHeight;
                var winWidth = maskWidth || window.innerWidth;
                var winHeight = maskHeight || window.innerHeight;
                var nLeft = (winWidth - frmWidth) / 2;
                var nTop = (winHeight - frmHeight) / 2;
                var formStyle = this.getFormSizeStyle();
                this.setData({
                    formStyle: "left: " + nLeft + "px;top:" + nTop + "px;opacity:1;" + formStyle,
                    formAnimation: this.showAnimation,
                    animationEndType: enumAnimationEndType.ShowForm
                });
            }
            else {
                this.setData({
                    formAnimation: this.showAnimation,
                    animationEndType: enumAnimationEndType.ShowForm
                });
            }
            this.visible = true;
            this.showFrom = true;
        }
    };
    DialogForm.prototype.onMaxClick = function () {
        var formDom = this.dom[this.formID];
        if (!this.state.isMax) {
            this.state.formLeft = formDom.offsetLeft;
            this.state.formTop = formDom.offsetTop;
            this.state.formWidth = formDom.clientWidth;
            this.state.formHeight = formDom.clientHeight;
            this.state.isMax = true;
            this.$.css(formDom, {
                left: 0,
                top: 0,
                width: "100%",
                height: "100%"
            });
            this.setData({
                maxTheme: this.maxClassName
            });
        }
        else {
            this.state.isMax = false;
            this.$.css(formDom, {
                left: this.state.formLeft,
                top: this.state.formTop,
                width: this.state.formWidth,
                height: this.state.formHeight
            });
            this.setData({
                maxTheme: ""
            });
        }
    };
    DialogForm.prototype.onMinClick = function () {
        this.state.isClosing = true;
        this.animationEndType = enumAnimationEndType.Minimize;
        this.setData({
            formAnimation: this.minAnimation
        });
    };
    DialogForm.prototype.formAnimationEnd = function () {
        if (this.animationEndType === enumAnimationEndType.CloseForm) {
            this.state.isClosing = true;
            this.setData({
                visible: false,
                showFrom: false
            });
            typeof this.props.onClose === "function" && this.props.onClose();
        }
        else if (this.animationEndType === enumAnimationEndType.Minimize) {
            this.setData({
                visible: false,
                showFrom: false
            });
            typeof this.props.onMin === "function" && this.props.onMin();
        }
        this.animationEndType = enumAnimationEndType.None;
    };
    DialogForm.prototype.btnClose = function () {
        if (this.$.supportCss3 && !this.isEmpty(this.hidenAnimation)) {
            this.setData({
                formAnimation: this.hidenAnimation,
                animationEndType: enumAnimationEndType.CloseForm
            });
        }
        else {
            this.state.isClosing = true;
            this.setData({
                visible: false,
                showFrom: false
            });
            typeof this.props.onClose === "function" && this.props.onClose();
        }
    };
    DialogForm.prototype.ontitleBarMouseDown = function (evt) {
        var thisEvent = window.event || evt;
        this.state.mouseX = thisEvent.clientX ? thisEvent.clientX :
            (thisEvent.touches ? thisEvent.touches[0].clientX : 0);
        this.state.mouseY = thisEvent.clientY ? thisEvent.clientY :
            (thisEvent.touches ? thisEvent.touches[0].clientY : 0);
        thisEvent.cancelBubble = true;
        if (!this.state.isMax) {
            this.state.isPressed = true;
        }
    };
    DialogForm.prototype.onbodyMouseMove = function (evt) {
        if (this.state.isPressed && this.state.isMoved && this.state.formDom && !this.state.isMax) {
            var thisEvent = (window.event || evt);
            var posX = thisEvent.clientX ? thisEvent.clientX :
                (thisEvent.touches ? thisEvent.touches[0].clientX : 0);
            var posY = thisEvent.clientY ? thisEvent.clientY :
                (thisEvent.touches ? thisEvent.touches[0].clientY : 0);
            var formDom = this.state.formDom;
            var formStyle = this.getFormSizeStyle();
            var left = formDom.offsetLeft, top_1 = formDom.offsetTop, myLeft = left + (posX - this.state.mouseX), myTop = top_1 + (posY - this.state.mouseY);
            this.state.mouseX = posX;
            this.state.mouseY = posY;
            this.$.css(formDom, {
                left: myLeft,
                top: myTop
            });
            this.formStyle = "left: " + myLeft + "px;top:" + myTop + "px;opacity:1;" + formStyle;
        }
    };
    DialogForm.prototype.onbodyMouseUp = function () {
        this.state.isPressed = false;
    };
    DialogForm.prototype.render = function () {
        var bottomHtmlCode = this.props.bottom || "";
        var htmlCode = require("./views/form.html");
        if (this.getType(htmlCode) === "[object Module]") {
            htmlCode = htmlCode.default;
        }
        return htmlCode.replace(/\[bottomHtmlCode\]/ig, bottomHtmlCode);
    };
    DialogForm.prototype.getFormSizeStyle = function (zIndex) {
        var result = "";
        var pWidth = this.props.width;
        var pHeight = this.props.height;
        if (!this.isEmpty(pWidth)) {
            result = pWidth !== "auto" ? (!isNaN(pWidth) ? "width:" + pWidth + "px;" : "width:" + pWidth + ";") : "";
        }
        if (!this.isEmpty(pHeight)) {
            result += pHeight !== "auto" ? (!isNaN(pHeight) ? "height:" + pHeight + "px;" : "height:" + pHeight + ";") : "";
        }
        if (isNaN(zIndex)) {
            if (!this.isEmpty(this.state.zIndex) && !isNaN(this.state.zIndex)) {
                result += "z-index:" + this.state.zIndex + ";";
            }
        }
        else {
            result += "z-index:" + zIndex + ";";
        }
        return result;
    };
    DialogForm.propType = {
        hasMask: {
            defaultValue: true,
            description: "是否有遮罩层",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        maskStyle: {
            defaultValue: "",
            description: "遮罩层样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        hasBottom: {
            defaultValue: true,
            description: "是否有底部状态栏",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        hasMax: {
            defaultValue: true,
            description: "是否有最大化按钮",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        hasMin: {
            defaultValue: true,
            description: "是否有最小化按钮",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        hasClose: {
            defaultValue: true,
            description: "是否有关闭按钮",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        hasIcon: {
            defaultValue: true,
            description: "是否有图标",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        formTheme: {
            defaultValue: "",
            description: "窗体样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        titleBarTheme: {
            defaultValue: "",
            description: "窗体标题栏样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        bottomTheme: {
            defaultValue: "",
            description: "窗体底部栏样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        bottom: {
            defaultValue: "",
            description: "窗口底部内容代码",
            rule: elmer_ui_core_1.propTypes.string
        },
        icon: {
            defaultValue: "icon-question",
            description: "标题栏图标",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        onClose: {
            description: "关闭事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onMin: {
            description: "最小化事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        config: {
            description: "配置参数",
            rule: elmer_ui_core_1.propTypes.any
        },
        title: {
            defaultValue: "Dialog(v2.0.0)",
            description: "标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        visible: {
            defaultValue: true,
            description: "是否显示",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        width: {
            defaultValue: "auto",
            description: "窗口宽度",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        height: {
            defaultValue: "auto",
            description: "窗口高度",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        parent: {
            description: "指定父元素，为计算窗口使用，为以后升级使用",
            rule: elmer_ui_core_1.propTypes.any
        },
        zIndex: {
            defaultValue: 1,
            description: "dialog form zIndex",
            rule: elmer_ui_core_1.propTypes.number
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], DialogForm.prototype, "$", void 0);
    DialogForm = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "dialog"
        }),
        __metadata("design:paramtypes", [Object])
    ], DialogForm);
    return DialogForm;
}(elmer_ui_core_1.Component));
exports.DialogForm = DialogForm;
