"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PcRegionPicker = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var RegionData_1 = require("../mobile/mobileSelect/RegionData");
require("./style.less");
var PcRegionPicker = (function (_super) {
    __extends(PcRegionPicker, _super);
    function PcRegionPicker(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            dropListVisible: false,
            hasFocus: false,
            selectedTab: "0"
        };
        _this.displayData = [];
        _this.provinceData = RegionData_1.RegionData.categoryProvince;
        _this.cityData = [];
        _this.districtData = [];
        _this.proviceTitle = "省份";
        _this.cityTitle = "城市";
        _this.districtTitle = "县区";
        _this.selectedProvince = {};
        _this.selectedCity = {};
        _this.selectedDistrict = {};
        _this.placeholder = "";
        _this.displayValue = "";
        _this.sourceData = RegionData_1.RegionData;
        if (props.title) {
            _this.proviceTitle = props.title[0];
            _this.cityTitle = props.title[1];
            _this.districtTitle = props.title[2];
        }
        _this.placeholder = !_this.isEmpty(props.placeholder) ? props.placeholder : "请选择";
        if (props.data && Object.keys(props.data).length > 0) {
            _this.sourceData = props.data;
            _this.provinceData = _this.sourceData.categoryProvince;
        }
        _this.updateDefaultValue();
        _this.updateDisplayData(true);
        return _this;
    }
    PcRegionPicker.prototype.$onPropsChanged = function (props) {
        if (props.data && Object.keys(props.data).length > 0) {
            this.sourceData = props.data;
            this.provinceData = this.sourceData.categoryProvince;
        }
        this.updateDefaultValue();
        this.updateDisplayData();
    };
    PcRegionPicker.prototype.handleOnBodyClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            dropListVisible: false,
            hasFocus: false,
        });
    };
    PcRegionPicker.prototype.checkIconVisible = function (iconValue) {
        var visibleClassName = this.isEmpty(iconValue) ? "eui-inline-hidden" : "eui-inline-block";
        return visibleClassName;
    };
    PcRegionPicker.prototype.handleOnTabClick = function (evt) {
        var id = evt.target.getAttribute("data-id");
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            selectedTab: id
        });
    };
    PcRegionPicker.prototype.handleOnDisplayTitleClick = function (evt) {
        var id = evt.target.getAttribute("data-id");
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            dropListVisible: true,
            selectedTab: !isNaN(id) && !this.isEmpty(id) ? id : "0"
        });
    };
    PcRegionPicker.prototype.handleOnProvinceClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.state.selectedTab = "1";
        this.setData({
            selectedProvince: evt.data.provice,
            cityData: this.sourceData[evt.data.provice.value] || [],
            districtData: [],
            selectedDistrict: {},
            selectedCity: {}
        });
        this.updateDisplayData();
    };
    PcRegionPicker.prototype.handleOnCityClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.state.selectedTab = "2";
        this.setData({
            selectedCity: evt.data.city,
            districtData: this.sourceData[evt.data.city.value] || [],
            selectedDistrict: {}
        });
        this.updateDisplayData();
    };
    PcRegionPicker.prototype.handleOnDistrictClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.state.dropListVisible = false;
        this.state.hasFocus = false;
        this.setData({
            selectedDistrict: evt.data.district
        });
        this.updateDisplayData();
        typeof this.props.onChanged === "function" && this.props.onChanged({
            data: this.displayData,
            id: this.props.id,
            name: this.props.name
        });
    };
    PcRegionPicker.prototype.handleOnClick = function () {
        if (!this.props.disabled) {
            this.setState({
                dropListVisible: true,
                hasFocus: true
            });
        }
    };
    PcRegionPicker.prototype.render = function () {
        return require("./pcRegionPicker.html");
    };
    PcRegionPicker.prototype.$after = function () {
        this.addEvent(this, document.body, "click", this.handleOnBodyClick);
    };
    PcRegionPicker.prototype.getData = function () {
        return this.displayData;
    };
    PcRegionPicker.prototype.reset = function () {
        this.selectedProvince = null;
        this.selectedCity = null;
        this.selectedDistrict = null;
        this.updateDisplayData();
    };
    PcRegionPicker.prototype.updateDisplayData = function (setDataDirect) {
        var result = [];
        var _displayValue = "";
        if (this.selectedProvince && !this.isEmpty(this.selectedProvince.value)) {
            result.push({
                title: this.selectedProvince.title,
                value: this.selectedProvince.value,
                index: result.length
            });
            _displayValue = this.selectedProvince.value;
        }
        if (this.selectedCity && !this.isEmpty(this.selectedCity.value)) {
            result.push({
                title: this.selectedCity.title,
                value: this.selectedCity.value,
                index: result.length
            });
            _displayValue += "|" + this.selectedCity.value;
        }
        if (this.selectedDistrict && !this.isEmpty(this.selectedDistrict.value)) {
            result.push({
                title: this.selectedDistrict.title,
                value: this.selectedDistrict.value,
                index: result.length
            });
            _displayValue += "|" + this.selectedDistrict.value;
        }
        if (!setDataDirect) {
            this.setData({
                displayData: result,
                displayValue: _displayValue
            });
        }
        else {
            this.displayData = result;
            this.displayValue = _displayValue;
        }
    };
    PcRegionPicker.prototype.updateDefaultValue = function () {
        if (this.props.defaultValue && this.props.defaultValue.length > 0) {
            var defaultProvice = this.props.defaultValue[0];
            for (var _i = 0, _a = this.provinceData; _i < _a.length; _i++) {
                var tmpProvice = _a[_i];
                if (this.isArray(tmpProvice.data)) {
                    for (var _b = 0, _c = tmpProvice.data; _b < _c.length; _b++) {
                        var tmpProviceData = _c[_b];
                        if (tmpProviceData.value == defaultProvice) {
                            this.selectedProvince = {
                                value: tmpProviceData.value,
                                title: tmpProviceData.title
                            };
                            this.cityData = this.sourceData[defaultProvice] || [];
                            break;
                        }
                    }
                }
                else {
                    if (tmpProvice.value == defaultProvice) {
                        this.selectedProvince = {
                            value: tmpProvice.value,
                            title: tmpProvice.title
                        };
                        this.cityData = this.sourceData[defaultProvice] || [];
                        break;
                    }
                }
            }
            var defaultCity = this.props.defaultValue[1];
            if (this.cityData && this.cityData.length > 0) {
                for (var _d = 0, _e = this.cityData; _d < _e.length; _d++) {
                    var tmpCity = _e[_d];
                    if (tmpCity.value == defaultCity) {
                        this.selectedCity = {
                            value: tmpCity.value,
                            title: tmpCity.title
                        };
                        this.districtData = this.sourceData[defaultCity];
                        break;
                    }
                }
            }
            var defaultDistrict = this.props.defaultValue[2];
            if (this.districtData && this.districtData.length > 0) {
                for (var _f = 0, _g = this.districtData; _f < _g.length; _f++) {
                    var tmpDistrict = _g[_f];
                    if (tmpDistrict.value == defaultDistrict) {
                        this.selectedDistrict = {
                            value: tmpDistrict.value,
                            title: tmpDistrict.title
                        };
                        break;
                    }
                }
            }
        }
        else {
            this.selectedProvince = null;
            this.selectedCity = null;
            this.selectedDistrict = null;
        }
    };
    PcRegionPicker.propTypes = {
        defaultValue: {
            defaultValue: [],
            description: "默认RegionCode",
            rule: elmer_ui_core_1.propTypes.array
        },
        id: {
            description: "组件ID",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        name: {
            description: "组件name",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        disabled: {
            defaultValue: false,
            description: "是否禁止",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        placeholder: {
            defaultValue: "请选择",
            description: "placeholder",
            rule: elmer_ui_core_1.propTypes.string
        },
        tabIndex: {
            defaultValue: 0,
            description: "tabIndex",
            rule: elmer_ui_core_1.propTypes.number.isRequired
        },
        onChanged: {
            description: "Change事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        title: {
            defaultValue: ["省份", "城市", "县区"],
            description: "标题",
            rule: elmer_ui_core_1.propTypes.array
        },
        availableCode: {
            defaultValue: [],
            description: "有效显示地区代码",
            rule: elmer_ui_core_1.propTypes.array
        },
        data: {
            description: "自定义选择数据",
            rule: elmer_ui_core_1.propTypes.any
        },
        style: {
            defaultValue: "",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        }
    };
    PcRegionPicker = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "PcRegionPicker"
        }),
        __metadata("design:paramtypes", [Object])
    ], PcRegionPicker);
    return PcRegionPicker;
}(elmer_ui_core_1.Component));
exports.PcRegionPicker = PcRegionPicker;
