"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElmerDropDown = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./style.less");
var ElmerDropDown = (function (_super) {
    __extends(ElmerDropDown, _super);
    function ElmerDropDown(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            titleVisible: false,
            dropListVisible: false,
            hasFocus: false,
            title: "",
            selectedData: { value: "" },
            dataList: [],
            style: ""
        };
        _this.state.dataList = props.data || [];
        _this.state.style = props.style || "";
        if (_this.props.zIndex > 0) {
            _this.state.style += "z-index:" + props.zIndex + ";";
        }
        if (!_this.isEmpty(props.value)) {
            var listData = props.data || [];
            for (var _i = 0, listData_1 = listData; _i < listData_1.length; _i++) {
                var tmpData = listData_1[_i];
                if (tmpData.value === props.value) {
                    _this.state.titleVisible = true;
                    _this.state.title = tmpData.title;
                    _this.state.selectedData = tmpData;
                    break;
                }
            }
        }
        return _this;
    }
    ElmerDropDown.prototype.getData = function () {
        return this.state.selectedData;
    };
    ElmerDropDown.prototype.reset = function () {
        this.setState({
            titleVisible: false,
            title: "",
            selectedData: null
        }, true);
    };
    ElmerDropDown.prototype.checkIconVisible = function (itemData) {
        var visibleClassName = itemData && this.isEmpty(itemData.icon) ? "eui-inline-hidden" : "eui-inline-block";
        if (itemData && !this.isEmpty(itemData.theme)) {
            visibleClassName += " " + itemData.theme;
        }
        return visibleClassName;
    };
    ElmerDropDown.prototype.handleOnBlur = function () {
        this.setState({
            dropListVisible: false,
            hasFocus: false,
        });
    };
    ElmerDropDown.prototype.handleOnClick = function () {
        if (!this.props.disabled) {
            this.setState({
                dropListVisible: !this.state.dropListVisible,
                hasFocus: true
            });
        }
    };
    ElmerDropDown.prototype.handleOnListClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
    };
    ElmerDropDown.prototype.handleOnListItemClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        if (!evt.data.item.disabled) {
            this.setState({
                titleVisible: true,
                dropListVisible: false,
                selectedData: evt.data.item,
                title: evt.data.item.title
            });
            typeof this.props.onChanged === "function" && this.props.onChanged(evt.data.item, {
                id: this.props.id,
                name: this.props.name,
                tag: this.props.tag
            }, this.props.tag);
            typeof this.props.onChange === "function" && this.props.onChange(evt.data.item, {
                id: this.props.id,
                name: this.props.name,
                tag: this.props.tag
            });
        }
    };
    ElmerDropDown.prototype.$onPropsChanged = function (props) {
        var listData = props.data || [];
        var updateState = {
            dataList: props.data || [],
            style: props.style || ""
        };
        for (var _i = 0, listData_2 = listData; _i < listData_2.length; _i++) {
            var tmpData = listData_2[_i];
            if (tmpData.value === props.value) {
                updateState.titleVisible = true;
                updateState.title = tmpData.title;
                updateState.selectedData = tmpData;
                break;
            }
        }
        this.setState(updateState);
    };
    ElmerDropDown.prototype.render = function () {
        return require("./index.html");
    };
    ElmerDropDown.propType = {
        id: {
            description: "组件ID",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        name: {
            description: "组件name",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        disabled: {
            defaultValue: false,
            description: "是否禁止",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        value: {
            defaultValue: "",
            description: "默认值",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        data: {
            defaultValue: [],
            description: "列表数据",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        placeholder: {
            defaultValue: "",
            description: "placeholder",
            rule: elmer_ui_core_1.propTypes.string
        },
        tabIndex: {
            defaultValue: 0,
            description: "tabIndex",
            rule: elmer_ui_core_1.propTypes.number.isRequired
        },
        zIndex: {
            description: "zIndex",
            rule: elmer_ui_core_1.propTypes.number
        },
        onChanged: {
            description: "Change事件,即将弃用的方法",
            rule: elmer_ui_core_1.propTypes.func
        },
        onChange: {
            description: "Change事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        style: {
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        showValue: {
            defaultValue: false,
            description: "是否显示value值在title后面",
            rule: elmer_ui_core_1.propTypes.bool
        },
        tag: {
            rule: elmer_ui_core_1.propTypes.any
        }
    };
    ElmerDropDown = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "dropDown"
        }),
        __metadata("design:paramtypes", [Object])
    ], ElmerDropDown);
    return ElmerDropDown;
}(elmer_ui_core_1.Component));
exports.ElmerDropDown = ElmerDropDown;
