"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var toast_1 = require("../toast");
var FormComponent = (function (_super) {
    __extends(FormComponent, _super);
    function FormComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.layoutTheme = "eui-form-inline";
        _this.inlineMode = false;
        _this.labelWidth = "";
        _this.itemPaddingLeft = "";
        _this.ajaxLoading = false;
        _this.layoutTheme = props.inlineMode ? "eui-form-inline" : "eui-form-block";
        _this.inlineMode = props.inlineMode;
        _this.labelWidth = "width:" + props.labelWidth + ";";
        _this.itemPaddingLeft = "padding-left: " + props.labelWidth + ";";
        _this.updateChildrenProps();
        return _this;
    }
    FormComponent.prototype.$onPropsChanged = function (newProps) {
        if (newProps.inlineMode !== this.inlineMode) {
            this.inlineMode = newProps.inlineMode;
            this.layoutTheme = newProps.inlineMode ? "eui-form-inline" : "eui-form-block";
        }
        if (newProps.labelWidth !== this.labelWidth) {
            this.labelWidth = newProps.labelWidth;
            this.itemPaddingLeft = "padding-left: " + newProps.labelWidth + ";";
        }
        this.updateChildrenProps();
        this.setState({}, true);
    };
    FormComponent.prototype.handleOnBackClick = function () {
        if (typeof this.props.onBack === "function") {
            this.props.onBack();
        }
        else {
            if (!this.isEmpty(this.props.backUrl)) {
                window.location.href = this.props.backUrl;
            }
        }
    };
    FormComponent.prototype.handleOnFormSubmit = function (evt) {
        evt.nativeEvent.preventDefault();
        evt.nativeEvent.stopImmediatePropagation();
        evt.nativeEvent.stopPropagation();
        return false;
    };
    FormComponent.prototype.render = function () {
        return require("./views/form.html");
    };
    FormComponent.prototype.handleOnBtnSubmit = function () {
        var _this = this;
        var request = {};
        if (/^(http|https)\:\/\//.test(this.props.action) || /^(\.\.\/)|(\.\/)/.test(this.props.action)) {
            request.url = this.props.action;
        }
        else {
            var NEData = (this.props.action || "").split(".");
            request.namespace = NEData[0];
            request.endPoint = NEData[1];
        }
        var submitData = this.getFormData();
        typeof this.props.beforeSubmit === "function" && this.props.beforeSubmit(submitData);
        this.setData({ ajaxLoading: true });
        this.updateChildrenAjaxLoadingStatus();
        this.ajax.sendRequest(__assign(__assign({}, request), { method: this.props.method, data: submitData })).then(function (resp) {
            _this.setData({ ajaxLoading: false });
            _this.updateChildrenAjaxLoadingStatus();
            typeof _this.props.onSuccess === "function" && _this.props.onSuccess(resp);
        }).catch(function (err) {
            _this.setData({ ajaxLoading: false });
            _this.updateChildrenAjaxLoadingStatus();
            if (typeof _this.props.onFail === "function") {
                _this.props.onFail(err);
            }
            else {
                if (_this.isObject(err)) {
                    toast_1.showToast(err.statusText);
                }
                else {
                    toast_1.showToast(err.message);
                }
            }
        });
    };
    FormComponent.prototype.handleOnReset = function () {
        var _this = this;
        if (this.dom && Object.keys(this.dom).length > 0) {
            Object.keys(this.dom).map(function (tmpKey) {
                var tmpChild = _this.dom[tmpKey];
                typeof tmpChild.reset === "function" && tmpChild.reset();
            });
        }
    };
    FormComponent.prototype.getFormData = function () {
        var _this = this;
        var result = {};
        if (this.dom && Object.keys(this.dom).length > 0) {
            Object.keys(this.dom).map(function (tmpKey) {
                var tmpChild = _this.dom[tmpKey];
                var tmpData = typeof tmpChild.getData === "function" ? tmpChild.getData() : null;
                if (tmpData) {
                    result[tmpData.name] = tmpData.value;
                }
            });
        }
        return result;
    };
    FormComponent.prototype.updateChildrenAjaxLoadingStatus = function () {
        var _this = this;
        if (this.dom && Object.keys(this.dom).length > 0) {
            Object.keys(this.dom).map(function (tmpKey) {
                var tmpChild = _this.dom[tmpKey];
                delete tmpChild.props.ajaxLoading;
                _this.defineReadOnlyProperty(tmpChild.props, "ajaxLoading", _this.ajaxLoading);
                typeof tmpChild.$onPropsChanged === "function" && tmpChild.$onPropsChanged(tmpChild.props);
            });
        }
    };
    FormComponent.prototype.setChildenPropsChanged = function () {
        var _this = this;
        this.updateChildrenProps();
        if (this.dom && Object.keys(this.dom).length > 0) {
            Object.keys(this.dom).map(function (tmpKey) {
                var tmpChild = _this.dom[tmpKey];
                delete tmpChild.props.ajaxLoading;
                _this.defineReadOnlyProperty(tmpChild.props, "ajaxLoading", _this.ajaxLoading);
                typeof tmpChild.$onPropsChanged === "function" && tmpChild.$onPropsChanged(tmpChild.props);
            });
        }
    };
    FormComponent.prototype.updateChildrenProps = function () {
        var _this = this;
        if (this.props.children && this.props.children.length > 0) {
            this.props.children.map(function (tmpChildren, index) {
                if (tmpChildren.tagName === "eui-form-item") {
                    if (_this.isEmpty(tmpChildren.props.id)) {
                        var myID = _this.getRandomID() + index;
                        tmpChildren.props.id = myID;
                        tmpChildren.props.attach = true;
                    }
                    _this.extend(tmpChildren.props, {
                        layoutTheme: _this.layoutTheme,
                        labelWidth: _this.labelWidth,
                        itemPaddingLeft: _this.itemPaddingLeft,
                        ajaxLoading: _this.ajaxLoading,
                        tabIndex: index
                    }, true);
                }
            });
        }
    };
    FormComponent.propType = {
        action: {
            description: "发送请求url",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        method: {
            defaultValue: "POST",
            description: "请求类型",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        title: {
            defaultValue: "Form标题",
            description: "Form标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        hasTitle: {
            defaultValue: true,
            description: "Form标题",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        submitText: {
            defaultValue: "提交",
            description: "提交按钮标题",
            rule: elmer_ui_core_1.propTypes.string
        },
        resetText: {
            defaultValue: "重置",
            description: "重置按钮标题",
            rule: elmer_ui_core_1.propTypes.string
        },
        backText: {
            defaultValue: "返回",
            description: "返回按钮标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        labelWidth: {
            defaultValue: "100px",
            description: "标签宽度",
            rule: elmer_ui_core_1.propTypes.string
        },
        inlineMode: {
            defaultValue: true,
            description: "同一行显示",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        onSuccess: {
            description: "调起服务成功",
            rule: elmer_ui_core_1.propTypes.func
        },
        onFail: {
            description: "调起服务失败",
            rule: elmer_ui_core_1.propTypes.func
        },
        onBack: {
            description: "点击Back按钮事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        beforeSubmit: {
            description: "提交数据前执行回调",
            rule: elmer_ui_core_1.propTypes.func
        },
        backUrl: {
            defaultValue: "",
            description: "返回按钮地址",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        showBack: {
            defaultValue: false,
            description: "是否显示back按钮",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        },
        showReset: {
            defaultValue: false,
            description: "是否显示重置按钮",
            rule: elmer_ui_core_1.propTypes.boolean.isRequired
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerServiceRequest),
        __metadata("design:type", elmer_ui_core_1.ElmerServiceRequest)
    ], FormComponent.prototype, "ajax", void 0);
    FormComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "form"
        }),
        __metadata("design:paramtypes", [Object])
    ], FormComponent);
    return FormComponent;
}(elmer_ui_core_1.Component));
exports.FormComponent = FormComponent;
