"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormItemComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var emunFormData_1 = require("./emunFormData");
var FormItemComponent = (function (_super) {
    __extends(FormItemComponent, _super);
    function FormItemComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            value: null,
            calendarStyle: "position:fixed;display:none;",
            startDate: "",
            endDate: "",
            showStartDate: false,
            itemStyle: ""
        };
        _this.ajaxLoading = false;
        _this.domID = _this.getRandomID();
        _this.ue = null;
        _this.labelWidth = "width: 100px;";
        _this.itemPaddingLeft = "padding-left: 100px;";
        _this.regionData = [];
        _this.ajaxLoading = props.ajaxLoading;
        _this.state.value = props.value;
        _this.labelWidth = props.labelWidth;
        _this.itemPaddingLeft = props.itemPaddingLeft;
        if (_this.props.zIndex > 0) {
            _this.state.itemStyle = "z-index: " + props.zIndex + ";";
        }
        if (props.type === emunFormData_1.EnumFormItemTypes.DatePeriod || props.type === emunFormData_1.EnumFormItemTypes.Date) {
            if (_this.isObject(props.value)) {
                _this.state.startDate = props.value.startDate || "";
                _this.state.endDate = props.value.endDate || "";
            }
            else {
                var cArr = (props.value || "").split("|");
                if (cArr.length > 0) {
                    _this.state.startDate = cArr[0] || "";
                }
                if (cArr.length > 1) {
                    _this.state.endDate = cArr[1] || "";
                }
            }
        }
        return _this;
    }
    FormItemComponent.prototype.$onPropsChanged = function (newProps) {
        if (newProps.ajaxLoading !== this.ajaxLoading) {
            if (this.props.type === emunFormData_1.EnumFormItemTypes.Editor && this.ue) {
                if (newProps.ajaxLoading) {
                    this.ue.setDisabled("fullscreen");
                }
                else {
                    this.ue.setEnabled();
                }
            }
        }
        this.state.value = newProps.value;
        this.setData({
            ajaxLoading: newProps.ajaxLoading
        }, true);
    };
    FormItemComponent.prototype.beforeInputChange = function (evt) {
        typeof this.props && this.props.onChange === "function" && this.props.onChange({
            id: this.props.id,
            name: this.props.name,
            data: evt.value
        });
        return evt.value;
    };
    FormItemComponent.prototype.getData = function () {
        var myValue = this.state.value;
        if (this.props.type === emunFormData_1.EnumFormItemTypes.Editor && this.ue) {
            myValue = this.ue.getContent();
        }
        else if ([emunFormData_1.EnumFormItemTypes.Upload, emunFormData_1.EnumFormItemTypes.PcRegion, emunFormData_1.EnumFormItemTypes.DropDown].indexOf(this.props.type) >= 0) {
            myValue = this.dom[this.domID].getData();
        }
        else if ([emunFormData_1.EnumFormItemTypes.Input, emunFormData_1.EnumFormItemTypes.Password, emunFormData_1.EnumFormItemTypes.TextArea].indexOf(this.props.type) >= 0) {
            myValue = this.dom[this.domID].value;
        }
        else if (this.props.type === emunFormData_1.EnumFormItemTypes.DatePeriod) {
            myValue = {
                startDate: this.state.startDate,
                endDate: this.state.endDate
            };
        }
        else if (this.props.type === emunFormData_1.EnumFormItemTypes.Date) {
            myValue = this.state.startDate;
        }
        return {
            name: this.props.name,
            value: myValue
        };
    };
    FormItemComponent.prototype.handleOnStartDateClick = function (evt) {
        var target = evt.target;
        var rect = target.getBoundingClientRect();
        var left = rect.left, top = rect.bottom;
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            showStartDate: true,
            calendarDefaultValue: [this.state.startDate],
            calendarStyle: "display:block;position:fixed;left:" + left + "px;top:" + top + "px;z-index:10000;"
        });
    };
    FormItemComponent.prototype.handleOnEndDateClick = function (evt) {
        var target = evt.target;
        var rect = target.getBoundingClientRect();
        var left = rect.left, top = rect.bottom;
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            showStartDate: false,
            calendarDefaultValue: [this.state.endDate],
            calendarStyle: "display:block;position:fixed;left:" + left + "px;top:" + top + "px;z-index:10000;"
        });
    };
    FormItemComponent.prototype.handleOnCalendarChange = function (data) {
        if (this.state.showStartDate) {
            this.setState({
                startDate: data[0] || "",
                calendarStyle: "display:none;"
            });
        }
        else {
            this.setState({
                endDate: data[0] || "",
                calendarStyle: "display:none;"
            });
        }
        typeof this.props.onChange === "function" && this.props.onChange({
            id: this.props.id,
            name: this.props.name,
            isStartDate: this.state.showStartDate,
            data: data
        });
    };
    FormItemComponent.prototype.handleOnCalendarOutClick = function () {
        this.setState({
            calendarStyle: "display:none;"
        });
    };
    FormItemComponent.prototype.handleOnDropdownChanged = function (itemData) {
        this.setState({
            value: itemData.value,
            title: itemData.title
        });
        typeof this.props.onChange === "function" && this.props.onChange({
            id: this.props.id,
            name: this.props.name,
            data: {
                value: itemData.value,
                title: itemData.title
            }
        });
    };
    FormItemComponent.prototype.handleOnPcRegionChange = function (regionData) {
        this.regionData = regionData;
        typeof this.props.onChange === "function" && this.props.onChange({
            id: this.props.id,
            name: this.props.name,
            data: regionData
        });
    };
    FormItemComponent.prototype.render = function () {
        if (this.props.type !== emunFormData_1.EnumFormItemTypes.Hidden) {
            return require("./views/formItem.html");
        }
        else {
            return "";
        }
    };
    FormItemComponent.prototype.reset = function () {
        this.props.value = "";
        this.setState({ value: "" }, true);
        if (this.props.type === emunFormData_1.EnumFormItemTypes.Editor) {
            if (this.ue) {
                this.ue.setContent("");
            }
        }
        else if ([emunFormData_1.EnumFormItemTypes.DropDown, emunFormData_1.EnumFormItemTypes.PcRegion, emunFormData_1.EnumFormItemTypes.Upload].indexOf(this.props.type) >= 0) {
            this.dom[this.domID].reset();
        }
    };
    FormItemComponent.prototype.$after = function () {
        if (this.props.type === emunFormData_1.EnumFormItemTypes.Editor && !this.ue) {
            if (UM) {
                var config = {};
                if (this.props.data && this.props.data.toolbars) {
                    config.toolbars = this.props.data.toolbars;
                }
                this.ue = UM.getEditor(this.domID, config);
                if (this.isObject(this.props.data) && !this.isEmpty(this.props.data.height)) {
                    this.ue.setHeight(this.props.data.height);
                }
                this.ue.setContent(this.state.value || "");
            }
            else {
                console.error("请在header引用UEditor插件");
            }
        }
    };
    FormItemComponent.propType = {
        id: {
            description: "组件ID",
            rule: elmer_ui_core_1.propTypes.string
        },
        name: {
            description: "组件Name",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        title: {
            defaultValue: "",
            description: "标题",
            rule: elmer_ui_core_1.propTypes.string
        },
        placeholder: {
            defaultValue: "",
            description: "PlaceHolder",
            rule: elmer_ui_core_1.propTypes.string
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        labelWidth: {
            defaultValue: "width:100px;",
            description: "标签宽度",
            rule: elmer_ui_core_1.propTypes.string
        },
        layoutTheme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        itemPaddingLeft: {
            defaultValue: "padding-left:100px;",
            description: "标签宽度",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        type: {
            defaultValue: emunFormData_1.EnumFormItemTypes.Input,
            description: "组件类型",
            rule: elmer_ui_core_1.propTypes.oneValueOf(Object.keys(emunFormData_1.EnumFormItemTypes)).isRequired
        },
        ajaxLoading: {
            defaultValue: false,
            description: "form是否正在请求",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        value: {
            defaultValue: "",
            description: "默认值",
            rule: elmer_ui_core_1.propTypes.any
        },
        data: {
            defaultValue: {},
            description: "扩展参数",
            rule: elmer_ui_core_1.propTypes.any
        },
        tabIndex: {
            defaultValue: 0,
            description: "tabIndex",
            rule: elmer_ui_core_1.propTypes.number
        },
        zIndex: {
            defaultValue: 0,
            description: "tabIndex",
            rule: elmer_ui_core_1.propTypes.number
        },
        onChange: {
            description: "部分组件值修改触发事件",
            rule: elmer_ui_core_1.propTypes.func
        }
    };
    FormItemComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "formItem"
        }),
        __metadata("design:paramtypes", [Object])
    ], FormItemComponent);
    return FormItemComponent;
}(elmer_ui_core_1.Component));
exports.FormItemComponent = FormItemComponent;
