import { Component, IElmerMouseEvent, IPropCheckRule } from "elmer-ui-core";
import "./index.less";
export declare type TypeImageViewerData = {
    title?: string;
    url: string;
};
export declare type TypeImageViewerState = {
    data?: TypeImageViewerData[];
    index?: number;
    nextIndex?: number;
    currentData?: TypeImageViewerData;
    nextData?: TypeImageViewerData;
    style?: string;
    currentStyle?: string;
    currentClassName?: string;
    currentTitle?: string;
    nextStyle?: string;
    nextClassName?: string;
    showCurrent?: boolean;
    visible?: boolean;
};
declare type TypeImageViewerProps = {
    data?: TypeImageViewerData[];
    width?: string;
    height?: string;
    style?: string;
    zIndex?: number;
    title?: string;
    visible?: boolean;
    onClose?: Function;
    className?: string;
};
declare type TypeImageViewerPropRules = {
    [P in keyof TypeImageViewerProps]: IPropCheckRule;
};
export default class ImageViewer extends Component {
    static propType: TypeImageViewerPropRules;
    state: TypeImageViewerState;
    props: TypeImageViewerProps;
    containerId: string;
    currentId?: string;
    nextId?: string;
    currentDom?: HTMLImageElement;
    nextDom?: HTMLImageElement;
    private routateLevel;
    private zoomLevel;
    private isGoNext;
    private isAnimationStart;
    private canChangeSize;
    private mousePoint;
    private movePoint;
    private isMouseDown;
    constructor(props: TypeImageViewerProps);
    handleOnContainerMouseDown(evt: IElmerMouseEvent): void;
    handleOnContainerMouseMove(evt: IElmerMouseEvent): void;
    handleOnContainerMouseUp(evt: IElmerMouseEvent): void;
    $onPropsChanged(newProps: TypeImageViewerProps): void;
    $after(): void;
    $didMount(): void;
    $resize(): any;
    onGoPrev(): void;
    onGoNext(): void;
    onImageAnimationEnd(): void;
    onloadImageComplete(): void;
    onZoomIn(): void;
    onZoomOut(): void;
    onReset(): void;
    onRoutateLeft(): void;
    onRoutateRight(): void;
    onClose(): void;
    private sizeStyle;
    private resetStyle;
    private updateStyle;
    private updateTransformStyle;
    private convertStyleToObj;
    private getDefaultStyle;
}
export {};
