"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var ImageViewer = (function (_super) {
    __extends(ImageViewer, _super);
    function ImageViewer(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            data: [],
            style: "",
            currentStyle: "",
            nextStyle: "opacity:0;",
            showCurrent: true,
            index: 0,
            nextIndex: 1,
            visible: true
        };
        _this.routateLevel = 0;
        _this.zoomLevel = 0;
        _this.isGoNext = true;
        _this.isAnimationStart = false;
        _this.canChangeSize = true;
        _this.mousePoint = {
            x: 0,
            y: 0
        };
        _this.movePoint = {
            x: 0,
            y: 0
        };
        _this.isMouseDown = false;
        var data = props.data || [];
        if (data.length < 2 && data.length > 0) {
            data.push(data[0]);
        }
        else {
            if (data.length <= 0) {
                console.error("Please set image datas");
            }
        }
        _this.currentId = _this.guid();
        _this.nextId = _this.guid();
        _this.containerId = _this.guid();
        _this.state.index = 0;
        _this.state.data = data;
        _this.state.currentData = data[0];
        _this.state.nextData = data[1];
        _this.state.style = (props.style || "") + _this.sizeStyle(props.width, props.height, props.zIndex);
        _this.state.visible = props.visible;
        if (_this.state.currentData) {
            _this.state.currentTitle = _this.state.currentData.title;
        }
        return _this;
    }
    ImageViewer.prototype.handleOnContainerMouseDown = function (evt) {
        evt.nativeEvent.preventDefault();
        this.isMouseDown = true;
        this.mousePoint = {
            x: evt.nativeEvent.clientX,
            y: evt.nativeEvent.clientY
        };
    };
    ImageViewer.prototype.handleOnContainerMouseMove = function (evt) {
        evt.nativeEvent.preventDefault();
        if (this.isMouseDown) {
            var posX = evt.nativeEvent.clientX, posY = evt.nativeEvent.clientY;
            this.movePoint = {
                x: posX - this.mousePoint.x + this.movePoint.x,
                y: posY - this.mousePoint.y + this.movePoint.y
            };
            var transValue = "translate3d(" + this.movePoint.x + "px, " + this.movePoint.y + "px, 0)";
            if (this.state.showCurrent) {
                var mcStyle = this.updateStyle(this.state.currentStyle, "transform: " + transValue + ";-webkit-transform: " + transValue + ";");
                this.setState({
                    currentStyle: mcStyle
                });
            }
            else {
                var mcStyle = this.updateStyle(this.state.nextStyle, "transform: " + transValue + ";-webkit-transform: " + transValue + ";");
                this.setState({
                    nextStyle: mcStyle
                });
            }
            this.mousePoint = {
                x: posX,
                y: posY
            };
        }
    };
    ImageViewer.prototype.handleOnContainerMouseUp = function (evt) {
        evt.nativeEvent.preventDefault();
        this.isMouseDown = false;
    };
    ImageViewer.prototype.$onPropsChanged = function (newProps) {
        var updateState = {};
        if (newProps.visible !== this.state.visible) {
            updateState.visible = newProps.visible;
        }
        if (!this.isEqual(newProps.data, this.state.data)) {
            if (newProps.data) {
                if (newProps.data.length === 1) {
                    updateState.data = newProps.data;
                    updateState.data.push(newProps.data[0]);
                }
                else {
                    updateState.data = newProps.data;
                }
                updateState.currentData = newProps.data[0];
                updateState.nextData = newProps.data[1];
            }
            else {
                updateState.data = [];
            }
        }
        if (Object.keys(updateState).length > 0) {
            this.setState(updateState);
        }
    };
    ImageViewer.prototype.$after = function () {
        var _this = this;
        this.addEvent(this, this.dom[this.containerId], "dragstart", function () {
            return false;
        }, {
            passive: false
        });
        this.addEvent(this, document.body, "resize", function () {
            _this.resetStyle();
        });
    };
    ImageViewer.prototype.$didMount = function () {
        this.currentDom = this.dom[this.currentId];
        this.nextDom = this.dom[this.nextId];
        this.resetStyle();
    };
    ImageViewer.prototype.$resize = function () {
        if (this.currentDom && this.nextDom) {
            return this.resetStyle;
        }
    };
    ImageViewer.prototype.onGoPrev = function () {
        if (!this.isAnimationStart) {
            this.isGoNext = true;
            this.isAnimationStart = true;
            if (this.state.showCurrent) {
                this.setState({
                    currentClassName: "animationToLeftHide",
                    nextClassName: "animationToLeftShow",
                    showCurrent: false
                });
            }
            else {
                this.setState({
                    currentClassName: "animationToLeftShow",
                    nextClassName: "animationToLeftHide",
                    showCurrent: true
                });
            }
        }
    };
    ImageViewer.prototype.onGoNext = function () {
        if (!this.isAnimationStart) {
            this.isGoNext = false;
            this.isAnimationStart = true;
            if (this.state.showCurrent) {
                this.setState({
                    currentClassName: "animationToRightHide",
                    nextClassName: "animationToRightShow",
                    showCurrent: false
                });
            }
            else {
                this.setState({
                    nextClassName: "animationToRightHide",
                    currentClassName: "animationToRightShow",
                    showCurrent: true
                });
            }
        }
    };
    ImageViewer.prototype.onImageAnimationEnd = function () {
        this.isAnimationStart = false;
        if (this.state.data.length > 2) {
            var nextData = void 0;
            var offsetIndex = 1;
            if (!this.state.showCurrent) {
                offsetIndex = this.state.nextIndex;
            }
            else {
                offsetIndex = this.state.index;
            }
            if (this.isGoNext) {
                if (offsetIndex + 1 < this.state.data.length) {
                    nextData = this.state.data[offsetIndex + 1];
                    offsetIndex = offsetIndex + 1;
                }
                else {
                    nextData = this.state.data[0];
                    offsetIndex = 0;
                }
            }
            else {
                if (offsetIndex - 1 >= 0) {
                    nextData = this.state.data[offsetIndex - 1];
                    offsetIndex -= 1;
                }
                else {
                    nextData = this.state.data[this.state.data.length - 1];
                    offsetIndex = this.state.data.length - 1;
                }
            }
            this.canChangeSize = true;
            this.zoomLevel = 0;
            if (this.state.showCurrent) {
                this.setState({
                    currentTitle: this.state.currentData.title,
                    nextData: nextData,
                    nextIndex: offsetIndex,
                    currentClassName: "",
                    nextClassName: "",
                    currentStyle: this.updateStyle(this.state.currentStyle, this.getDefaultStyle(true) + "opacity:1;"),
                    nextStyle: this.updateStyle(this.state.nextStyle, this.getDefaultStyle(false) + "opacity:0;")
                });
            }
            else {
                this.setState({
                    currentData: nextData,
                    currentTitle: this.state.nextData.title,
                    index: offsetIndex,
                    currentClassName: "",
                    nextClassName: "",
                    currentStyle: this.updateStyle(this.state.currentStyle, this.getDefaultStyle(false) + "opacity:0;"),
                    nextStyle: this.updateStyle(this.state.nextStyle, this.getDefaultStyle(true) + "opacity:1;")
                });
            }
        }
    };
    ImageViewer.prototype.onloadImageComplete = function () {
        if (this.canChangeSize) {
            this.resetStyle();
            this.canChangeSize = false;
        }
    };
    ImageViewer.prototype.onZoomIn = function () {
        this.zoomLevel += 1;
        var scaleValue = 1 + this.zoomLevel * 0.1;
        var zoomStyle = "transform: scale(" + scaleValue + "," + scaleValue + ");-webkit-transform: scale(" + scaleValue + "," + scaleValue + ");";
        if (this.state.showCurrent) {
            var style = this.updateStyle(this.state.currentStyle, zoomStyle);
            this.setState({
                currentStyle: style
            });
        }
        else {
            var style = this.updateStyle(this.state.nextStyle, zoomStyle);
            this.setState({
                nextStyle: style
            });
        }
    };
    ImageViewer.prototype.onZoomOut = function () {
        this.zoomLevel -= 1;
        var scaleValue = 1 + this.zoomLevel * 0.1;
        scaleValue = scaleValue > 0 ? scaleValue : 0.1;
        var zoomStyle = "transform: scale(" + scaleValue + "," + scaleValue + ");-webkit-transform: scale(" + scaleValue + "," + scaleValue + ");";
        if (this.state.showCurrent) {
            var style = this.updateStyle(this.state.currentStyle, zoomStyle);
            this.setState({
                currentStyle: style
            });
        }
        else {
            var style = this.updateStyle(this.state.nextStyle, zoomStyle);
            this.setState({
                nextStyle: style
            });
        }
    };
    ImageViewer.prototype.onReset = function () {
        this.resetStyle();
    };
    ImageViewer.prototype.onRoutateLeft = function () {
        this.routateLevel -= 90;
        var rotateStyle = "transform: rotateZ(" + this.routateLevel + "deg);-webkit-transform: rotateZ(" + this.routateLevel + "deg);";
        if (this.state.showCurrent) {
            var tStyle = this.updateStyle(this.state.currentStyle, rotateStyle);
            this.setState({
                currentStyle: this.updateStyle(this.state.currentStyle, rotateStyle)
            });
        }
        else {
            this.setState({
                nextStyle: this.updateStyle(this.state.nextStyle, rotateStyle)
            });
        }
    };
    ImageViewer.prototype.onRoutateRight = function () {
        this.routateLevel += 90;
        var rotateStyle = "transform: rotateZ(" + this.routateLevel + "deg);-webkit-transform: rotateZ(" + this.routateLevel + "deg);";
        if (this.state.showCurrent) {
            var tStyle = this.updateStyle(this.state.currentStyle, rotateStyle);
            this.setState({
                currentStyle: tStyle
            });
        }
        else {
            this.setState({
                nextStyle: this.updateStyle(this.state.nextStyle, rotateStyle)
            });
        }
    };
    ImageViewer.prototype.onClose = function () {
        typeof this.props.onClose === "function" && this.props.onClose();
    };
    ImageViewer.prototype.sizeStyle = function (width, height, zIndex) {
        var result = "";
        if (!this.isEmpty(width)) {
            if (this.isNumeric(width)) {
                result += "width:" + width + "px;";
            }
            else {
                result += "width:" + width + ";";
            }
        }
        if (!this.isEmpty(height)) {
            if (this.isNumeric(height)) {
                result += "height:" + height + "px;";
            }
            else {
                result += "height:" + height + ";";
            }
        }
        if (this.isNumeric(zIndex)) {
            result += "z-index: " + zIndex + ";";
        }
        return result;
    };
    ImageViewer.prototype.resetStyle = function () {
        var marginLeft = -this.currentDom.clientWidth / 2;
        var marginTop = -this.currentDom.clientHeight / 2;
        var nextLeft = -this.nextDom.clientWidth / 2;
        var nextTop = -this.nextDom.clientHeight / 2;
        var currentStyle = "margin-left: " + marginLeft + "px;margin-top:" + marginTop + "px;z-index: 1;" + (this.state.showCurrent ? this.getDefaultStyle(true) + "opacity:1;" : this.getDefaultStyle(false) + "opacity:0;");
        var nextStyle = "margin-left: " + nextLeft + "px;margin-top:" + nextTop + "px;z-index: 0;" + (this.state.showCurrent ? this.getDefaultStyle(false) + "opacity:0;" : this.getDefaultStyle(true) + "opacity:1");
        this.setState({
            currentStyle: currentStyle,
            nextStyle: nextStyle
        });
    };
    ImageViewer.prototype.updateStyle = function (styleValue, newStyle) {
        var obj = this.convertStyleToObj(styleValue);
        var newObj = this.convertStyleToObj(newStyle);
        var result = "";
        for (var key in newObj) {
            if (["transform", "-webkit-transform", "-moz-transform", "-ms-transform", "-o-transform"].indexOf(key) < 0) {
                obj[key] = newObj[key];
            }
            else {
                if (!this.isEmpty(newObj[key])) {
                    if (this.isEmpty(obj[key])) {
                        obj[key] = newObj[key];
                    }
                    else {
                        obj[key] = this.updateTransformStyle(obj[key], newObj[key], false);
                    }
                }
            }
        }
        for (var strKey in obj) {
            result += strKey + ":" + obj[strKey] + ";";
        }
        return result;
    };
    ImageViewer.prototype.updateTransformStyle = function (oldValueStr, newValueStr, isRemove) {
        var attrValReg = /\s*([a-z0-9]*\([a-z0-9\-,\s\.]*\))/ig;
        var oldValueArr = oldValueStr.match(attrValReg);
        var newValueArr = newValueStr.match(attrValReg);
        if (oldValueArr && newValueArr) {
            for (var i = 0; i < newValueArr.length; i++) {
                var newValue = newValueArr[i].replace(/^\s*/, "").replace(/\s*$/, "");
                var newKey = newValue.substr(0, newValue.indexOf("("));
                var isFindOldKey = false;
                for (var j = 0; j < oldValueArr.length; j++) {
                    var oldValue = oldValueArr[j].replace(/^\s*/, "").replace(/\s*$/, "");
                    var oldKey = oldValue.substr(0, oldValue.indexOf("("));
                    if (newKey === oldKey) {
                        isFindOldKey = true;
                        if (!isRemove) {
                            oldValueArr[j] = newValue;
                        }
                        else {
                            delete oldValueArr[j];
                        }
                        break;
                    }
                }
                if (!isFindOldKey) {
                    if (!isRemove) {
                        oldValueArr.push(newValue);
                    }
                }
            }
            return oldValueArr.join(" ");
        }
        else if (!oldValueArr && newValueArr) {
            return newValueArr.join(" ");
        }
        else if (oldValueArr && !newValueArr) {
            return oldValueArr.join(" ");
        }
        else {
            return "";
        }
    };
    ImageViewer.prototype.convertStyleToObj = function (str) {
        if (!this.isEmpty(str)) {
            var strArr = str.split(";");
            var strResult = {};
            for (var _i = 0, strArr_1 = strArr; _i < strArr_1.length; _i++) {
                var strItem = strArr_1[_i];
                var lMatch = strItem.match(/^\s*([a-z0-9\-]*)\s*\:/i);
                if (lMatch) {
                    var key = lMatch[1];
                    var value = strItem.replace(/^\s*([a-z0-9\-]*)\s*\:/i, "").replace(/^\s*/, "").replace(/\s*$/, "");
                    strResult[key] = value;
                }
            }
            return strResult;
        }
        else {
            return {};
        }
    };
    ImageViewer.prototype.getDefaultStyle = function (show) {
        var initValue = "scale(1,1) rotateZ(0deg)";
        if (show) {
            initValue += " translate3d(0,0,0)";
        }
        else {
            initValue += " translate3d(100%,0,0)";
        }
        return "transform: " + initValue + ";-webkit-transform: " + initValue + ";";
    };
    ImageViewer.propType = {
        data: {
            description: "图片数据",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        width: {
            description: "宽度",
            defaultValue: "100%",
            rule: elmer_ui_core_1.PropTypes.string
        },
        height: {
            description: "高度",
            defaultValue: "100%",
            rule: elmer_ui_core_1.PropTypes.string
        },
        style: {
            description: "样式",
            defaultValue: "position:fixed;left:0;top:0;",
            rule: elmer_ui_core_1.PropTypes.string
        },
        zIndex: {
            description: "zIndex",
            defaultValue: 10001,
            rule: elmer_ui_core_1.PropTypes.number
        },
        title: {
            description: "标题",
            defaultValue: "Image Viewer",
            rule: elmer_ui_core_1.PropTypes.string
        },
        visible: {
            description: "显示隐藏",
            defaultValue: true,
            rule: elmer_ui_core_1.PropTypes.bool.isRequired
        },
        onClose: {
            description: "关闭按钮事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        className: {
            description: "样式",
            defaultValue: "AniZoomIn",
            rule: elmer_ui_core_1.PropTypes.string
        }
    };
    ImageViewer = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "ImageViewer",
            template: {
                url: "./index.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], ImageViewer);
    return ImageViewer;
}(elmer_ui_core_1.Component));
exports.default = ImageViewer;
