"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LayoutRow = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var LayoutRow = (function (_super) {
    __extends(LayoutRow, _super);
    function LayoutRow(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            theme: "",
            setHeight: ""
        };
        _this.state.theme = !_this.isEmpty(props.theme) ? props.theme : "";
        _this.state.setHeight = props.setHeight || "";
        return _this;
    }
    LayoutRow.prototype.$before = function () {
        this.updateChildrenSetSize();
    };
    LayoutRow.prototype.render = function () {
        var cHeight = this.state.setHeight || "";
        var innerStyle = this.props.style || "";
        cHeight = !/\;/.test(cHeight) && cHeight.length > 0 ? cHeight + ";" + innerStyle : cHeight + innerStyle;
        return "<div class=\"{{state.theme}} eui-layout-row\" style=\"" + cHeight + "\"><context /></div>";
    };
    LayoutRow.prototype.$onPropsChanged = function (props) {
        this.setState({}, true);
    };
    LayoutRow.prototype.updateChildrenSetSize = function () {
        try {
            var children = this.props.children || [];
            var colAllWidth = [], rowAllHeight = [];
            var colAutoWidth = false, colAutoWidthIndex = -1;
            var colAutoHeight = false, colAutoHeightIndex = -1;
            for (var i = 0, cLen = children.length; i < cLen; i++) {
                var tmpNode = children[i];
                if (tmpNode.tagName === "eui-layout-col") {
                    if (/^\s*\*\s*$/.test(tmpNode.props.width)) {
                        if (colAutoWidth) {
                            throw new Error("自适应宽度col只能设置一个元素");
                        }
                        colAutoWidth = true;
                        colAutoWidthIndex = i;
                    }
                    else {
                        var tmpColWidth = this.isNumeric(tmpNode.props.width) ? tmpNode.props.width + "px" : tmpNode.props.width;
                        colAllWidth.push(tmpColWidth);
                        children[i].props.setWidth = "width:" + tmpColWidth + ";";
                    }
                }
                else if (tmpNode.tagName === "eui-layout-row") {
                    if (/^\s*\*\s*$/.test(tmpNode.props.height)) {
                        if (colAutoHeight) {
                            throw new Error("自适应高度row只能设置一个元素");
                        }
                        colAutoHeight = true;
                        colAutoHeightIndex = i;
                    }
                    else {
                        var tmpColHeight = this.isNumeric(tmpNode.props.height) ? tmpNode.props.height + "px" : tmpNode.props.height;
                        rowAllHeight.push(tmpColHeight);
                        children[i].props.setHeight = "height: " + tmpColHeight + ";";
                    }
                }
            }
            if (colAutoWidth && colAutoWidthIndex >= 0 && colAutoWidthIndex < children.length) {
                var calcWidth = "calc(100% - " + colAllWidth.join(" - ") + ")";
                children[colAutoWidthIndex].props.setWidth = "width:" + calcWidth + ";width:-webkit-" + calcWidth + ";width:-moz-" + calcWidth + ";width:-ms-" + calcWidth + ";";
            }
            if (colAutoHeight && colAutoHeightIndex >= 0 && colAutoHeightIndex < children.length) {
                var calcHeight = "calc(100% - " + rowAllHeight.join(" - ") + ")";
                children[colAutoHeightIndex].props.setHeight = "height:" + calcHeight + ";height:-webkit-" + calcHeight + ";height:-moz-" + calcHeight + ";height:-ms-" + calcHeight + ";";
            }
        }
        catch (e) {
            console.error(e);
        }
    };
    LayoutRow.propTypes = {
        theme: {
            defaultValue: "",
            description: "类名",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        height: {
            defaultValue: "",
            description: "高度",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        style: {
            defaultValue: "",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        }
    };
    LayoutRow = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "layout-row"
        }),
        __metadata("design:paramtypes", [Object])
    ], LayoutRow);
    return LayoutRow;
}(elmer_ui_core_1.Component));
exports.LayoutRow = LayoutRow;
