"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.showLoading = exports.Loading = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./loadingIcon");
require("./style.less");
var Loading = (function (_super) {
    __extends(Loading, _super);
    function Loading(props) {
        var _this = _super.call(this, props) || this;
        _this.type = "style1";
        _this.style1Visible = true;
        _this.style2Visible = false;
        _this.style3Visible = false;
        _this.style4Visible = false;
        _this.style5Visible = false;
        _this.style6Visible = false;
        _this.style7Visible = false;
        _this.style8Visible = false;
        _this.visible = true;
        _this.title = "loading";
        _this.titleVisible = true;
        _this.type = props.type || "style1";
        _this.visible = props.visible;
        _this.title = props.title || "loading";
        _this.titleVisible = props.titleVisible;
        _this.style1Visible = false;
        _this[_this.type + "Visible"] = true;
        return _this;
    }
    Loading.prototype.$onPropsChanged = function (newProps) {
        var updateState = {};
        if (!this.isEmpty(newProps.visible)) {
            updateState.visible = newProps.visible;
        }
        if (!this.isEmpty(newProps.titleVisible)) {
            updateState.titleVisible = newProps.titleVisible;
        }
        if (!this.isEmpty(newProps.title)) {
            updateState.title = newProps.title;
        }
        if (!this.isEmpty(newProps.type)) {
            this[newProps.type + "Visible"] = true;
        }
        this.setData(updateState);
    };
    Loading.prototype.render = function () {
        return require("./index.html");
    };
    Loading.propType = {
        percent: {
            description: "进度",
            rule: elmer_ui_core_1.propTypes.number
        },
        title: {
            defaultValue: "loading",
            description: "标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        type: {
            defaultValue: "style1",
            description: "icon样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        titleVisible: {
            defaultValue: true,
            description: "是否显示标题",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        visible: {
            defaultValue: true,
            description: "显示Loading",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        }
    };
    Loading = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "Loading"
        }),
        __metadata("design:paramtypes", [Object])
    ], Loading);
    return Loading;
}(elmer_ui_core_1.Component));
exports.Loading = Loading;
var showLoading = function (options) {
    var config = {
        type: "style2",
        title: "Loading...",
        showTitle: true,
        visible: true
    };
    var ui = elmer_ui_core_1.getUI();
    var obj = {
        options: null
    };
    var parent = document.createElement("div");
    ui.extend(config, options);
    obj.options = config;
    var objRender = ui.render(parent, "<eui-loading titleVisible='{{options.showTitle}}' title='{{options.title}}' type='{{options.type}}' visible='{{options.visible}}'/>", obj);
    document.body.appendChild(parent);
    return {
        show: function () {
            var cp = JSON.parse(JSON.stringify(config));
            cp.visible = true;
            obj.setData({ options: cp });
        },
        hide: function () {
            var cp = JSON.parse(JSON.stringify(config));
            cp.visible = false;
            obj.setData({ options: cp });
        },
        dispose: function () {
            objRender.dispose();
            parent && parent.parentElement && parent.parentElement.removeChild(parent);
            parent = null;
            objRender = null;
            obj = null;
            ui = null;
            config = null;
        },
        setTitle: function (title) {
            var cp = JSON.parse(JSON.stringify(config));
            cp.title = title;
            obj.setData({
                options: cp
            });
        }
    };
};
exports.showLoading = showLoading;
elmerData["showLoading"] = exports.showLoading;
