"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContentMenu = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./ContentMenuItem");
require("./style.less");
var ContentMenu = (function (_super) {
    __extends(ContentMenu, _super);
    function ContentMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.data = [];
        _this.visible = false;
        _this.data = props.data || [];
        return _this;
    }
    ContentMenu.prototype.$onPropsChanged = function (newProps) {
        if (JSON.stringify(newProps.data) !== JSON.stringify(this.data) || newProps.visible !== this.visible) {
            this.setData({
                data: JSON.parse(JSON.stringify(newProps.data || [])),
                visible: newProps.visible
            }, true);
        }
    };
    ContentMenu.prototype.handleOnContextClick = function (event) {
        event.nativeEvent.cancelBubble = true;
        event.nativeEvent.stopPropagation();
    };
    ContentMenu.prototype.handleOnMenuItemClick = function (event) {
        event.nativeEvent.cancelBubble = true;
        event.nativeEvent.stopPropagation();
        typeof this.props.onItemClick === "function" && this.props.onItemClick(event);
    };
    ContentMenu.prototype.handleOnMouseDown = function (event) {
        event.nativeEvent.cancelBubble = true;
        event.nativeEvent.stopPropagation();
        event.nativeEvent.preventDefault();
        return false;
    };
    ContentMenu.prototype.render = function () {
        return require("./views/ContentMenu.html");
    };
    ContentMenu.propType = {
        data: {
            defaultValue: [],
            description: "数据源",
            propertyKey: "data",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        onItemClick: {
            description: "菜单项单击事件",
            propertyKey: "data",
            rule: elmer_ui_core_1.propTypes.func
        },
        style: {
            defaultValue: "",
            description: "内联样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        visible: {
            defaultValue: false,
            description: "是否显示",
            propertyKey: "visible",
            rule: elmer_ui_core_1.propTypes.boolean
        }
    };
    ContentMenu = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "contentMenu"
        }),
        __metadata("design:paramtypes", [Object])
    ], ContentMenu);
    return ContentMenu;
}(elmer_ui_core_1.Component));
exports.ContentMenu = ContentMenu;
