"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContentMenuItem = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var EContentMenu_1 = require("./EContentMenu");
require("./style.less");
var ContentMenuItem = (function (_super) {
    __extends(ContentMenuItem, _super);
    function ContentMenuItem(props) {
        var _this = _super.call(this, props) || this;
        _this.typeTheme = "";
        _this.data = JSON.parse(JSON.stringify(props.data || {}));
        return _this;
    }
    ContentMenuItem.prototype.$onPropsChanged = function (newProps) {
        if (JSON.stringify(newProps.data) !== JSON.stringify(this.data)) {
            this.setData({
                data: JSON.parse(JSON.stringify(newProps.data || {}))
            }, true);
        }
    };
    ContentMenuItem.prototype.onItemClick = function (myEvent) {
        myEvent.nativeEvent.cancelBubble = true;
        myEvent.nativeEvent.stopPropagation();
        myEvent.nativeEvent.preventDefault();
        var hasChildren = this.data && this.data.children && this.data.children.length > 0;
        if (!hasChildren) {
            myEvent.data = this.data;
            typeof this.props.click === "function" && this.props.click(myEvent);
        }
    };
    ContentMenuItem.propType = {
        click: {
            defaultValue: null,
            description: "单击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        data: {
            defaultValue: {},
            description: "菜单数据",
            propertyKey: "data",
            rule: elmer_ui_core_1.propTypes.any
        },
        icon: {
            defaultValue: "",
            description: "菜单图标",
            rule: elmer_ui_core_1.propTypes.string
        },
        value: {
            defaultValue: "",
            description: "菜单值",
            rule: elmer_ui_core_1.propTypes.any
        },
        title: {
            defaultValue: "菜单项",
            description: "菜单标题",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.number, elmer_ui_core_1.propTypes.string]).isRequired
        },
        type: {
            defaultValue: EContentMenu_1.EnumContentMenuItemType.NormalText,
            description: "菜单项类型",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
    };
    ContentMenuItem = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "contentMenuItem",
            template: {
                url: "./views/ContentMenuItem.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], ContentMenuItem);
    return ContentMenuItem;
}(elmer_ui_core_1.Component));
exports.ContentMenuItem = ContentMenuItem;
