import { Component, IElmerEvent, IPropCheckRule } from "elmer-ui-core";
import "./index.less";
declare type MobileSelectProps = {
    cancelText: string;
    data: any[];
    defaultValue: any[];
    okText: string;
    onCancel: Function;
    onChange: Function;
    onClose: Function;
    onOk: Function;
    placeHolder: any;
    title: string;
    visible: boolean;
    zIndex: number;
    showSearch: boolean;
    searchPlaceHolder: string;
};
declare type MobileSelectPropsRule = {
    [P in keyof MobileSelectProps]: IPropCheckRule;
};
export declare class MobileSelector extends Component<MobileSelectProps> {
    static propType: MobileSelectPropsRule;
    searchPlaceHolder: string;
    title: string;
    cancelText: string;
    okText: string;
    private visible;
    private isFirstRender;
    private domID;
    private contentID;
    private listID;
    private focustID;
    private maskShowAnimation;
    private contentShowAnimation;
    private maskHiddenAnimation;
    private contentHiddenAnimation;
    private onClose;
    private data;
    private sourceData;
    private contentHeight;
    private itemHeight;
    private selectedIndexs;
    private displayIndexs;
    private isPressed;
    private listWidth;
    private showSearch;
    private mouseEventObj;
    private mouseEventElement;
    private onChangeData;
    private $;
    constructor(props: any);
    $willReceiveProps(newProps: any): void;
    $didUpdate(): void;
    $didMount(): void;
    $dispose(): void;
    render(): string;
    handleOnListMouseDown(evt: IElmerEvent): void;
    handleOnSearchTouch(event: IElmerEvent): void;
    handleOnSearchClick(event: Event): void;
    handleSearch(event: IElmerEvent): void;
    handleOnSearchKeyPress(event: IElmerEvent): void;
    handleOnCancelClick(): void;
    handleOnOkClick(): void;
    handleOnMaskClick(): void;
    handleOnContentClick(event: IElmerEvent): void;
    handleOnMaskAnimationEnd(event: AnimationEvent): void;
    handleOnBodyMouseDown(event: MouseEvent): void;
    handleOnBodyTouchStart(event: TouchEvent): void;
    handleOnBodyMouseMove(event: MouseEvent): void;
    handleOnBodyTouchMove(event: TouchEvent): void;
    handleOnBodyMouseUp(event: MouseEvent, {}: any, target: any): void;
    handleOnBodyTouchEnd(event: IElmerEvent): void;
    private handleOnMoveEndEvent;
    private handleOnMoveEvent;
    private handleOnPressEvent;
    private scrollTo;
    private setVisible;
}
export {};
