"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MobileSelector = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var MobileSelector = (function (_super) {
    __extends(MobileSelector, _super);
    function MobileSelector(props) {
        var _this = _super.call(this, props) || this;
        _this.cancelText = "取消";
        _this.okText = "确定";
        _this.visible = false;
        _this.isFirstRender = false;
        _this.domID = _this.getRandomID();
        _this.contentID = _this.getRandomID();
        _this.listID = _this.getRandomID();
        _this.focustID = _this.getRandomID();
        _this.maskShowAnimation = "euiMobileSelectMaskShowAni";
        _this.contentShowAnimation = "euiMobileSelectShowAni";
        _this.maskHiddenAnimation = "euiMobileSelectMaskHiddenAni";
        _this.contentHiddenAnimation = "euiMobileSelectHiddenAni";
        _this.data = [];
        _this.sourceData = [];
        _this.contentHeight = 0;
        _this.itemHeight = 0;
        _this.selectedIndexs = [];
        _this.displayIndexs = [];
        _this.isPressed = false;
        _this.listWidth = "100%";
        _this.showSearch = true;
        _this.onChangeData = {};
        _this.cancelText = props.cancelText;
        _this.visible = props.visible;
        _this.onClose = props.onClose;
        _this.data = props.data || [];
        _this.okText = props.okText;
        _this.showSearch = props.showSearch;
        _this.searchPlaceHolder = props.searchPlaceHolder;
        _this.selectedIndexs = props.defaultValue || [0];
        _this.displayIndexs = props.defaultValue || [0];
        _this.listWidth = (_this.data.length > 0 ? (1 / _this.data.length * 100) : 100) + "%";
        _this.sourceData = _this.data;
        _this.title = props.title || "";
        return _this;
    }
    MobileSelector.prototype.$willReceiveProps = function (newProps) {
        if (newProps.visible !== this.visible) {
            this.visible = newProps.visible;
            this.setVisible();
        }
        if (JSON.stringify(newProps.data) !== JSON.stringify(this.sourceData)) {
            var newData = newProps.data || [];
            var selectedIndexData = [];
            for (var i = 0; i < newData.length; i++) {
                if (JSON.stringify(newData[i]) !== JSON.stringify(this.sourceData[i])) {
                    selectedIndexData[i] = 0;
                }
                else {
                    selectedIndexData[i] = this.displayIndexs[i] || 0;
                }
            }
            this.displayIndexs = selectedIndexData;
            this.sourceData = newData;
            this.setData({
                data: newData
            });
        }
    };
    MobileSelector.prototype.$didUpdate = function () {
        if (!this.isFirstRender) {
            if (this.visible) {
                this.setVisible();
            }
        }
    };
    MobileSelector.prototype.$didMount = function () {
        this.$.on(document.body, "mousedown", this.handleOnBodyMouseDown.bind(this));
        this.$.on(document.body, "touchstart", this.handleOnBodyTouchStart.bind(this));
        this.$.on(document.body, "mouseup", this.handleOnBodyMouseUp.bind(this));
        this.$.on(document.body, "touchend", this.handleOnBodyTouchEnd.bind(this));
        this.$.on(document.body, "mousemove", this.handleOnBodyMouseMove.bind(this));
        this.$.on(document.body, "touchmove", this.handleOnBodyTouchMove.bind(this));
    };
    MobileSelector.prototype.$dispose = function () {
        this.$.removeEvent(document.body, "mousedown", this.handleOnBodyMouseDown.bind(this));
        this.$.removeEvent(document.body, "touchstart", this.handleOnBodyTouchStart.bind(this));
        this.$.removeEvent(document.body, "mouseup", this.handleOnBodyMouseUp.bind(this));
        this.$.removeEvent(document.body, "touchend", this.handleOnBodyTouchEnd.bind(this));
        this.$.removeEvent(document.body, "mousemove", this.handleOnBodyMouseMove.bind(this));
        this.$.removeEvent(document.body, "touchmove", this.handleOnBodyTouchMove.bind(this));
    };
    MobileSelector.prototype.render = function () {
        return require("./index.html");
    };
    MobileSelector.prototype.handleOnListMouseDown = function (evt) {
        this.isPressed = true;
        this.mouseEventElement = evt.target;
    };
    MobileSelector.prototype.handleOnSearchTouch = function (event) {
        event.target.firstChild.focus();
    };
    MobileSelector.prototype.handleOnSearchClick = function (event) {
        event.target.focus();
    };
    MobileSelector.prototype.handleSearch = function (event) {
        var sourceData = JSON.parse(JSON.stringify(this.sourceData[0] || []));
        var searchValue = event.target.value || "";
        var result = [];
        if (!this.isEmpty(searchValue)) {
            for (var key in sourceData) {
                var tmpData = sourceData[key];
                if ((tmpData.title || "").indexOf(searchValue) >= 0) {
                    result.push(tmpData);
                }
            }
            if (result.length <= 0) {
                var placeHolder = this.props.placeHolder;
                var placeHolderText = this.isArray(placeHolder) ? placeHolder[0] : placeHolder;
                result.push({
                    title: placeHolderText,
                    value: -1
                });
            }
            this.setData({
                data: [result],
                displayIndexs: [0],
                selectedIndexs: [0]
            });
        }
        else {
            this.setData({
                data: [sourceData],
                displayIndexs: [0],
                selectedIndexs: [0]
            });
        }
        result = null;
        searchValue = null;
        sourceData = null;
    };
    MobileSelector.prototype.handleOnSearchKeyPress = function (event) {
        if (event.nativeEvent.keyCode === 13 && this.showSearch) {
            this.handleSearch(event);
        }
    };
    MobileSelector.prototype.handleOnCancelClick = function () {
        this.visible = false;
        this.setVisible();
        typeof this.props.onCancel === "function" && this.props.onCancel();
    };
    MobileSelector.prototype.handleOnOkClick = function () {
        this.visible = false;
        this.selectedIndexs = this.displayIndexs || [];
        this.setVisible();
        var checkedData = [];
        for (var i = 0; i < this.displayIndexs.length; i++) {
            if (this.data[i]) {
                checkedData.push(this.data[i][this.displayIndexs[i]]);
            }
        }
        typeof this.props.onOk === "function" && this.props.onOk({
            selectedIndex: this.displayIndexs,
            selectedItems: checkedData
        });
    };
    MobileSelector.prototype.handleOnMaskClick = function () {
        this.visible = false;
        this.setVisible();
    };
    MobileSelector.prototype.handleOnContentClick = function (event) {
        event.nativeEvent.cancelBubble = true;
        event.nativeEvent.stopPropagation();
        event.nativeEvent.stopImmediatePropagation();
    };
    MobileSelector.prototype.handleOnMaskAnimationEnd = function (event) {
        var dom = this.dom[this.domID];
        if (!this.visible && event.target === dom) {
            this.$.attr(dom, "style", "display:none;z-index:" + this.props.zIndex + ";");
            this.isFunction(this.onClose) && this.onClose();
        }
        dom = null;
    };
    MobileSelector.prototype.handleOnBodyMouseDown = function (event) {
        this.mouseEventElement && this.visible && this.handleOnPressEvent(event.clientX, event.clientY, this.mouseEventElement);
    };
    MobileSelector.prototype.handleOnBodyTouchStart = function (event) {
        this.mouseEventElement && this.visible && this.handleOnPressEvent(event.touches[0].clientX, event.touches[0].clientY, this.mouseEventElement);
    };
    MobileSelector.prototype.handleOnBodyMouseMove = function (event) {
        this.mouseEventElement && this.visible && this.handleOnMoveEvent(event.clientX, event.clientY, this.mouseEventElement);
    };
    MobileSelector.prototype.handleOnBodyTouchMove = function (event) {
        this.mouseEventElement && this.visible && this.handleOnMoveEvent(event.touches[0].clientX, event.touches[0].clientY, this.mouseEventElement);
    };
    MobileSelector.prototype.handleOnBodyMouseUp = function (event, _a, target) {
        this.mouseEventElement && this.visible && this.handleOnMoveEndEvent(target);
    };
    MobileSelector.prototype.handleOnBodyTouchEnd = function (event) {
        this.mouseEventElement && this.visible && this.handleOnMoveEndEvent(event.target);
    };
    MobileSelector.prototype.handleOnMoveEndEvent = function (target) {
        this.isPressed = false;
        if (this.mouseEventObj.obj) {
            var offsetY = this.$.attr(this.mouseEventObj.obj, "offsety");
            var offsetTop = (this.contentHeight - this.itemHeight) / 2;
            var scrollHeight = this.mouseEventObj.obj.clientHeight;
            var key = this.$.attr(this.mouseEventObj.obj, "data-key");
            offsetY = !isNaN(offsetY) ? parseFloat(offsetY) : 0;
            key = !isNaN(key) ? parseInt(key, 10) : 0;
            if (offsetY > offsetTop) {
                this.scrollTo(this.mouseEventObj.obj, offsetTop);
                this.displayIndexs[key] = 0;
            }
            else if (Math.abs(offsetY - offsetTop) >= scrollHeight) {
                this.scrollTo(this.mouseEventObj.obj, offsetTop - (scrollHeight - this.itemHeight));
                this.displayIndexs[key] = this.mouseEventObj.obj.children.length - 1;
            }
            else {
                var offsetLen = parseInt(((offsetY - offsetTop) / this.itemHeight).toString(), 10);
                offsetLen = Math.abs(offsetLen);
                if (offsetLen * this.itemHeight > Math.abs(offsetY - offsetTop)) {
                    offsetLen = offsetLen - 1 >= 0 ? offsetLen - 1 : 0;
                }
                else {
                    offsetLen = offsetLen + 1 < this.mouseEventObj.obj.children.length ? offsetLen + 1 : this.mouseEventObj.obj.children.length - 1;
                }
                this.scrollTo(this.mouseEventObj.obj, offsetTop - offsetLen * this.itemHeight);
                this.displayIndexs[key] = offsetLen;
            }
            var checkedData = [];
            for (var i = 0; i < this.displayIndexs.length; i++) {
                if (this.data[i]) {
                    checkedData.push(this.data[i][this.displayIndexs[i]]);
                }
            }
            this.onChangeData = {
                selectedIndex: this.displayIndexs,
                selectedItems: checkedData
            };
            typeof this.props.onChange === "function" && this.props.onChange(this.onChangeData);
            offsetTop = null;
            scrollHeight = null;
        }
    };
    MobileSelector.prototype.handleOnMoveEvent = function (x, y, target) {
        if (this.isPressed) {
            var mouseY = this.mouseEventObj.y;
            var offsetY = this.$.attr(this.mouseEventObj.obj, "offsety");
            offsetY = !isNaN(offsetY) ? parseFloat(offsetY) : 0;
            var lastY = offsetY + (y - mouseY);
            this.scrollTo(this.mouseEventObj.obj, lastY);
            this.mouseEventObj.x = x;
            this.mouseEventObj.y = y;
            lastY = null;
            mouseY = null;
            offsetY = null;
        }
    };
    MobileSelector.prototype.handleOnPressEvent = function (x, y, target) {
        var cLen = target.children.length;
        if (cLen > 0) {
            var itemWidth = Math.ceil(target.clientWidth / cLen);
            var itemIndex = 0;
            for (var i = 0; i < cLen; i++) {
                if (i * itemWidth <= x && x < (i + 1) * itemWidth) {
                    itemIndex = i;
                    break;
                }
            }
            this.isPressed = true;
            this.mouseEventObj = {
                x: x,
                y: y,
                obj: target.children[itemIndex],
                index: itemIndex
            };
        }
    };
    MobileSelector.prototype.scrollTo = function (dom, offsetY) {
        var oldOffsetY = this.$.attr(dom, "offsety");
        var offsetCode = this.$.getCss3("transform", "translate3d(0," + offsetY + "px,0)");
        offsetCode += "width:" + this.listWidth + ";";
        oldOffsetY = this.isNumeric(oldOffsetY) && /^[0-9]*$/.test(oldOffsetY) ? parseInt(oldOffsetY, 10) : 0;
        this.$.attr(dom, "style", offsetCode);
        this.$.attr(dom, "offsety", offsetY);
        offsetCode = null;
    };
    MobileSelector.prototype.setVisible = function () {
        var dom = this.dom[this.domID];
        var content = this.dom[this.contentID];
        var listDom = this.dom[this.listID];
        var focustDom = this.dom[this.focustID];
        var $ = this.$;
        if (dom && content) {
            if (this.visible) {
                $.attr(dom, "style", "display:block;z-index:" + this.props.zIndex + ";");
                $.addClass(dom, this.maskShowAnimation);
                $.addClass(content, this.contentShowAnimation);
                $.removeClass(dom, this.maskHiddenAnimation);
                $.removeClass(content, this.contentHiddenAnimation);
                if (listDom) {
                    var itemHeight = focustDom.offsetHeight;
                    var offsetTop = (listDom.clientHeight - itemHeight) / 2;
                    var itemLen = this.sourceData.length > 0 ? this.sourceData.length : 1;
                    this.contentHeight = listDom.clientHeight;
                    this.itemHeight = itemHeight;
                    var index = 0;
                    this.listWidth = parseInt((1 / itemLen * 100).toString(), 10) + "%";
                    for (var i = 0; i < listDom.children.length; i++) {
                        var tmpUl = listDom.children[i];
                        if (tmpUl.tagName === "UL") {
                            var selectedIndex = this.displayIndexs[index] || 0;
                            this.scrollTo(tmpUl, offsetTop - itemHeight * selectedIndex);
                            this.$.css(tmpUl, {
                                width: this.listWidth
                            });
                            index += 1;
                        }
                    }
                }
            }
            else {
                $.addClass(dom, this.maskHiddenAnimation);
                $.addClass(content, this.contentHiddenAnimation);
                $.removeClass(dom, this.maskShowAnimation);
                $.removeClass(content, this.contentShowAnimation);
            }
        }
        $ = null;
        dom = null;
        content = null;
        listDom = null;
        focustDom = null;
    };
    MobileSelector.propType = {
        cancelText: {
            defaultValue: "取消",
            description: "取消按钮文本",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        data: {
            defaultValue: [],
            description: "数据源",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        defaultValue: {
            defaultValue: [0],
            description: "默认选择的值",
            rule: elmer_ui_core_1.propTypes.array
        },
        okText: {
            defaultValue: "确定",
            description: "确定按钮文本",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        onCancel: {
            description: "取消事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onChange: {
            description: "选择变化触发事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onClose: {
            description: "关闭事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        onOk: {
            description: "确定事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        placeHolder: {
            defaultValue: "请选择",
            description: "没有值时的选择",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.array])
        },
        title: {
            defaultValue: "请选择",
            description: "标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        visible: {
            defaultValue: false,
            description: "是否显示",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        zIndex: {
            defaultValue: 1000,
            description: "显示位置",
            rule: elmer_ui_core_1.propTypes.number
        },
        showSearch: {
            defaultValue: false,
            description: "显示搜索框",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        searchPlaceHolder: {
            defaultValue: "请输入搜索内容",
            description: "输入框placeholder",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], MobileSelector.prototype, "$", void 0);
    MobileSelector = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "MobileSelect"
        }),
        __metadata("design:paramtypes", [Object])
    ], MobileSelector);
    return MobileSelector;
}(elmer_ui_core_1.Component));
exports.MobileSelector = MobileSelector;
