import { Component, IElmerEvent, IPropCheckRule } from "elmer-ui-core";
import "./index.less";
declare type TypeKeyboardNumberProps = {
    title?: string;
    btnCloseText?: string;
    btnConfirmText?: string;
    copyRight?: string;
    showClose?: boolean;
    showConfirm?: boolean;
    showAnimation?: string;
    hideAnimation?: string;
    visible?: boolean;
    onChange?: Function;
    onClose?: Function;
    onConfirm?: Function;
};
declare type TypeKeyboardNumberPropsRule = {
    [P in keyof TypeKeyboardNumberProps]: IPropCheckRule;
};
export default class NumberKeyboard extends Component {
    static propType: TypeKeyboardNumberPropsRule;
    state: any;
    props: TypeKeyboardNumberProps;
    private isConfirmClick;
    private isShowAnimation;
    private hiddenClassName;
    constructor(props: TypeKeyboardNumberProps);
    onConfirm(): void;
    onItemClick(evt: IElmerEvent): void;
    $onPropsChanged(newProps: TypeKeyboardNumberProps): void;
    onAnimationEnd(): void;
    hide(): void;
    show(): void;
}
declare type TypeCreateKeyboardNumberOptions = TypeKeyboardNumberProps & {
    filter?: any;
};
declare type TypeCreateKeyboardNumberForamtParams = {
    inputValue: string;
    saveValue: string;
    isInit?: boolean;
    cursorPosition?: number;
};
declare type TypeCreateKeyboardNumberOwner = {
    dispose(): void;
    show(): void;
    hide(): void;
    formatInput(options: TypeCreateKeyboardNumberForamtParams): string;
};
export declare const createKeyboardNumber: (options: TypeCreateKeyboardNumberOptions) => TypeCreateKeyboardNumberOwner;
export {};
