"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createKeyboardNumber = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var NumberKeyboard = (function (_super) {
    __extends(NumberKeyboard, _super);
    function NumberKeyboard(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            currentAnimation: ""
        };
        _this.isConfirmClick = false;
        _this.hiddenClassName = "keyBoardHidden";
        if (props.visible) {
            _this.isShowAnimation = true;
            _this.state.currentAnimation = props.showAnimation;
        }
        else {
            _this.isShowAnimation = false;
            _this.state.currentAnimation = _this.hiddenClassName;
        }
        return _this;
    }
    NumberKeyboard.prototype.onConfirm = function () {
        this.isConfirmClick = true;
        this.hide();
    };
    NumberKeyboard.prototype.onItemClick = function (evt) {
        typeof this.props.onChange === "function" && this.props.onChange(evt.dataSet.value);
    };
    NumberKeyboard.prototype.$onPropsChanged = function (newProps) {
        if (this.isShowAnimation !== newProps.visible) {
            if (newProps.visible) {
                this.show();
            }
            else {
                this.hide();
            }
        }
    };
    NumberKeyboard.prototype.onAnimationEnd = function () {
        if (this.isShowAnimation) {
            this.setState({
                currentAnimation: ""
            });
        }
        else {
            this.setState({
                currentAnimation: this.hiddenClassName
            });
            if (this.isConfirmClick) {
                typeof this.onConfirm === "function" && this.onConfirm();
            }
            else {
                typeof this.props.onClose === "function" && this.props.onClose();
            }
        }
    };
    NumberKeyboard.prototype.hide = function () {
        if (this.isShowAnimation) {
            this.isShowAnimation = false;
            this.setState({
                currentAnimation: this.props.hideAnimation
            });
        }
        else {
            typeof this.props.onClose === "function" && this.props.onClose();
        }
    };
    NumberKeyboard.prototype.show = function () {
        this.isShowAnimation = true;
        this.setState({
            currentAnimation: this.props.showAnimation
        });
    };
    NumberKeyboard.propType = {
        title: {
            description: "Keyboard panel title",
            defaultValue: "",
            rule: elmer_ui_core_1.PropTypes.string
        },
        btnCloseText: {
            description: "close button title",
            defaultValue: "取消",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        btnConfirmText: {
            description: "confirm button title",
            defaultValue: "完成",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        copyRight: {
            description: "copyright string",
            defaultValue: "CopyRight ©️ Elmer S J Mo",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        showClose: {
            description: "是否显示取消按钮",
            defaultValue: true,
            rule: elmer_ui_core_1.PropTypes.bool
        },
        showConfirm: {
            description: "是否显示完成按钮",
            defaultValue: true,
            rule: elmer_ui_core_1.PropTypes.bool
        },
        showAnimation: {
            description: "显示动画键盘样式",
            defaultValue: "showKeyboardAnimation",
            rule: elmer_ui_core_1.PropTypes.string
        },
        hideAnimation: {
            description: "显示动画键盘样式",
            defaultValue: "hideKeyboardAnimation",
            rule: elmer_ui_core_1.PropTypes.string
        },
        visible: {
            description: "显示隐藏键盘",
            defaultValue: false,
            rule: elmer_ui_core_1.PropTypes.bool
        },
        onChange: {
            description: "点击改变事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onClose: {
            description: "键盘隐藏动画结束后触发事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onConfirm: {
            description: "完成按钮点击事件",
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    NumberKeyboard = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "keyboardNumber",
            template: {
                url: "./index.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], NumberKeyboard);
    return NumberKeyboard;
}(elmer_ui_core_1.Component));
exports.default = NumberKeyboard;
var createKeyboardNumber = function (options) {
    var ui = elmer_ui_core_1.getUI();
    var isDispose = false;
    var obj = {
        domId: ui.getRandomID(),
        dom: {},
        options: options,
        onClose: function () {
            if (isDispose) {
                uiRender.dispose();
                document.body.removeChild(div);
                uiRender = null;
                obj = null;
                htmlCode = null;
                ui = null;
                div = null;
                owner = null;
            }
        }
    };
    var div = document.createElement("div");
    var owner = {
        dispose: function () {
            isDispose = true;
            obj.dom[obj.domId].hide();
        },
        show: function () {
            obj.dom[obj.domId].show();
        },
        hide: function () {
            isDispose = false;
            obj.dom[obj.domId].hide();
        },
        formatInput: function (fOptions) {
            if (fOptions) {
                var saveStr = ui.isEmpty(fOptions.saveValue) ? "" : fOptions.saveValue;
                var inputValue = fOptions.inputValue;
                var saveArr = saveStr.split("");
                var inputResult = "";
                if (inputValue !== "DEL") {
                    if (fOptions.isInit) {
                        if (inputValue !== ".") {
                            if (ui.isNumeric(fOptions.cursorPosition) && fOptions.cursorPosition >= 0 && fOptions.cursorPosition < saveArr.length) {
                                saveArr.splice(fOptions.cursorPosition, 0, inputValue);
                            }
                            else {
                                saveArr.push(inputValue);
                            }
                            inputResult = saveArr.join("");
                        }
                    }
                    else {
                        if (inputValue === "." && saveStr.indexOf(inputValue) >= 0) {
                            inputResult = saveStr;
                        }
                        else {
                            if (ui.isNumeric(fOptions.cursorPosition) && fOptions.cursorPosition >= 0 && fOptions.cursorPosition < saveArr.length) {
                                saveArr.splice(fOptions.cursorPosition, 0, inputValue);
                            }
                            else {
                                saveArr.push(inputValue);
                            }
                            inputResult = saveArr.join("");
                        }
                    }
                }
                else {
                    inputResult = saveStr.length > 0 ? saveStr.substr(0, saveStr.length - 1) : "";
                }
                if (/^[0]{1,}\./.test(inputResult)) {
                    inputResult = inputResult.replace(/^[0]{1,}\./, "0.");
                }
                else if (/^[0]{1,}([1-9][0-9\.]*)$/.test(inputResult)) {
                    inputResult = inputResult.replace(/^[0]{1,}([1-9][0-9\.]*)$/, "$1");
                }
                else if (/^[0]{1,}$/.test(inputResult)) {
                    inputResult = "0";
                }
                else if (/^\./.test(inputResult)) {
                    inputResult = "0" + inputResult;
                }
                return inputResult;
            }
            else {
                return "";
            }
        }
    };
    var htmlCode = "<eui-keyboard-number\n        id=\"{{domId}}\"\n        visible=\"{{options.visible}}\"\n        title=\"{{options.title}}\"\n        btnCloseText=\"{{options.btnCloseText}}\"\n        btnConfirmText=\"{{options.btnConfirmText}}\"\n        copyRight=\"{{options.copyRight}}\"\n        showClose=\"{{options.showClose}}\"\n        showConfirm=\"{{options.showConfirm}}\"\n        showAnimation=\"{{options.showAnimation}}\"\n        hideAnimation=\"{{options.hideAnimation}}\"\n        visible=\"{{options.visible}}\"\n        et:onChange=\"options.onChange\"\n        et:onClose=\"onClose\"\n        et:onConfirm=\"options.onConfirm\"\n    />";
    var uiRender = ui.render(div, htmlCode, obj);
    document.body.appendChild(div);
    return owner;
};
exports.createKeyboardNumber = createKeyboardNumber;
