import { Component, IPropCheckRule } from "elmer-ui-core";
import "./index.less";
declare type TypeOfficeDataViewColumnType = "Text" | "Progress" | "CheckBox" | "FromRender";
export declare type TypeOfficeDataViewHeaderItem = {
    title?: string;
    dataKey?: string;
    colspan?: number;
    rowspan?: number;
    className?: string;
    style?: string;
    type?: TypeOfficeDataViewColumnType;
    render?: Function;
    minKey?: string;
    maxKey?: string;
    max?: number;
    min?: number;
    events?: any;
    isCodeTitle?: boolean;
};
export declare type TypeOfficeDataViewBodyItem = {
    title?: string;
    data?: any;
    style?: string;
    className?: string;
    min?: number;
    max?: number;
    value?: any;
};
export declare type TypeOfficeDataViewPager = {
    position?: string;
    page: number;
    pageSize: number;
    totalPage: number;
    totalNums: number;
};
declare type TypeOfficeDataViewProps = {
    data: any[];
    defineIndex: number;
    className: string;
    columns: TypeOfficeDataViewHeaderItem[][];
    width: string;
    height: string;
    tableWidth: string;
    pager: TypeOfficeDataViewPager;
    onPageChange: Function;
};
declare type TypeOfficeDataViewPropsRule = {
    [P in keyof TypeOfficeDataViewProps]: IPropCheckRule;
};
declare type TypeOfficeDataViewState = {
    data?: any[];
    className?: string;
    outStyle: string;
    tableStyle: string;
    pager?: TypeOfficeDataViewPager;
    tBodyStyle?: string;
    columnSizeData: any[];
    bodyData?: TypeOfficeDataViewBodyItem[];
    headerData?: TypeOfficeDataViewHeaderItem[];
    jumpNums?: string;
    updateTime?: string;
};
export declare const createOfficeDataViewPager: (data: TypeOfficeDataViewPager) => TypeOfficeDataViewPager;
export declare const createOfficeDataViewHeader: (data: TypeOfficeDataViewHeaderItem[][]) => TypeOfficeDataViewHeaderItem[][];
export default class OfficeDataView extends Component {
    static propType: TypeOfficeDataViewPropsRule;
    props: TypeOfficeDataViewProps;
    state: TypeOfficeDataViewState;
    tableId: string;
    tableViewId: string;
    tablePagerId: string;
    tableHeaderId: string;
    tableBodyId: string;
    private bodyHeight;
    private isInitSize;
    private defaultPagerPosition;
    constructor(props: TypeOfficeDataViewProps);
    onFirstClick(): void;
    onPrevClick(): void;
    onNextClick(): void;
    onLastClick(): void;
    OnGotoClick(): void;
    $didMount(): void;
    $willReceiveProps(props: TypeOfficeDataViewProps): void;
    private getBodyData;
    private initColumnData;
    private getPagerPosition;
    private getOutStyle;
}
export {};
