"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createOfficeDataViewHeader = exports.createOfficeDataViewPager = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var createOfficeDataViewPager = function (data) { return (data); };
exports.createOfficeDataViewPager = createOfficeDataViewPager;
var createOfficeDataViewHeader = function (data) { return data; };
exports.createOfficeDataViewHeader = createOfficeDataViewHeader;
var OfficeDataView = (function (_super) {
    __extends(OfficeDataView, _super);
    function OfficeDataView(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            outStyle: "",
            tableStyle: "width: 100%;",
            columnSizeData: [],
            pager: exports.createOfficeDataViewPager({
                position: "页码{{page}}/{{totalPage}} 每页{{pageSize}}共{{totalPage}}页",
                page: 1,
                pageSize: 20,
                totalNums: 1,
                totalPage: 1
            }),
            bodyData: []
        };
        _this.bodyHeight = 0;
        _this.isInitSize = false;
        _this.defaultPagerPosition = "页码 {{page}}/{{totalPage}} 每页 {{pageSize}} 共 {{totalNums}} 条数据";
        _this.state.className = props.className;
        _this.state.tableStyle = !_this.isEmpty(props.tableWidth) ? "min-width:" + props.tableWidth + ";" : "width:100%;";
        _this.state.outStyle = _this.getOutStyle();
        _this.tableId = _this.getRandomID();
        _this.tableViewId = _this.getRandomID();
        _this.tablePagerId = _this.getRandomID();
        _this.tableHeaderId = _this.getRandomID();
        _this.tableBodyId = _this.getRandomID();
        _this.state.bodyData = _this.getBodyData(props.data);
        _this.state.headerData = props.columns;
        _this.state.data = props.data;
        _this.state.updateTime = (new Date()).getTime().toString();
        if (props.pager) {
            _this.state.pager = props.pager;
            if (!_this.isEmpty(props.pager.position)) {
                _this.defaultPagerPosition = props.pager.position;
            }
            var sourceLength = props.pager.totalNums;
            _this.state.pager.pageSize = props.pager.pageSize > 0 ? props.pager.pageSize : 20;
            _this.state.pager.page = props.pager.page > 0 ? props.pager.page : 1;
            if (props.pager.totalNums <= sourceLength) {
                _this.state.pager.totalNums = sourceLength;
                _this.state.pager.totalPage = _this.state.pager.totalPage > 0 ? _this.state.pager.totalPage : Math.ceil(sourceLength / _this.state.pager.pageSize);
            }
            _this.state.pager.position = _this.getPagerPosition(_this.state.pager);
        }
        else {
            var dPageSize = 10;
            var totalNums = props.data.length;
            var totalPage = Math.ceil(totalNums / dPageSize);
            _this.state.pager = exports.createOfficeDataViewPager({
                position: _this.getPagerPosition({
                    page: 1,
                    pageSize: dPageSize,
                    totalNums: totalNums,
                    totalPage: totalPage,
                }),
                page: 1,
                pageSize: dPageSize,
                totalNums: totalNums,
                totalPage: totalPage
            });
        }
        _this.initColumnData();
        return _this;
    }
    OfficeDataView.prototype.onFirstClick = function () {
        var myPager = JSON.parse(JSON.stringify(this.state.pager));
        if (myPager.page !== 1) {
            myPager.page = 1;
            myPager.position = this.getPagerPosition(myPager);
            var evtData = {
                pagination: myPager,
                update: true
            };
            typeof this.props.onPageChange === "function" && this.props.onPageChange(evtData);
            if (evtData.update) {
                this.setState({
                    pager: myPager,
                    bodyData: [],
                    data: []
                });
            }
        }
    };
    OfficeDataView.prototype.onPrevClick = function () {
        var myPager = JSON.parse(JSON.stringify(this.state.pager));
        var savePage = myPager.page;
        myPager.page = myPager.page - 1 > 0 ? myPager.page - 1 : 1;
        if (myPager.page !== savePage) {
            myPager.position = this.getPagerPosition(myPager);
            var evtData = {
                pagination: myPager,
                update: true
            };
            typeof this.props.onPageChange === "function" && this.props.onPageChange(evtData);
            if (evtData.update) {
                this.setState({
                    pager: myPager,
                    bodyData: [],
                    data: []
                });
            }
        }
    };
    OfficeDataView.prototype.onNextClick = function () {
        var myPager = JSON.parse(JSON.stringify(this.state.pager));
        var savePage = myPager.page;
        myPager.page = myPager.page + 1 <= myPager.totalPage ? myPager.page + 1 : myPager.totalPage;
        if (myPager.page !== savePage) {
            myPager.position = this.getPagerPosition(myPager);
            var evtData = {
                pagination: myPager,
                update: true
            };
            typeof this.props.onPageChange === "function" && this.props.onPageChange(evtData);
            if (evtData.update) {
                this.setState({
                    pager: myPager,
                    bodyData: [],
                    data: []
                });
            }
        }
    };
    OfficeDataView.prototype.onLastClick = function () {
        var myPager = JSON.parse(JSON.stringify(this.state.pager));
        var savePage = myPager.page;
        if (savePage !== myPager.totalPage) {
            myPager.page = myPager.totalPage;
            myPager.position = this.getPagerPosition(myPager);
            var evtData = {
                pagination: myPager,
                update: true
            };
            typeof this.props.onPageChange === "function" && this.props.onPageChange(evtData);
            if (evtData.update) {
                this.setState({
                    pager: myPager,
                    bodyData: [],
                    data: []
                });
            }
        }
    };
    OfficeDataView.prototype.OnGotoClick = function () {
        var jump = this.isNumeric(this.state.jumpNums) ? parseInt(this.state.jumpNums, 10) : 1;
        var myPager = JSON.parse(JSON.stringify(this.state.pager));
        if (myPager.page !== jump) {
            myPager.page = jump;
            myPager.position = this.getPagerPosition(myPager);
            var evtData = {
                pagination: myPager,
                update: true
            };
            typeof this.props.onPageChange === "function" && this.props.onPageChange(evtData);
            if (evtData.update) {
                this.setState({
                    pager: myPager,
                    bodyData: [],
                    data: []
                });
            }
        }
    };
    OfficeDataView.prototype.$didMount = function () {
        var outDom = this.dom[this.tableViewId];
        var tableHeadDom = this.dom[this.tableHeaderId];
        var pagerDom = this.dom[this.tablePagerId];
        var tableWidthStyle = !this.isEmpty(this.props.tableWidth) ? "min-width:" + this.props.tableWidth + ";" : "width:100%;";
        var outHeight = outDom.clientHeight;
        var pagerHeight = pagerDom.clientHeight;
        var tableHeight = outHeight - pagerHeight;
        var tableHeaderHeight = tableHeadDom.clientHeight;
        var tableHeightStyle = "";
        var updateState = {};
        this.bodyHeight = tableHeight - tableHeaderHeight;
        updateState.tableStyle = tableWidthStyle + tableHeightStyle;
        updateState.tBodyStyle = "height:" + (tableHeight - tableHeaderHeight) + "px;overflow-y: auto;";
        if (this.props.data && tableHeight - tableHeaderHeight > this.props.data.length * 30) {
            updateState.bodyData = this.getBodyData(this.props.data);
        }
        this.setState(updateState);
    };
    OfficeDataView.prototype.$willReceiveProps = function (props) {
        var bodyData = this.getBodyData(props.data);
        var updateState = {
            bodyData: bodyData,
            data: props.data,
            updateTime: (new Date()).getTime()
        };
        if (props.pager && props.pager.pageSize > 0) {
            this.state.pager = exports.createOfficeDataViewPager({
                position: this.getPagerPosition({
                    page: props.pager.page,
                    pageSize: props.pager.pageSize,
                    totalNums: props.pager.totalNums,
                    totalPage: props.pager.totalPage,
                }),
                page: props.pager.page,
                pageSize: props.pager.pageSize,
                totalNums: props.pager.totalNums,
                totalPage: props.pager.totalPage,
            });
        }
        this.setState(updateState);
    };
    OfficeDataView.prototype.getBodyData = function (bodyData) {
        if (this.props.data && this.props.columns) {
            var defineIndex = this.props.defineIndex;
            var defineHeader = this.props.columns[defineIndex];
            var updateBodyData = [];
            if (defineHeader) {
                if (bodyData && bodyData.length > 0) {
                    for (var row = 0; row < bodyData.length; row++) {
                        var rowData = bodyData[row];
                        var bodyLineData = [];
                        for (var col = 0; col < defineHeader.length; col++) {
                            var defineHeaderCol = defineHeader[col];
                            if (defineHeaderCol) {
                                var colValue = this.getValue(rowData, defineHeaderCol.dataKey);
                                if (typeof defineHeaderCol.render === "function") {
                                    bodyLineData.push({
                                        type: "Code",
                                        value: defineHeaderCol.render(colValue, rowData),
                                        events: defineHeaderCol.events,
                                        style: defineHeaderCol.style,
                                        rowspan: 1,
                                        colspan: 1,
                                        data: rowData
                                    });
                                }
                                else {
                                    if (defineHeaderCol.type === "Progress") {
                                        var min = !this.isEmpty(defineHeaderCol.minKey) ? this.getValue(rowData, defineHeaderCol.minKey) : 0;
                                        var max = !this.isEmpty(defineHeaderCol.maxKey) ? this.getValue(rowData, defineHeaderCol.maxKey) : 0;
                                        if (defineHeaderCol.max > 0) {
                                            min = defineHeaderCol.min;
                                            max = defineHeaderCol.max;
                                        }
                                        bodyLineData.push({
                                            type: "Code",
                                            value: "<eui-progress value=\"" + colValue + "\" min=\"" + min + "\" max=\"" + max + "\"/>",
                                            events: defineHeaderCol.events,
                                            style: defineHeaderCol.style,
                                            rowspan: 1,
                                            colspan: 1,
                                            data: rowData
                                        });
                                    }
                                    else if (defineHeaderCol.type === "CheckBox") {
                                        var checkValue = colValue ? "true" : "false";
                                        bodyLineData.push({
                                            type: "Code",
                                            value: "<eui-checkbox checked=\"{{" + checkValue + "}}\"/>",
                                            events: defineHeaderCol.events,
                                            style: defineHeaderCol.style,
                                            rowspan: 1,
                                            colspan: 1,
                                            data: rowData
                                        });
                                    }
                                    else {
                                        bodyLineData.push({
                                            type: "Text",
                                            value: colValue,
                                            rowspan: 1,
                                            colspan: 1,
                                            style: defineHeaderCol.style
                                        });
                                    }
                                }
                            }
                        }
                        updateBodyData.push(bodyLineData);
                    }
                    if (bodyData.length * 30 < this.bodyHeight) {
                        var maxLen = Math.ceil((this.bodyHeight - bodyData.length * 30) / 30) + 1;
                        for (var i = 0; i < maxLen; i++) {
                            var bodyLine = [];
                            for (var col = 0; col < defineHeader.length; col++) {
                                bodyLine.push({
                                    type: "Code",
                                    colspan: 1,
                                    rowspan: 1,
                                    style: defineHeader[col].style,
                                    value: "<span data-type='html'>&nbsp;&nbsp;</span>"
                                });
                            }
                            updateBodyData.push(bodyLine);
                        }
                    }
                }
                else {
                    updateBodyData.push([{
                            type: "Code",
                            colspan: defineHeader.length,
                            rowspan: 1,
                            style: "height: 100px;",
                            className: "dataViewEmptyLine",
                            value: "<label><eui-icon type='fa-trash-o'/><span>没有更多数据了</span></label>"
                        }]);
                }
                return updateBodyData;
            }
            else {
                return JSON.parse(JSON.stringify(bodyData));
            }
        }
        else {
            console.error("\u672A\u8BBE\u7F6E\u6570\u636E\u8868\u6807\u9898[" + this["selector"] + "]");
        }
    };
    OfficeDataView.prototype.initColumnData = function () {
        var bodyData = this.state.data;
        var columNums = bodyData.length;
        var result = [];
        for (var i = 0; i < columNums; i++) {
            result.push({
                style: "width:auto;",
                width: "auto"
            });
        }
        this.state.columnSizeData = result;
    };
    OfficeDataView.prototype.getPagerPosition = function (pagerData) {
        var pStr = this.defaultPagerPosition || "";
        pStr = pStr.replace(/\{\{page\}\}/g, this.getValue(pagerData, "page") || "");
        pStr = pStr.replace(/\{\{pageSize\}\}/g, this.getValue(pagerData, "pageSize") || "");
        pStr = pStr.replace(/\{\{totalNums\}\}/g, this.getValue(pagerData, "totalNums") || "");
        pStr = pStr.replace(/\{\{totalPage\}\}/g, this.getValue(pagerData, "totalPage") || "");
        return pStr;
    };
    OfficeDataView.prototype.getOutStyle = function () {
        var mStyles = [];
        !this.isEmpty(this.props.width) && mStyles.push("width:" + this.props.width);
        !this.isEmpty(this.props.height) && mStyles.push("height:" + this.props.height);
        return mStyles.join(";") + ";";
    };
    OfficeDataView.propType = {
        data: {
            description: "Data Source",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        defineIndex: {
            description: "Set the header mapping index",
            defaultValue: 0,
            rule: elmer_ui_core_1.PropTypes.number.isRequired
        },
        className: {
            description: "Dom style class name",
            defaultValue: "office_blue",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        columns: {
            description: "标题",
            defaultValue: [],
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        width: {
            description: "Widget width",
            defaultValue: "",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        height: {
            description: "Widget height",
            defaultValue: "250px",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        pager: {
            description: "分页数据",
            rule: elmer_ui_core_1.PropTypes.object
        },
        tableWidth: {
            description: "Data table width",
            defaultValue: "",
            rule: elmer_ui_core_1.PropTypes.string
        },
        onPageChange: {
            description: "切换页面事件",
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    OfficeDataView = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "OfficeDataView",
            template: {
                url: "./index.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], OfficeDataView);
    return OfficeDataView;
}(elmer_ui_core_1.Component));
exports.default = OfficeDataView;
