import { IPropCheckRule } from "elmer-ui-core";
export declare type TypeOfficeFormMenuButton = {
    title: string;
    icon: string;
    id?: string;
};
export declare type TypeOfficeFormTabMenuItem = {
    title: string;
    id?: string;
    buttons: TypeOfficeFormMenuButton[];
};
export declare type TypeOfficeFormTabItem = {
    title: string;
    id?: string;
    menus: TypeOfficeFormTabMenuItem[];
};
export declare type TypeOfficeFormProps = {
    title?: string;
    tabMenu?: TypeOfficeFormTabItem[];
    onClick?: Function;
    quickApps?: TypeOfficeFormMenuButton[];
    statusBarCol1?: string;
    statusBarCol2?: string;
    statusBarCol3?: string;
    statusBarCol4?: string;
};
export declare type TypeOfficeFormPropsRule = {
    [P in keyof TypeOfficeFormProps]?: IPropCheckRule;
};
export declare type TypeOfficeFormState = TypeOfficeFormProps & {
    choseTabMenu?: any;
    choseTabIndex?: number;
};
export declare const createOfficeFormTabMenu: (config: TypeOfficeFormTabItem[]) => TypeOfficeFormTabItem[];
export declare const createOfficeQuickButtons: (config: TypeOfficeFormMenuButton[]) => TypeOfficeFormMenuButton[];
export declare const definePropType: TypeOfficeFormPropsRule;
