"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var statusBar_1 = require("./statusBar");
var TypeFormAttr_1 = require("./TypeFormAttr");
require("./index.less");
var Form = (function (_super) {
    __extends(Form, _super);
    function Form(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            tabMenu: [],
            choseTabMenu: {},
            choseTabIndex: 0
        };
        _this.tabScrollLeft = 0;
        _this.tabScrollWidth = 0;
        _this.tabMenuId = _this.guid();
        _this.state.tabMenu = props.tabMenu;
        _this.state.quickApps = props.quickApps;
        _this.state.choseTabMenu = _this.state.tabMenu[0];
        return _this;
    }
    Form.prototype.handleOnMenuButtonMouseDown = function (evt) {
        evt.nativeEvent.cancelBubble = true;
    };
    Form.prototype.handleOnQuickAppClick = function (evt) {
        typeof this.props.onClick === "function" && this.props.onClick({
            type: "QuickAppButton",
            data: evt.data.app,
            event: evt
        });
    };
    Form.prototype.handleOnHeaderButtonClick = function (evt) {
        typeof this.props.onClick === "function" && this.props.onClick({
            type: evt.dataSet.type,
            event: evt
        });
    };
    Form.prototype.handleOnStartClick = function (evt) {
        typeof this.props.onClick === "function" && this.props.onClick({
            type: "StartButton",
            event: evt
        });
    };
    Form.prototype.handleOnTabMenuButtonClick = function (evt) {
        typeof this.props.onClick === "function" && this.props.onClick({
            type: "MenuButton",
            data: evt.data.buttonItem,
            event: evt,
            tabIndex: this.state.choseTabIndex,
            tabMenu: this.state.choseTabMenu,
            setMenuState: this.updateTabMenuState.bind(this)
        });
    };
    Form.prototype.handleOnTabMenuMouseDown = function (evt) {
        if (this.tabMenuParent.scrollWidth > this.tabMenuParent.clientWidth || this.tabScrollLeft < 0) {
            this.isTabMenuPress = true;
            this.tabScrollWidth = this.tabMenuParent.scrollWidth;
            this.mousePoint = {
                x: evt.nativeEvent.clientX,
                y: evt.nativeEvent.clientY
            };
        }
        else {
            if (this.tabMenuParent.firstChild) {
                this.$.css(this.tabMenuParent.firstChild, "margin-left", "0px");
            }
        }
    };
    Form.prototype.handleOnTabMenuMouseMove = function (evt) {
        if (this.isTabMenuPress) {
            var posX = evt.nativeEvent.clientX;
            var offsetX = posX - this.mousePoint.x + this.tabScrollLeft;
            var clientWidth = this.tabMenuParent.clientWidth;
            if (offsetX <= 0 && (this.tabScrollWidth + offsetX >= clientWidth || this.tabScrollLeft < offsetX)) {
                this.$.css(this.tabMenuParent.firstChild, "margin-left", offsetX + "px");
                this.tabScrollLeft = offsetX;
            }
            this.mousePoint.x = posX;
        }
    };
    Form.prototype.handleOnBodyMouseUp = function () {
        this.isTabMenuPress = false;
    };
    Form.prototype.handleOnTabClick = function (evt) {
        if (evt.data.index !== this.state.choseTabIndex) {
            this.tabScrollLeft = 0;
            this.setState({
                choseTabIndex: evt.data.index,
                choseTabMenu: evt.data.tabItem
            });
            if (this.tabMenuParent.firstChild) {
                this.$.css(this.tabMenuParent.firstChild, "margin-left", "0px");
            }
        }
    };
    Form.prototype.$didMount = function () {
        this.addEvent(this, document.body, "selectstart", function (evt) {
            evt.nativeEvent.preventDefault();
            return false;
        });
        this.addEvent(this, document.body, "contextmenu", function (evt) {
            evt.nativeEvent.preventDefault();
            return false;
        });
        this.tabMenuParent = this.dom[this.tabMenuId];
    };
    Form.prototype.render = function () {
        return require("./index.html");
    };
    Form.prototype.updateTabMenuState = function (tabMenuData) {
        var newMenuData = JSON.parse(JSON.stringify(this.state.tabMenu));
        newMenuData[this.state.choseTabIndex] = tabMenuData;
        this.setState({
            tabMenu: newMenuData,
            choseTabMenu: tabMenuData
        });
    };
    Form.propType = TypeFormAttr_1.definePropType;
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], Form.prototype, "$", void 0);
    Form = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "OfficeForm",
            components: [{
                    selector: "StatusBar",
                    component: statusBar_1.default
                }]
        }),
        __metadata("design:paramtypes", [Object])
    ], Form);
    return Form;
}(elmer_ui_core_1.Component));
exports.default = Form;
