"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PagerComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var PagerComponent = (function (_super) {
    __extends(PagerComponent, _super);
    function PagerComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.pageCount = 0;
        _this.allCount = 0;
        _this.page = 0;
        _this.theme = "";
        _this.pageSize = 20;
        _this.pageSize = props.pageSize;
        _this.allCount = props.totalCount;
        _this.page = props.page;
        _this.initData();
        return _this;
    }
    PagerComponent.prototype.$onPropsChanged = function (props) {
        this.pageSize = props.pageSize;
        this.allCount = props.totalCount;
        this.page = props.page;
        this.initData(true);
    };
    PagerComponent.prototype.initData = function (updateData) {
        var allCount = this.allCount > 0 ? this.allCount : 1;
        var pageSize = this.pageSize > 0 ? this.pageSize : 10;
        var pageCount = Math.ceil(allCount / pageSize);
        var page = this.page > 0 && this.page < pageCount ? this.page : (pageCount <= 0 ? 1 : pageCount);
        var $btnStartPage = Math.floor(page / 10) * 10;
        var pageList = [];
        var prevPage = -1;
        var nextPage = -1;
        if (page > 5 && page % 10 === 0) {
            $btnStartPage = $btnStartPage - 1;
        }
        for (var i = $btnStartPage; i < $btnStartPage + 10; i++) {
            if (i + 1 <= pageCount) {
                if ($btnStartPage + 10 < pageCount && i === $btnStartPage + 10 - 2) {
                    pageList.push({
                        value: "...",
                        theme: "disabledItem"
                    });
                }
                else {
                    pageList.push({
                        value: i + 1,
                        theme: ""
                    });
                }
            }
        }
        if (page > 1) {
            prevPage = page - 1;
        }
        if (page < pageCount) {
            nextPage = page + 1;
        }
        if (updateData) {
            this.setData({
                nextPage: nextPage,
                prevPage: prevPage,
                pageList: pageList,
                pageCount: pageCount
            }, true);
        }
        else {
            this.nextPage = nextPage;
            this.prevPage = prevPage;
            this.pageList = pageList;
            this.pageCount = pageCount;
        }
    };
    PagerComponent.prototype.onFirstClick = function () {
        this.page = 1;
        this.initData(true);
        typeof this.props.onChange === "function" && this.props.onChange(this.page, this.pageSize);
    };
    PagerComponent.prototype.onLastClick = function () {
        var allCount = this.allCount > 0 ? this.allCount : 1;
        var pageSize = this.pageSize > 0 ? this.pageSize : 10;
        var pageCount = Math.ceil(allCount / pageSize);
        this.page = pageCount;
        this.initData(true);
        typeof this.props.onChange === "function" && this.props.onChange(this.page, this.pageSize);
    };
    PagerComponent.prototype.onChangeItem = function (evt) {
        var data = evt.data.item;
        if (!isNaN(data.value) && this.page !== data.value) {
            this.page = data.value;
            this.initData(true);
            typeof this.props.onChange === "function" && this.props.onChange(this.page, this.pageSize);
        }
    };
    PagerComponent.prototype.onGotoNextPage = function (evt) {
        var toPage = parseInt(evt.target.getAttribute("data-page"), 10);
        var dataTag = evt.target.getAttribute("data-tag");
        if (toPage > 0 && toPage <= this.pageCount) {
            this.page = toPage;
            this[dataTag] = toPage;
            this.initData(true);
            typeof this.props.onChange === "function" && this.props.onChange(this.page, this.pageSize);
        }
    };
    PagerComponent.prototype.render = function () {
        return require("./index.html");
    };
    PagerComponent.propType = {
        onChange: {
            description: "切换页面事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        totalCount: {
            defaultValue: 0,
            description: "所有记录数量",
            rule: elmer_ui_core_1.propTypes.number.isRequired
        },
        page: {
            defaultValue: 0,
            description: "当前页码",
            rule: elmer_ui_core_1.propTypes.number.isRequired
        },
        pageSize: {
            defaultValue: 20,
            description: "当前页码",
            rule: elmer_ui_core_1.propTypes.number.isRequired
        },
        summeryVisible: {
            defaultValue: true,
            description: "记录显示",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        }
    };
    PagerComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "pager"
        }),
        __metadata("design:paramtypes", [Object])
    ], PagerComponent);
    return PagerComponent;
}(elmer_ui_core_1.Component));
exports.PagerComponent = PagerComponent;
