"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PanelComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var PanelComponent = (function (_super) {
    __extends(PanelComponent, _super);
    function PanelComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            theme: "",
            title: "",
            hasTitle: "",
            style: "",
            bottomTheme: "",
            hasBottom: true,
        };
        _this.state.theme = props.theme || "";
        _this.state.title = props.title;
        _this.state.hasTitle = !_this.isEmpty(props.title);
        _this.state.style = !_this.isEmpty(props.style) ? props.style : "";
        _this.state.hasBottom = props.hasBottom;
        _this.state.bottomTheme = props.bottomTheme;
        return _this;
    }
    PanelComponent.prototype.$onPropsChanged = function (props) {
        this.setState({
            theme: props.theme,
            title: props.title,
            hasTitle: !this.isEmpty(props.title),
            style: !this.isEmpty(props.style) ? props.style : "",
            hasBottom: props.hasBottom,
            bottomTheme: props.bottomTheme
        });
    };
    PanelComponent.prototype.render = function () {
        return "<div style=\"{{state.style}}\" class=\"eui-panel {{state.theme}}\" class.eui-panel-has-title=\"this.state.hasTitle\">\n                <label em:if=\"this.state.hasTitle\"><span>{{state.title}}</span></label>\n                <div><div><content /></div></div>\n                <footer class=\"{{state.bottomTheme}}\" em:if=\"this.state.hasBottom\">\n                    <eui-run-code em:showProps=\"this.props.showBottomProps\" em:exprops=\"this.props.props\" code=\"{{props.bottom}}\"/>\n                </footer>\n            </div>";
    };
    PanelComponent.propType = {
        theme: {
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        style: {
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        },
        title: {
            description: "标题",
            rule: elmer_ui_core_1.propTypes.string
        },
        hasBottom: {
            defaultValue: true,
            description: "是否有底部区域",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        bottom: {
            defaultValue: "",
            description: "底部区域html代码",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        bottomTheme: {
            defaultValue: "",
            description: "底部区域样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        showBottomProps: {
            description: "是否打印底部区域传入的props",
            rule: elmer_ui_core_1.propTypes.bool
        }
    };
    PanelComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "panel"
        }),
        __metadata("design:paramtypes", [Object])
    ], PanelComponent);
    return PanelComponent;
}(elmer_ui_core_1.Component));
exports.PanelComponent = PanelComponent;
