"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.attachQQService = exports.QQService = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var QQService = (function (_super) {
    __extends(QQService, _super);
    function QQService(props) {
        var _this = _super.call(this, props) || this;
        _this.showList = false;
        _this.data = [];
        if (props.data && props.data.length > 0) {
            _this.selectGroup = props.data[0];
        }
        _this.data = props.data || [];
        return _this;
    }
    QQService.prototype.handleOnTabClick = function () {
        this.setData({
            showList: !this.showList
        });
    };
    QQService.prototype.handleOnGroupClick = function (evt) {
        this.setData({
            selectGroup: evt.data.item
        });
    };
    QQService.prototype.handleOnItemClick = function (evt) {
        typeof this.props.onClick === "function" && this.props.onClick(evt.data.tmpItem);
    };
    QQService.prototype.render = function () {
        return require("./index.html");
    };
    QQService.prototype.$onPropsChanged = function (props) {
        this.setData({
            data: props.data || []
        });
    };
    QQService.propType = {
        data: {
            defaultValue: [
                { title: "在线客服", items: [
                        { title: "企业QQ交谈1", tipTitle: "QQ:", value: "1234567", icon: "qq_icon" },
                        { title: "企业QQ交谈2", tipTitle: "QQ:", value: "1234568", icon: "qq_icon" },
                        { title: "企业QQ交谈3", tipTitle: "QQ:", value: "1234569", icon: "qq_icon" }
                    ] },
                { title: "技术支持", items: [
                        { title: "250933400", tipTitle: "QQ:", value: "250933400", icon: "qq_icon" },
                        { title: "250933400", tipTitle: "QQ:", value: "250933400", icon: "qq_icon" },
                        { title: "250933400", tipTitle: "QQ:", value: "250933400", icon: "qq_icon" }
                    ] },
            ],
            description: "数据",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        workTime: {
            defaultValue: "9:00-24:00",
            description: "工作时间",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        workTitle: {
            defaultValue: "在线时间：",
            description: "工作时间标题",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        onClick: {
            description: "点击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string
        }
    };
    QQService = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "qqservice"
        }),
        __metadata("design:paramtypes", [Object])
    ], QQService);
    return QQService;
}(elmer_ui_core_1.Component));
exports.QQService = QQService;
var attachQQService = function (options) {
    var defaultOptions = {
        data: null,
        theme: ""
    };
    var ui = elmerData.getUI();
    ui.extend(defaultOptions, options);
    var dom = document.createElement("div");
    dom.setAttribute("style", "display: block;height:0;");
    document.body.appendChild(dom);
    ui.render(dom, "<eui-qqservice et:onClick='onClick' em:data='this.data' workTime='{{workTime}}' workTitle='{{workTitle}}' theme='{{theme}}'/>", __assign({}, defaultOptions));
};
exports.attachQQService = attachQQService;
window["attachQQService"] = exports.attachQQService;
