import { Component, IElmerEvent, IPropCheckRule } from "elmer-ui-core";
import "./index.less";
declare type TypeScrollBarProps = {
    theme: IPropCheckRule;
    onChange: IPropCheckRule;
    style: IPropCheckRule;
    scrollSize: IPropCheckRule;
    scrollViewSize: IPropCheckRule;
    type: IPropCheckRule;
    top: IPropCheckRule;
    left: IPropCheckRule;
};
declare type TypeScrollBarStateKeys = Exclude<keyof TypeScrollBarProps, "onChange" | "type">;
declare type TypeScrollBarState = {
    [P in TypeScrollBarStateKeys]: any;
} & {
    type: "scrollX" | "scrollY";
    thumbId?: string;
    thumbTrackId?: string;
    thumbSize?: number;
};
export declare class ScrollBarComponent extends Component {
    static propType: TypeScrollBarProps;
    state: TypeScrollBarState;
    private isPressed;
    private mouseX;
    private mouseY;
    private thumbLeft;
    private thumbTop;
    private isUpdateScrollSize;
    private $;
    constructor(props: {
        [P in keyof TypeScrollBarProps]: any;
    });
    handleOnThumbPress(evt: IElmerEvent): void;
    handleOnThumbTrackUp(evt: IElmerEvent): void;
    handleOnThumbTrackMove(evt: IElmerEvent): void;
    $after(): void;
    private updateScrollSize;
    private calcThumbSize;
}
export {};
