"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollBarComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var ScrollBarComponent = (function (_super) {
    __extends(ScrollBarComponent, _super);
    function ScrollBarComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            theme: "",
            style: "position:absolute;right:0;top:0;",
            scrollSize: 0,
            scrollViewSize: 0,
            type: "scrollY",
            top: 0,
            left: 0,
            thumbSize: 0
        };
        _this.isPressed = false;
        _this.mouseX = 0;
        _this.mouseY = 0;
        _this.thumbLeft = 0;
        _this.thumbTop = 0;
        _this.isUpdateScrollSize = false;
        _this.state.theme = props.theme || "";
        _this.state.style = props.style || "position:absolute;right:0;top:0;";
        _this.state.scrollSize = props.scrollSize || 0;
        _this.state.scrollViewSize = props.scrollViewSize || 0;
        _this.state.type = props.type || "scrollY";
        _this.state.thumbId = _this.getRandomID();
        _this.state.thumbTrackId = _this.getRandomID();
        return _this;
    }
    ScrollBarComponent.prototype.handleOnThumbPress = function (evt) {
        var posX = evt.nativeEvent.touches ? evt.nativeEvent.touches[0].clientX : evt.nativeEvent.clientX;
        var posY = evt.nativeEvent.touches ? evt.nativeEvent.touches[0].clientY : evt.nativeEvent.clientY;
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.isPressed = true;
        this.mouseX = posX;
        this.mouseY = posY;
    };
    ScrollBarComponent.prototype.handleOnThumbTrackUp = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.isPressed = false;
    };
    ScrollBarComponent.prototype.handleOnThumbTrackMove = function (evt) {
        var posX = evt.nativeEvent.touches ? evt.nativeEvent.touches[0].clientX : evt.nativeEvent.clientX;
        var posY = evt.nativeEvent.touches ? evt.nativeEvent.touches[0].clientY : evt.nativeEvent.clientY;
        var trackDom = this.dom[this.state.thumbTrackId];
        var thumbDom = this.dom[this.state.thumbId];
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        if (trackDom && thumbDom && this.isPressed) {
            if (this.state.type === "scrollY") {
                var offsetTop = posY - this.mouseY + this.thumbTop;
                var offsetHeight = trackDom.clientHeight - this.state.thumbSize;
                if (offsetTop >= 0 && offsetTop <= offsetHeight) {
                    this.$.css(thumbDom, {
                        top: offsetTop,
                        height: this.state.thumbSize
                    });
                    this.thumbTop = offsetTop;
                }
                offsetTop = null;
                offsetHeight = null;
            }
            else {
                var offsetLeft = posX - this.mouseX + this.thumbLeft;
                var offsetWidth = trackDom.clientWidth - this.state.thumbSize;
                if (offsetLeft >= 0 && offsetLeft <= offsetWidth) {
                    this.$.css(thumbDom, {
                        left: offsetLeft,
                        width: this.state.thumbSize
                    });
                    this.thumbLeft = offsetLeft;
                }
                offsetLeft = null;
                offsetWidth = null;
            }
            this.mouseX = posX;
            this.mouseY = posY;
        }
        thumbDom = null;
        trackDom = null;
    };
    ScrollBarComponent.prototype.$after = function () {
        this.addEvent(this, document.body, "mousemove", this.handleOnThumbTrackMove);
        this.addEvent(this, document.body, "touchmove", this.handleOnThumbTrackMove);
        this.addEvent(this, document.body, "mouseup", this.handleOnThumbTrackUp);
        this.addEvent(this, document.body, "touchend", this.handleOnThumbTrackUp);
        if (!this.isUpdateScrollSize) {
            this.isUpdateScrollSize = true;
            this.updateScrollSize();
        }
    };
    ScrollBarComponent.prototype.updateScrollSize = function () {
        var trackDom = this.dom[this.state.thumbTrackId];
        var thumbDom = this.dom[this.state.thumbId];
        if (trackDom && thumbDom) {
            var bHeight = trackDom.clientHeight;
            var bWidth = trackDom.clientWidth;
            var scrollSize = this.isNumeric(this.state.scrollSize) ? (this.isString(this.state.scrollSize) ? parseInt(this.state.scrollSize, 10) : this.state.scrollSize) : 0;
            var scrollViewSize = this.isNumeric(this.state.scrollViewSize) ? (this.isString(this.state.scrollViewSize) ? parseInt(this.state.scrollViewSize, 10) : this.state.scrollViewSize) : 0;
            if (this.state.type === "scrollY") {
                if (scrollSize > scrollViewSize && scrollViewSize > 0) {
                    this.state.thumbSize = this.calcThumbSize(bHeight);
                    this.$.css(thumbDom, {
                        top: this.state.top,
                        height: this.state.thumbSize
                    });
                }
                else {
                    this.$.css(thumbDom, {
                        top: 0,
                        height: "100%"
                    });
                }
            }
            else {
                if (scrollSize > scrollViewSize && scrollViewSize > 0) {
                    this.state.thumbSize = this.calcThumbSize(bWidth);
                    this.$.css(thumbDom, {
                        left: this.state.left,
                        width: this.state.thumbSize
                    });
                }
                else {
                    this.$.css(thumbDom, {
                        left: 0,
                        width: "100%"
                    });
                }
            }
            bHeight = null;
            bWidth = null;
            scrollSize = null;
            scrollViewSize = null;
        }
        trackDom = null;
        thumbDom = null;
    };
    ScrollBarComponent.prototype.calcThumbSize = function (thumbSize) {
        var scrollSize = this.isNumeric(this.state.scrollSize) ? (this.isString(this.state.scrollSize) ? parseInt(this.state.scrollSize, 10) : this.state.scrollSize) : 0;
        var scrollViewSize = this.isNumeric(this.state.scrollViewSize) ? (this.isString(this.state.scrollViewSize) ? parseInt(this.state.scrollViewSize, 10) : this.state.scrollViewSize) : 0;
        var scrollEffect = scrollSize - scrollViewSize;
        var np = Math.exp(1 - thumbSize / scrollEffect) / 2;
        return np * thumbSize;
    };
    ScrollBarComponent.propType = {
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.PropTypes.string
        },
        style: {
            defaultValue: "",
            description: "内联样式",
            rule: elmer_ui_core_1.PropTypes.string
        },
        scrollSize: {
            description: "滚动内容高度",
            rule: elmer_ui_core_1.PropTypes.number.isRequired
        },
        scrollViewSize: {
            description: "滚动条显示区域",
            rule: elmer_ui_core_1.PropTypes.number.isRequired
        },
        type: {
            defaultValue: "scrollY",
            description: "滚动条类型",
            rule: elmer_ui_core_1.PropTypes.oneValueOf(["scrollX", "scrollY"]).isRequired
        },
        onChange: {
            description: "滚动事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        top: {
            defaultValue: 0,
            description: "垂直滚动条位置",
            rule: elmer_ui_core_1.PropTypes.number
        },
        left: {
            defaultValue: 0,
            description: "水平滚动条位置",
            rule: elmer_ui_core_1.PropTypes.number
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], ScrollBarComponent.prototype, "$", void 0);
    ScrollBarComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "scrollbar",
            template: {
                url: "./index.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], ScrollBarComponent);
    return ScrollBarComponent;
}(elmer_ui_core_1.Component));
exports.ScrollBarComponent = ScrollBarComponent;
