"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabBar = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var TabBar = (function (_super) {
    __extends(TabBar, _super);
    function TabBar(props) {
        var _this = _super.call(this, props) || this;
        _this.index = 0;
        _this.tabTitle = [];
        _this.currentIndex = 0;
        _this.currentIndex = _this.props.currentIndex;
        return _this;
    }
    TabBar.prototype.getChildContext = function () {
        return {
            tabStore: {
                tabIndex: this.currentIndex
            }
        };
    };
    TabBar.prototype.setIndex = function (index) {
        this.index = index;
    };
    TabBar.prototype.handleOnTabClick = function (evt) {
        var index = evt.data.myTabTitle.key;
        var beforeResult = typeof this.props.onBeforeChange === "function" ? this.props.onBeforeChange(index) : undefined;
        if (beforeResult === undefined || beforeResult) {
            this.setData({
                currentIndex: index
            }, true);
            typeof this.props.onChange === "function" && this.props.onChange(index);
        }
    };
    TabBar.prototype.render = function () {
        return require("./views/tabBar.html");
    };
    TabBar.prototype.$before = function () {
        var _this = this;
        var tabData = [];
        var index = 0;
        this.props.children.map(function (item) {
            if (item.tagName === "eui-tab-item") {
                if (item.props.visible === undefined || item.props.visible) {
                    item.props.index = index;
                    item.props.currentIndex = _this.currentIndex;
                    item.props.id = "tabItem_" + index;
                    item.props.attach = true;
                    tabData.push({
                        index: index,
                        title: item.props.title
                    });
                    index += 1;
                }
            }
        });
        this.tabTitle = tabData;
    };
    TabBar.prototype.$onPropsChanged = function (newProps) {
        var _this = this;
        if (newProps.currentIndex !== this.currentIndex) {
            this.setData({
                currentIndex: newProps.currentIndex
            });
            var index_1 = 0;
            this.props.children.map(function (item) {
                if (item.tagName === "eui-tab-item") {
                    if (item.props.visible === undefined || item.props.visible) {
                        var domKey = "tabItem_" + index_1;
                        _this.dom[domKey].setCurrentIndex(newProps.currentIndex);
                        index_1 += 1;
                    }
                }
            });
        }
    };
    TabBar.prototype.switchTab = function (tabIndex) {
        var _this = this;
        var index = 0;
        this.setData({
            currentIndex: tabIndex
        });
        this.props.children.map(function (item) {
            if (item.tagName === "eui-tab-item") {
                if (item.props.visible === undefined || item.props.visible) {
                    var domKey = "tabItem_" + index;
                    _this.dom[domKey].setCurrentIndex(tabIndex);
                    index += 1;
                }
            }
        });
    };
    TabBar.propType = {
        onChange: {
            defaultValue: null,
            description: "tab切换事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onBeforeChange: {
            description: "切换事件前回调",
            rule: elmer_ui_core_1.PropTypes.func
        },
        currentIndex: {
            defaultValue: 0,
            rule: elmer_ui_core_1.PropTypes.number.isRequired
        },
        visible: {
            rule: elmer_ui_core_1.PropTypes.bool
        }
    };
    TabBar = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "tab"
        }),
        __metadata("design:paramtypes", [Object])
    ], TabBar);
    return TabBar;
}(elmer_ui_core_1.Component));
exports.TabBar = TabBar;
