"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var TableComponent = (function (_super) {
    __extends(TableComponent, _super);
    function TableComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            theme: "",
            columns: {
                header: [],
                colsGroup: [],
                dataKeys: []
            },
            columnsData: [],
            bodyData: [],
            resourceData: [],
            columnsLength: 0,
            exProps: {},
            allCount: 0
        };
        _this.state.theme = !_this.isEmpty(props.theme) ? props.theme : "";
        _this.state.columns = _this.formatColumns(props.columns);
        _this.state.columnsData = props.columns;
        _this.state.bodyData = _this.formatRows(props.data, _this.state.columns.header);
        _this.state.resourceData = props.data;
        _this.state.columnsLength = _this.state.columns.header.length;
        _this.state.allCount = (props.data || []).length;
        return _this;
    }
    TableComponent.prototype.$onPropsChanged = function (props) {
        var updateState = {};
        if (JSON.stringify(props.columns) !== JSON.stringify(this.state.columnsData)) {
            updateState.columns = this.formatColumns(props.columns);
            updateState.columnsData = props.columns;
            updateState.bodyData = this.formatRows(props.data, updateState.columns.header);
            updateState.columnsLength = updateState.columns.header.length;
            updateState.allCount = updateState.bodyData.length;
            updateState.resourceData = props.data;
        }
        else {
            if (JSON.stringify(props.data) !== JSON.stringify(this.state.resourceData)) {
                updateState.bodyData = this.formatRows(props.data, this.state.columns.header);
                updateState.allCount = updateState.bodyData.length;
                updateState.resourceData = props.data;
            }
        }
        if (Object.keys(updateState).length > 0) {
            this.setState(updateState);
        }
    };
    TableComponent.prototype.render = function () {
        return require("./views/index.html");
    };
    TableComponent.prototype.formatRows = function (data, dataHeader) {
        var bodyData = data || [];
        var resultData = [];
        var keysLen = dataHeader.length;
        var startIndex = this.props.startIndex > 0 ? this.props.startIndex : 0;
        for (var i = 0, cLen = bodyData.length; i < cLen; i++) {
            var tmpRowData = {
                index: i + startIndex,
                items: []
            };
            var tmpData = bodyData[i];
            for (var j = 0; j < keysLen; j++) {
                var tmpHeader = dataHeader[j];
                var tmpKey = tmpHeader.dataKey;
                tmpRowData.items.push({
                    dataType: typeof tmpHeader.render === "function" ? "code" : tmpHeader.dataType,
                    data: tmpData[tmpKey],
                    dataSource: tmpData,
                    code: typeof tmpHeader.render === "function" ? tmpHeader.render(tmpData, tmpData[tmpKey]) : "",
                    props: tmpHeader.props,
                    style: tmpHeader.style || "",
                    className: tmpHeader.className,
                    propsType: this.getType(tmpHeader.props)
                });
            }
            resultData.push(tmpRowData);
        }
        return resultData;
    };
    TableComponent.prototype.formatColumns = function (columnsData) {
        var columns = columnsData || [];
        var columnColGroups = [];
        var columnHeader = [];
        var columnDataKeys = [];
        for (var i = 0, cLen = columns.length; i < cLen; i++) {
            var tmpColumnData = columns[i];
            if (this.isEmpty(tmpColumnData.dataKey)) {
                console.error("Columns必须设置dataKey字段，指定显示数据", tmpColumnData);
            }
            columnHeader.push({
                autoDefined: tmpColumnData.codeTitle,
                title: tmpColumnData.title,
                dataKey: tmpColumnData.dataKey,
                dataType: tmpColumnData.dataType,
                render: tmpColumnData.render,
                props: tmpColumnData.props,
                style: tmpColumnData.style || "",
                className: tmpColumnData.className || "",
                width: !this.isEmpty(tmpColumnData.width) ? tmpColumnData.width : "auto"
            });
            columnColGroups.push({
                width: !this.isEmpty(tmpColumnData.width) ? tmpColumnData.width : "auto"
            });
        }
        return {
            header: columnHeader,
            colsGroup: columnColGroups,
            dataKeys: columnDataKeys
        };
    };
    TableComponent.propType = {
        theme: {
            defaultValue: "",
            description: "样式类名",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        columns: {
            description: "显示字段",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        data: {
            description: "数据源",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        startIndex: {
            defaultValue: 0,
            description: "开始需要",
            rule: elmer_ui_core_1.propTypes.number.isRequired
        },
        noDataText: {
            defaultValue: "没有更多数据",
            description: "没有数据的提示文本",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        owner: {
            description: "自定义元素事件执行对象",
            rule: elmer_ui_core_1.propTypes.any
        }
    };
    TableComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "table"
        }),
        __metadata("design:paramtypes", [Object])
    ], TableComponent);
    return TableComponent;
}(elmer_ui_core_1.Component));
exports.TableComponent = TableComponent;
