"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toast = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./index.less");
var Toast = (function (_super) {
    __extends(Toast, _super);
    function Toast(props) {
        var _this = _super.call(this, props) || this;
        _this.message = "";
        _this.icon = "eui-toast-error";
        _this.curAnimation = "AnislideDownIn";
        _this.closeAnimation = "AnislideDownOut";
        _this.showAnimation = "AnislideDownIn";
        _this.theme = "";
        _this.leftTime = 5;
        _this.duration = 5;
        _this.timeTick = false;
        _this.canTick = true;
        _this.showVisible = true;
        _this.cid = _this.getRandomID();
        _this.onClose = null;
        _this.autoClose = true;
        _this.toClose = false;
        _this.onClose = props.onClose;
        _this.autoClose = props.autoClose;
        _this.icon = props.icon;
        _this.duration = props.duration;
        _this.showAnimation = props.showAnimation;
        _this.closeAnimation = props.closeAnimation;
        _this.message = props.message;
        _this.showVisible = props.visible;
        _this.canTick = _this.autoClose;
        _this.icon = _this.props.iconVisible ? _this.icon : "noIcon";
        _this.theme = props.theme;
        _this.theme = _this.props.iconVisible ? _this.theme : _this.theme + " themeNoIcon";
        return _this;
    }
    Toast.prototype.$onPropsChanged = function (newProps) {
        if (newProps.autoClose !== this.autoClose) {
            this.autoClose = newProps.autoClose;
        }
        if (newProps.visible !== this.showVisible) {
            if (!this.showVisible && newProps.visible) {
                this.leftTime = this.duration;
                this.canTick = false;
                this.setData({
                    closeAnimation: newProps.closeAnimation,
                    curAnimation: this.showAnimation,
                    icon: this.props.iconVisible ? newProps.icon : "noIcon",
                    leftTime: this.duration,
                    message: newProps.message,
                    showAnimation: newProps.showAnimation,
                    showVisible: true,
                    theme: newProps.iconVisible ? newProps.theme : newProps.theme + " themeNoIcon",
                    toClose: false
                });
                this.autoClose && this.timeTickFunc();
            }
        }
        else {
            this.setData({
                closeAnimation: newProps.closeAnimation,
                curAnimation: this.showAnimation,
                duration: this.duration,
                icon: newProps.icon,
                message: newProps.message,
                showAnimation: newProps.showAnimation,
                theme: newProps.theme
            });
        }
    };
    Toast.prototype.timeTickFunc = function () {
        if (this.leftTime > 1) {
            var updateStatus = {
                leftTime: this.leftTime - 1,
                timeTick: true
            };
            this.setData(updateStatus);
            setTimeout(this.timeTickFunc.bind(this), 1000);
        }
        else {
            this.setData({
                curAnimation: this.closeAnimation,
                toClose: true,
            });
        }
    };
    Toast.prototype.handleOnDomAnimationEnd = function () {
        if (this.toClose) {
            this.setData({
                showVisible: false
            });
            this.isFunction(this.onClose) && this.onClose(this.props.handler);
        }
    };
    Toast.prototype.$after = function () {
        if (!this.timeTick && this.canTick) {
            this.leftTime = this.duration;
            this.canTick = false;
            this.setData({
                leftTime: this.duration,
                showVisible: true
            });
            this.timeTickFunc();
        }
        else {
            this.setData({
                showVisible: true
            });
        }
    };
    Toast.prototype.handleOnClose = function () {
        this.setData({
            curAnimation: this.closeAnimation,
            toClose: true,
        });
    };
    Toast.prototype.render = function () {
        return "<div show='{{showVisible}}' style='{{style}}' class='eui-toast-msg {{theme}}'><div id='{{cid}}' et:animationEnd='handleOnDomAnimationEnd' class='{{curAnimation}}'><div class='fa icon {{icon}}'><span>{{message}}</span><i if='{{autoClose}}'>({{leftTime}}s)</i></div><a em:if='!this.autoClose' class='fa fa-times-circle' evt:click='handleOnClose' href='javascript:void(0);'></a></div></div>";
    };
    Toast.propType = {
        autoClose: elmer_ui_core_1.propTypes.boolean,
        closeAnimation: {
            defaultValue: "AnislideDownOut",
            description: "关闭动画",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        duration: {
            defaultValue: 6,
            description: "自动关闭时间",
            rule: elmer_ui_core_1.propTypes.number.isRequired
        },
        handler: elmer_ui_core_1.propTypes.any,
        iconVisible: {
            defaultValue: true,
            description: "icon是否显示",
            rule: elmer_ui_core_1.propTypes.boolean,
        },
        leftTime: elmer_ui_core_1.propTypes.number,
        message: {
            defaultValue: "",
            description: "消息内容",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number]).isRequired
        },
        onClose: elmer_ui_core_1.propTypes.func,
        showAnimation: {
            defaultValue: "AnislideDownIn",
            description: "显示动画",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        style: {
            defaultValue: "",
            description: "组件内联样式",
            propertyKey: "style",
            rule: elmer_ui_core_1.propTypes.string
        },
        theme: {
            defaultValue: "",
            description: "样式",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        timeVisible: {
            defaultValue: true,
            description: "是否显示倒计时",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        visible: {
            defaultValue: false,
            description: "显示隐藏",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        icon: {
            defaultValue: "eui-toast-error",
            description: "图标",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        }
    };
    Toast = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "toast"
        }),
        __metadata("design:paramtypes", [Object])
    ], Toast);
    return Toast;
}(elmer_ui_core_1.Component));
exports.Toast = Toast;
