"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.showToast = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
__exportStar(require("./Toast"), exports);
var setTostState = function (stateKey, stateValue) {
    elmerData.elmerState.toastGlobalData[stateKey] = stateValue;
};
var getTostState = function (stateKey) {
    return elmerData.elmerState.toastGlobalData ? elmerData.elmerState.toastGlobalData[stateKey] : null;
};
var showToast = function (message, exOptions) {
    var options = exOptions || {};
    var ui = elmerData.getUI();
    var exOption = {
        duration: 5,
        iconVisible: true,
        timeVisible: true,
        visible: true,
        zIndex: 10001,
        autoClose: true
    };
    var iconThemes = {
        Error: "eui-toast-error",
        Success: "eui-toast-msg-success",
        None: "themeNoIcon"
    };
    var target = getTostState("target") || document.createElement("div");
    var hasAppend = /^(\[object\s*)HTML([a-zA-Z]*)(Element\])$/.test(Object.prototype.toString.call(getTostState("target")));
    ui.extend(exOption, options);
    if (!ui.isEmpty(exOption.icon)) {
        exOption.theme = iconThemes[exOption.icon];
    }
    if (!elmerData.elmerState.toastGlobalData) {
        elmer_ui_core_1.defineGlobalState("toastGlobalData", {
            messages: [],
            render: null,
            target: null,
            title: "toast弹窗数据"
        });
    }
    if (!getTostState("render")) {
        setTostState("render", ui);
    }
    if (!hasAppend) {
        target.className = "eui-toast-msg-list";
        target.style.zIndex = exOption.zIndex;
        document.body.appendChild(target);
        setTostState("target", target);
    }
    var parent = document.createElement("div");
    target.appendChild(parent);
    var uiRender = ui.render(parent, "<eui-toast style='position:relative;{{options.zIndex}}' message='{{message}}' handler='{{id}}' et:onClose='onClose' " +
        "autoClose='{{autoClose}}' closeAnimation='{{closeAnimation}}' showAnimation='{{showAnimation}}' " +
        "duration='{{duration}}' icon='{{icon}}' theme='{{theme}}' iconVisible='{{options.iconVisible}}' timeVisible='{{options.timeVisible}}'" +
        "/>", {
        autoClose: exOption.autoClose,
        closeAnimation: exOption.closeAnimation,
        duration: exOption.duration,
        icon: exOption.icon,
        id: ui.getRandomID(),
        message: message,
        options: exOption,
        selector: "eui-toast-msg",
        showAnimation: exOption.showAnimation,
        theme: exOption.theme,
        visible: exOption.visible,
        onClose: function () {
            parent.parentElement.removeChild(parent);
            uiRender.dispose();
            uiRender = null;
            typeof exOption.onClose === "function" && exOption.onClose();
        }
    });
};
exports.showToast = showToast;
elmer_ui_core_1.defineGlobalVar("showToast", exports.showToast);
