"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeViewItem = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var TreeViewItem = (function (_super) {
    __extends(TreeViewItem, _super);
    function TreeViewItem(props) {
        var _this = _super.call(this, props) || this;
        _this.listWidth = "auto";
        _this.settingWidth = false;
        _this.hasChild = false;
        _this.expandIcon = "fa-angle-right";
        _this.hasIcon = false;
        _this.subLevel = 0;
        _this.space = 0;
        _this.expand = false;
        _this.theme = "";
        _this.level = 0;
        _this.offsetLeft = 0;
        _this.width = 0;
        _this.childrenMaxWidth = 0;
        _this.data = JSON.parse(JSON.stringify(props.data));
        _this.data.children = (_this.data.children || []);
        _this.hasChild = _this.data.hasExpand ? _this.data.hasExpand : (_this.data && _this.data.children.length > 0);
        _this.hasIcon = !_this.isEmpty(_this.data.icon);
        _this.icon = _this.data.icon;
        _this.theme = !_this.isEmpty(props.theme) ? props.theme : "";
        _this.theme = [_this.theme, _this.getCheckStatusTheme()].join(" ");
        _this.subLevel = _this.props.level + 1;
        _this.space = _this.props.level * 20;
        _this.offsetLeft = _this.props.level * 20;
        _this.data.theme = !_this.isEmpty(_this.data.theme) ? _this.data.theme : "";
        return _this;
    }
    TreeViewItem.prototype.getCheckStatusTheme = function () {
        if (this.props.selectedData) {
            var checkField = !this.isEmpty(this.props.valueKey) ? this.props.valueKey : "value";
            for (var _i = 0, _a = this.props.selectedData; _i < _a.length; _i++) {
                var item = _a[_i];
                if (item[checkField] === this.data[checkField]) {
                    return "eui-treeview-item-selected";
                }
            }
        }
        return "";
    };
    TreeViewItem.prototype.$willReceiveProps = function (newProps) {
        var cTheme = this.getCheckStatusTheme();
        var cArray = (this.theme || "").split(" ");
        var newData = newProps.data || {};
        if (!this.isEmpty(cTheme)) {
            if (cArray.indexOf("eui-treeview-item-selected") < 0) {
                cArray.push("eui-treeview-item-selected");
            }
        }
        else {
            var tIndex = cArray.indexOf("eui-treeview-item-selected");
            if (tIndex >= 0) {
                cArray.splice(tIndex, 1);
            }
        }
        newData.children = newData.children || [];
        newData.theme = !this.isEmpty(newData.theme) ? newData.theme : "";
        this.setData({
            width: newProps.width,
            theme: cArray.join(" "),
            data: newProps.data || {}
        });
    };
    TreeViewItem.prototype.handleOnExpandClick = function (event) {
        var newExpand = !this.expand;
        var updateData = {
            expand: newExpand,
            expandIcon: newExpand ? "fa-angle-down" : "fa-angle-right"
        };
        this.expandDom = event.target;
        if (typeof this.props.onExpandClick === "function") {
            var resultExpand = this.props.onExpandClick({
                expand: newExpand,
                data: this.data,
                setData: this.updateData.bind(this),
                setChildren: this.updateChildren.bind(this)
            });
            updateData.expand = resultExpand;
            updateData.expandIcon = resultExpand ? "fa-angle-down" : "fa-angle-right";
        }
        this.setData(updateData);
        event.nativeEvent.cancelBubble = true;
        event.nativeEvent.stopPropagation();
        event.nativeEvent.preventDefault();
        return false;
    };
    TreeViewItem.prototype.updateData = function (data) {
        if (JSON.stringify(data.children) !== JSON.stringify(this.data.children)) {
            data.children = data.children || [];
            typeof this.props.onUpdateChildren === "function" && this.props.onUpdateChildren(this.props.index, data);
        }
        data.theme = !this.isEmpty(data.theme) ? data.theme : "";
        this.setData(__assign({}, (data || {})), true);
        if (JSON.stringify(data.data || {}) !== JSON.stringify(this.data)) {
            typeof this.props.onUpdateChildren === "function" && this.props.onUpdateChildren(this.props.index, this.data);
        }
    };
    TreeViewItem.prototype.updateChildren = function (data) {
        var newData = this.data;
        newData.children = data || [];
        this.props.data.children = data;
        this.setData({
            data: newData
        }, true);
        if (JSON.stringify(data) !== JSON.stringify(this.data.children)) {
            typeof this.props.onUpdateChildren === "function" && this.props.onUpdateChildren(this.props.index, this.data);
        }
    };
    TreeViewItem.prototype.$didMount = function () {
        if (this.expand) {
            var parent_1 = this.expandDom.parentElement.parentElement;
            var childrens = this.$.find(parent_1, "+ul>li>div>label span");
            var width = this.getMaxWidth(childrens);
            if (this.childrenMaxWidth !== width && childrens && childrens.length > 0) {
                var childrenLeft = childrens[0].getAttribute("data-left");
                var offsetLeft = !isNaN(childrenLeft) ? parseInt(childrenLeft, 10) : 0;
                if (width + offsetLeft > this.width) {
                    var updateWidth = width + this.offsetLeft;
                    if (updateWidth > this.width) {
                        var updateDoms = this.$.find(parent_1, "+ul>li");
                        this.$.css(updateDoms, "width", updateWidth);
                    }
                }
            }
            this.width = width;
        }
    };
    TreeViewItem.prototype.handleOnClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        evt.nativeEvent.preventDefault();
        evt.data = this.data;
        evt.setData = this.setData.bind(this);
        this.isFunction(this.props.click) && this.props.click(evt, this.data);
    };
    TreeViewItem.prototype.handleOnDblClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        evt.nativeEvent.preventDefault();
        evt.data = this.data;
        evt.setData = this.updateData.bind(this);
        this.isFunction(this.props.dblClick) && this.props.dblClick(evt);
    };
    TreeViewItem.prototype.render = function () {
        return require("./views/treeViewItem.html");
    };
    TreeViewItem.prototype.handleOnListUpdateChildren = function (data) {
        this.data.children = data;
    };
    TreeViewItem.prototype.getMaxWidth = function (domList) {
        var maxWidth = 0;
        if (domList) {
            domList.map(function (tmpDom) {
                var tmpWidth = tmpDom.clientWidth + tmpDom.offsetLeft + 20;
                if (tmpWidth > maxWidth) {
                    maxWidth = tmpWidth;
                }
                tmpWidth = null;
            });
        }
        return maxWidth;
    };
    TreeViewItem.propType = {
        width: elmer_ui_core_1.propTypes.number.isRequired,
        selectedData: elmer_ui_core_1.propTypes.array,
        onExpandClick: elmer_ui_core_1.propTypes.func,
        dblClick: elmer_ui_core_1.propTypes.func,
        level: {
            defaultValue: 0,
            description: "level",
            rule: elmer_ui_core_1.propTypes.number
        },
        valueKey: {
            defaultValue: "value",
            description: "value字段名",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        click: {
            description: "单击事件",
            rule: elmer_ui_core_1.propTypes.func
        },
        index: {
            description: "数组索引",
            rule: elmer_ui_core_1.propTypes.any
        },
        onUpdateChildren: {
            description: "更新Item事件",
            rule: elmer_ui_core_1.propTypes.func
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], TreeViewItem.prototype, "$", void 0);
    TreeViewItem = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "treeViewItem"
        }),
        __metadata("design:paramtypes", [Object])
    ], TreeViewItem);
    return TreeViewItem;
}(elmer_ui_core_1.Component));
exports.TreeViewItem = TreeViewItem;
