"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeViewList = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var TreeViewList = (function (_super) {
    __extends(TreeViewList, _super);
    function TreeViewList(props) {
        var _this = _super.call(this, props) || this;
        _this.selectedData = [];
        _this.display = "none";
        _this.level = 0;
        _this.space = 0;
        _this.data = [];
        _this.width = 0;
        var myData = props.data || [];
        var hasChildData = [];
        var noChildData = [];
        myData.map(function (tmpData) {
            if (tmpData && tmpData.children && tmpData.children.length > 0) {
                hasChildData.push(tmpData);
            }
            else {
                noChildData.push(tmpData);
            }
        });
        _this.data = props.data || [];
        _this.selectedData = props.selectedData;
        if (props.firstChild === "firstChild") {
            _this.display = "block";
            _this.show = true;
        }
        _this.level = props.level;
        _this.treeViewItemDblClick = props.onItemDblClick;
        return _this;
    }
    TreeViewList.prototype.handleOnUpdateChildren = function (index, data) {
        if (index >= 0 && index < this.data.length) {
            this.data[index] = data;
            typeof this.props.onUpdateChildren === "function" && this.props.onUpdateChildren(this.data);
        }
    };
    TreeViewList.prototype.$willReceiveProps = function (newProps) {
        var updateProps = {};
        var hasChanged = false;
        if (newProps !== this.show && newProps.firstChild !== "firstChild") {
            hasChanged = true;
            updateProps.display = newProps.show ? "block" : "none";
            updateProps.show = newProps.show;
        }
        if (newProps.width > 0 && this.width <= 0) {
            hasChanged = true;
            updateProps.width = newProps.width;
        }
        if (newProps.fixedWidth !== "auto" && !this.isEmpty(newProps.fixedWidth)) {
            hasChanged = true;
            updateProps.fixedWidth = newProps.fixedWidth;
        }
        if (JSON.stringify(newProps.data) !== JSON.stringify(this.data)) {
            updateProps.data = newProps.data;
        }
        updateProps.selectedData = newProps.selectedData;
        this.setData(updateProps, true);
    };
    TreeViewList.prototype.render = function () {
        return require("./views/treeViewList.html");
    };
    TreeViewList.propType = {
        data: elmer_ui_core_1.propTypes.array.isRequired,
        fixedWidth: elmer_ui_core_1.propTypes.string,
        level: elmer_ui_core_1.propTypes.number,
        width: elmer_ui_core_1.propTypes.number.isRequired,
        selectedData: elmer_ui_core_1.propTypes.array,
        onItemDblClick: elmer_ui_core_1.propTypes.func,
        onExpandClick: elmer_ui_core_1.propTypes.func,
        treeViewItemClick: elmer_ui_core_1.propTypes.func,
        valueKey: {
            defaultValue: "value",
            description: "value字段名",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        },
        onUpdateChildren: {
            description: "更新Item事件",
            rule: elmer_ui_core_1.propTypes.func
        }
    };
    TreeViewList = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "treeViewList"
        }),
        __metadata("design:paramtypes", [Object])
    ], TreeViewList);
    return TreeViewList;
}(elmer_ui_core_1.Component));
exports.TreeViewList = TreeViewList;
