import { Component, IElmerEvent } from "elmer-ui-core";
import "./styles/index.less";
import "./TreeViewItem";
import "./TreeViewList";
declare type TreeViewProps = {
    data: any[];
    onChange: Function;
    onExpandClick: Function;
    changeOnDblClick: boolean;
    isMutil: boolean;
    valueKey: string | number;
};
export interface ITreeViewItem {
    title: string;
    id?: string;
    icon?: string;
    children: ITreeViewItem[];
    data?: any;
    hasExpand?: boolean;
    key?: number;
    value?: any;
    theme?: string;
}
export declare class TreeView extends Component<TreeViewProps> {
    static propType: any;
    data: ITreeViewItem[];
    level: number;
    private containerWidth;
    private settingWidthToChild;
    private selectedData;
    private changeOnDblClick;
    private domObj;
    constructor(props: any);
    handleOnUpdateChildren(data: any): void;
    handleOnItemClick(evt: IElmerEvent): void;
    handleOnItemDblClick(evt: IElmerEvent): void;
    $didMount(): void;
    $willReceiveProps(newProps: any): void;
    render(): any;
    private selectedDataChange;
}
export {};
