"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeView = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./styles/index.less");
require("./TreeViewItem");
require("./TreeViewList");
var TreeView = (function (_super) {
    __extends(TreeView, _super);
    function TreeView(props) {
        var _this = _super.call(this, props) || this;
        _this.data = [];
        _this.level = 0;
        _this.containerWidth = 0;
        _this.settingWidthToChild = false;
        _this.selectedData = [];
        _this.changeOnDblClick = true;
        _this.data = props.data || [];
        _this.changeOnDblClick = props.changeOnDblClick;
        return _this;
    }
    TreeView.prototype.handleOnUpdateChildren = function (data) {
        this.data = data;
    };
    TreeView.prototype.handleOnItemClick = function (evt) {
        var dom = this.dom[this.id];
        var domList = this.domObj.find(dom, "li label");
        this.domObj.removeClass(domList, "active");
        this.domObj.addClass(evt.target, "active");
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        !this.changeOnDblClick && this.selectedDataChange(evt, evt.data);
    };
    TreeView.prototype.handleOnItemDblClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.changeOnDblClick && this.selectedDataChange(evt, evt.data);
    };
    TreeView.prototype.$didMount = function () {
        var parent = this.dom[this.id];
        if (parent && this.containerWidth <= 0 && !this.settingWidthToChild) {
            this.setData({
                containerWidth: parent.offsetWidth
            });
        }
    };
    TreeView.prototype.$willReceiveProps = function (newProps) {
        this.setData({
            data: newProps.data
        }, true);
        console.log(newProps);
    };
    TreeView.prototype.render = function () {
        return require("./views/index.html");
    };
    TreeView.prototype.selectedDataChange = function (evt, data) {
        if (this.props.isMutil) {
            var valueKey = this.props.valueKey || "key";
            var isExists = false;
            var index = -1;
            for (var i = 0; i < this.selectedData.length; i++) {
                if (this.selectedData[i][valueKey] === data[valueKey]) {
                    isExists = true;
                    index = i;
                    break;
                }
            }
            if (!isExists) {
                var tmpData = JSON.parse(JSON.stringify(this.selectedData)) || [];
                tmpData.push(data);
                this.setData({
                    selectedData: tmpData
                });
            }
            else {
                var tmpData = JSON.parse(JSON.stringify(this.selectedData)) || [];
                tmpData.splice(index, 1);
                this.setData({
                    selectedData: tmpData
                });
            }
        }
        else {
            this.setData({
                selectedData: [data]
            });
        }
        typeof this.props.onChange === "function" && this.props.onChange(evt, this.selectedData);
    };
    TreeView.propType = {
        data: elmer_ui_core_1.propTypes.array,
        onChange: elmer_ui_core_1.propTypes.func,
        onExpandClick: elmer_ui_core_1.propTypes.func,
        changeOnDblClick: {
            defaultValue: true,
            description: "chang事件是否在双击事件",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        isMutil: {
            defaultValue: false,
            description: "是否可多选",
            rule: elmer_ui_core_1.propTypes.boolean
        },
        valueKey: {
            defaultValue: "value",
            description: "value字段名",
            rule: elmer_ui_core_1.propTypes.oneOf([elmer_ui_core_1.propTypes.string, elmer_ui_core_1.propTypes.number])
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], TreeView.prototype, "domObj", void 0);
    TreeView = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "treeView"
        }),
        __metadata("design:paramtypes", [Object])
    ], TreeView);
    return TreeView;
}(elmer_ui_core_1.Component));
exports.TreeView = TreeView;
