"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Desktop = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
require("./app/setting");
require("./state/reducer");
var MatrixCharacterEffects_1 = require("./backgroundPlugin/MatrixCharacterEffects");
var PictureBackground_1 = require("./backgroundPlugin/PictureBackground");
require("./config/service");
var DesktopModel_1 = require("./DesktopModel");
require("./styles/desktop.less");
var Desktop = (function (_super) {
    __extends(Desktop, _super);
    function Desktop() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.supportThemes = {
            default: "default",
            themeDesktop: "themeDesktop",
            themeDefault: "themeDefault",
            themeNoBack: "themeNoBackground"
        };
        _this.theme = "default";
        _this.cavId = _this.getRandomID();
        _this.reduxConfig = {};
        return _this;
    }
    Desktop.prototype.$init = function () {
        this.setTheme("themeNoBack", this.supportThemes);
    };
    Desktop.prototype.$inject = function () {
        this.model.obj.setBackgroundPluginData(this.props.backgroundPlugin);
        this.model.obj.setBackgroundPluginId(this.props.userWallperPlugin);
    };
    Desktop.prototype.$onPropsChanged = function (props) {
        if (JSON.stringify(props.backgroundConfig) !== JSON.stringify(this.backgroundConfig)) {
            this.backgroundConfig = props.backgroundConfig;
        }
        this.model.obj.onPropsChange(props);
    };
    Desktop.prototype.$after = function () {
        this.addEvent(this, document.body, "contextmenu", function (evt) {
            evt.nativeEvent.preventDefault();
            return false;
        });
        this.model.obj.setCanvas(this.dom[this.cavId]);
        this.model.obj.start();
    };
    Desktop.prototype.$dispose = function () {
        this.setTheme("default", this.supportThemes);
        this.model.obj.stop();
    };
    Desktop.prototype.$resize = function () {
        var _this = this;
        return function (width, height) {
            _this.model.obj.onResize(width, height);
        };
    };
    Desktop.propType = {
        userWallperPlugin: {
            defaultValue: "images",
            description: "设置背景使用的插件id",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        autoRunAppList: {
            defaultValue: [],
            description: "系统启动运行程序",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        backgroundConfig: {
            description: "背景设置参数",
            rule: elmer_ui_core_1.PropTypes.any
        },
        backgroundPlugin: {
            description: "背景渲染插件",
            rule: elmer_ui_core_1.PropTypes.array
        },
        template: {
            defaultValue: "Win10",
            description: "设置管理系统模板",
            rule: elmer_ui_core_1.PropTypes.oneValueOf(["Win10", "WebAdmin", "Office"])
        },
        deskTopApp: {
            defaultValue: [],
            description: "显示桌面快捷菜单",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        mainMenuList: {
            defaultValue: [],
            description: "主菜单列表",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        quickStartMenu: {
            defaultValue: [],
            description: "快捷菜单",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        }
    };
    Desktop = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "desktop",
            template: {
                url: "./views/index.html",
                fromLoader: true
            },
            model: {
                obj: DesktopModel_1.DesktopModel
            },
            connect: {
                mapStateToProps: function (state) {
                    return {
                        autoRunAppList: state.desktop.autoRunAppList,
                        backgroundPlugin: [
                            {
                                id: "hackers",
                                title: "黑客帝国",
                                factory: MatrixCharacterEffects_1.MatrixCharacterEffects
                            }, {
                                id: "images",
                                title: "背景图片",
                                factory: PictureBackground_1.PictureBackground
                            }
                        ],
                        backgroundConfig: state.desktop.background,
                        deskTopApp: state.desktop.deskTopApp,
                        mainMenuList: state.desktop.mainMenuList,
                        quickStartMenu: state.desktop.quickStartMenu,
                        template: state.desktop.template,
                        userWallperPlugin: state.desktop.userWallperPlugin || "images"
                    };
                }
            }
        })
    ], Desktop);
    return Desktop;
}(elmer_ui_core_1.Component));
exports.Desktop = Desktop;
