import { IContentMenuItem } from "../components/menu";
export declare type DesktopRunData = {
    type: "ElmerUI" | "React" | "Angular" | "Vue" | "Url" | "CallMethod" | "Route";
    props?: any;
    component?: string | Function;
    width?: number | string;
    height?: number | string;
    icon?: string;
    theme?: string;
    bottom?: string;
    bottomTheme?: string;
    showBottom?: boolean;
    showBarMax?: boolean;
    showBarMin?: boolean;
    showBarClose?: boolean;
    showIcon?: boolean;
    maxBarTheme?: string;
    titleTheme?: string;
    url?: string;
    hashRouter?: boolean;
};
export declare type DesktopApp = {
    title: string;
    icon: string;
    id: string;
    description?: string;
    data?: DesktopRunData;
};
export declare type TypeStartMenu = {
    name: string;
    id?: string;
    data?: DesktopApp[];
};
export declare const createDesktopAppContent: (appData: DesktopApp) => string;
export declare const demoAppData: DesktopApp[];
export declare const winStartmenuSideButtons: DesktopApp[];
export declare const DesktopMenus: IContentMenuItem[];
export declare const mainMenuList: TypeStartMenu[];
export declare const SystemQuickStartTool: TypeStartMenu;
export declare const autoRunAppList: DesktopApp[];
