"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DesktopModel = void 0;
var Canvas_1 = require("elmer-common/lib/Canvas/Canvas");
var DesktopModel = (function (_super) {
    __extends(DesktopModel, _super);
    function DesktopModel(obj) {
        var _this = _super.call(this) || this;
        _this.supportCanvas = false;
        _this.pluginData = [];
        _this.dom = obj;
        return _this;
    }
    DesktopModel.prototype.onPropsChange = function (props) {
        if (this.plugin) {
            this.plugin.onPropsChange(props);
        }
    };
    DesktopModel.prototype.setCanvas = function (cav) {
        this.cav = cav;
        this.supportCanvas = cav && cav.getContext("2d") !== null;
    };
    DesktopModel.prototype.setBackgroundPluginData = function (pluginData) {
        if (pluginData && pluginData.length > 0) {
            this.pluginData = pluginData;
        }
    };
    DesktopModel.prototype.setBackgroundPluginId = function (id) {
        for (var _i = 0, _a = this.pluginData; _i < _a.length; _i++) {
            var plugin = _a[_i];
            if (plugin.id === id) {
                this.userPlugin = plugin;
                break;
            }
        }
    };
    DesktopModel.prototype.start = function () {
        try {
            if (this.supportCanvas) {
                if (this.userPlugin && typeof this.userPlugin.factory === "function") {
                    this.plugin = new this.userPlugin.factory(this.cav, this.dom.props);
                    typeof this.plugin.init === "function" && this.plugin.init();
                    if (this.plugin.isAnimation) {
                        this.animationHandler = this.startAnimation(this.animation, this);
                    }
                    else {
                        typeof this.plugin.draw === "function" && this.plugin.draw(0);
                    }
                }
                else {
                    console.error("Background Plugin is not an function");
                }
            }
            else {
                console.error("Your browser not support Canvas. Upgrade your browser maybe resolve this problem.");
            }
        }
        catch (e) {
            console.error(e);
        }
    };
    DesktopModel.prototype.stop = function () {
        (this.plugin && typeof this.plugin.dispose === "function") && this.plugin.dispose();
        this.plugin = null;
        this.userPlugin = null;
        this.pluginData = null;
        this.stopAnimation(this.animationHandler);
    };
    DesktopModel.prototype.animation = function (tim) {
        typeof this.plugin.draw === "function" && this.plugin.draw(tim);
    };
    DesktopModel.prototype.onResize = function (width, height) {
        (this.plugin && typeof this.plugin.resize === "function") && this.plugin.resize(width, height);
    };
    return DesktopModel;
}(Canvas_1.Canvas));
exports.DesktopModel = DesktopModel;
