"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.commonHandler = void 0;
var elmer_common_1 = require("elmer-common");
var components_1 = require("../components");
var commonHandler = function (resp, errorResponse) {
    if (resp.statusCode !== 200) {
        if (!elmer_common_1.StaticCommon.isEmpty(resp.statusCode)) {
            var msg = resp.message || resp.info || resp.statusText || "请求失败";
            components_1.showToast(msg + (" (" + resp.statusCode + ")"));
            return true;
        }
        else {
            if (!elmer_common_1.StaticCommon.isEmpty(resp.success) && !resp.success) {
                var msg = resp.message || resp.info || resp.statusText || "请求失败";
                components_1.showToast(msg);
                return true;
            }
        }
    }
    if (errorResponse) {
        var msg = resp.message || resp.info || resp.statusText || "请求失败";
        components_1.showToast(msg);
        return true;
    }
};
exports.commonHandler = commonHandler;
