"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoginPageComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var LoginPageComponent = (function (_super) {
    __extends(LoginPageComponent, _super);
    function LoginPageComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.loginProps = {};
        for (var key in props) {
            if (["children", "copyRight"].indexOf(key) < 0) {
                _this.loginProps[key] = props[key];
            }
        }
        return _this;
    }
    LoginPageComponent.propType = {
        copyRight: {
            defaultValue: "©2010-2019 All right by elmer",
            description: "copy right information",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        userNamePH: {
            defaultValue: "邮箱或手机号码",
            description: "UserName Placeholder",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        userName: {
            defaultValue: "",
            description: "默认登录用户名",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        passwordPH: {
            defaultValue: "登录密码",
            description: "password Placeholder",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        loginText: {
            defaultValue: "登录",
            description: "Login button title",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        loginApiEndPoint: {
            description: "the link for send login request",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        loginApiNamespace: {
            description: "set namespace for the api endPoint config",
            rule: elmer_ui_core_1.PropTypes.string
        },
        registeText: {
            defaultValue: "注册账户",
            description: "registe link title",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        registeURL: {
            defaultValue: "javascript:void(0);",
            description: "registe link url",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        forgetText: {
            defaultValue: "忘记密码？",
            description: "forget link title",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        forgetURL: {
            defaultValue: "javascript:void(0);",
            description: "forget link url",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        onRegisteClick: {
            description: "Handle on registe link click event",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onForgetClick: {
            description: "Handle on forget link click event",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onBeforeLogin: {
            description: "before login event",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onAfterLogin: {
            description: "after login action when login success",
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    LoginPageComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "AppLogin",
            template: {
                url: "./index.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], LoginPageComponent);
    return LoginPageComponent;
}(elmer_ui_core_1.Component));
exports.LoginPageComponent = LoginPageComponent;
