"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var top_1 = require("./top");
var leftMenu_1 = require("./leftMenu");
require("./css/css.css");
require("./css/index.less");
var WebAdmin = (function (_super) {
    __extends(WebAdmin, _super);
    function WebAdmin(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            openMenuList: []
        };
        _this.mainMenu = {
            id: "49c496d7-d291-f28f-bd26-3b2d0ce8",
            title: "网站首页",
            data: {
                type: "Route",
                component: "/"
            }
        };
        _this.sessionDataID = "b0f0038c-99c5-f04a-337e-c1cd55d2";
        var defaultMenuList = [_this.mainMenu];
        var openMenu = _this.getLastOpenMenu();
        if (openMenu) {
            if (openMenu.id !== _this.mainMenu.id) {
                defaultMenuList.push(openMenu);
            }
            _this.state.defaultOpenMenu = openMenu;
        }
        _this.state.openMenuList = defaultMenuList;
        return _this;
    }
    WebAdmin.prototype.handleOnCloseTab = function (data) {
        var openList = this.state.openMenuList;
        var newOpenList = [];
        var closeIndex = -1;
        var activeIndex = 0;
        for (var i = 0; i < openList.length; i++) {
            if (openList[i].id !== data.id || openList[i].id === this.mainMenu.id) {
                newOpenList.push(openList[i]);
            }
            else {
                closeIndex = i;
            }
        }
        if (closeIndex > 0) {
            if (closeIndex < newOpenList.length) {
                activeIndex = closeIndex;
            }
            else {
                activeIndex = closeIndex - 1;
            }
        }
        this.setState({
            defaultOpenMenu: newOpenList[activeIndex],
            openMenuList: newOpenList
        });
    };
    WebAdmin.prototype.handleOnTopMenuClick = function (data) {
        this.openMenu(data);
    };
    WebAdmin.prototype.handleOnLeftMenuClick = function (evt) {
        var menuData = evt.data;
        if (menuData) {
            this.openMenu(menuData);
        }
    };
    WebAdmin.prototype.handleOnMenuSwitchClick = function (hideMenu) {
        this.setState({
            hideMenu: hideMenu
        });
    };
    WebAdmin.prototype.openMenu = function (menuData) {
        if (this.props.menuList && this.props.menuList.length > 0) {
            var isFindOpenItem = false;
            for (var key in this.state.openMenuList) {
                var openMenu = this.state.openMenuList[key];
                if (openMenu.id === menuData.id) {
                    this.setState({
                        defaultOpenMenu: menuData
                    });
                    isFindOpenItem = true;
                    break;
                }
            }
            if (!isFindOpenItem) {
                var openList = JSON.parse(JSON.stringify(this.state.openMenuList));
                openList.push(menuData);
                this.setState({
                    defaultOpenMenu: menuData,
                    openMenuList: openList
                });
            }
        }
    };
    WebAdmin.prototype.getLastOpenMenu = function () {
        var ssStr = sessionStorage.getItem(this.sessionDataID);
        if (!this.isEmpty(ssStr)) {
            var sJson = JSON.parse(ssStr);
            return sJson.selectSubMenu;
        }
    };
    WebAdmin.propType = {
        menuList: {
            defaultValue: [],
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        }
    };
    WebAdmin = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "WebAdmin",
            template: {
                url: "./views/index.html",
                fromLoader: true
            },
            connect: {
                mapStateToProps: function (state) {
                    return {
                        menuList: state.desktop.mainMenuList,
                        webconfig: state.desktop.webconfig
                    };
                }
            },
            components: [{
                    selector: "WebAdminTop",
                    component: top_1.default
                }, {
                    selector: "WebLeftMenu",
                    component: leftMenu_1.default
                }]
        }),
        __metadata("design:paramtypes", [Object])
    ], WebAdmin);
    return WebAdmin;
}(elmer_ui_core_1.Component));
exports.default = WebAdmin;
