"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var WebAdminLeftMenu = (function (_super) {
    __extends(WebAdminLeftMenu, _super);
    function WebAdminLeftMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            hideMenu: false,
            menuData: [],
            selectMenu: {},
            selectSubMenu: {}
        };
        _this.sessionDataID = "b0f0038c-99c5-f04a-337e-c1cd55d2";
        _this.selectMenuChange = false;
        _this.state.menuData = props.data || [];
        return _this;
    }
    WebAdminLeftMenu.prototype.$after = function () {
        if (!this.selectMenuChange) {
            var saveDataStr = sessionStorage.getItem(this.sessionDataID);
            var saveData = !this.isEmpty(saveDataStr) ? JSON.parse(saveDataStr) : {};
            if (!this.isEmpty(saveData.selectMenu) && !this.isEmpty(saveData.selectSubMenu)) {
                this.showHideMenu(saveData.selectMenu, true);
                this.setState({
                    selectSubMenu: saveData.selectSubMenu
                });
                this.selectMenuChange = true;
            }
        }
    };
    WebAdminLeftMenu.prototype.handleOnMenuClick = function (evt) {
        var _this = this;
        var menuData = evt.data.item;
        var nextAction = !menuData.isExpand;
        this.selectMenuChange = true;
        if (nextAction) {
            this.$.animation({
                dom: evt.target.parentElement,
                type: "SineEaseIn",
                duration: 300,
                to: {
                    height: 35 * (menuData.data.length + 1)
                },
                onFinish: function () {
                    _this.showHideMenu(menuData, nextAction, true);
                    _this.$.css(evt.target.parentElement, "height", "");
                }
            });
        }
        else {
            this.$.animation({
                dom: evt.target.parentElement,
                type: "SineEaseIn",
                duration: 300,
                to: {
                    height: 35
                },
                onFinish: function () {
                    _this.$.css(evt.target.parentElement, "height", "");
                    _this.showHideMenu(menuData, nextAction, true);
                }
            });
        }
    };
    WebAdminLeftMenu.prototype.handleOnSwitchBarClick = function () {
        var hideMenu = !this.state.hideMenu;
        this.setState({
            hideMenu: hideMenu,
        });
        typeof this.props.onSwitchClick === "function" && this.props.onSwitchClick(hideMenu);
    };
    WebAdminLeftMenu.prototype.handleOnMenuItemClick = function (evt) {
        var selectMenu = evt.data.item;
        var selectSubMenu = evt.data.subItem;
        var saveDataStr = sessionStorage.getItem(this.sessionDataID);
        var saveData = !this.isEmpty(saveDataStr) ? JSON.parse(saveDataStr) : {};
        this.selectMenuChange = true;
        this.setState({
            selectMenu: selectMenu,
            selectSubMenu: selectSubMenu
        });
        sessionStorage.setItem(this.sessionDataID, JSON.stringify(__assign(__assign({}, saveData), { selectMenu: selectMenu,
            selectSubMenu: selectSubMenu })));
        typeof this.props.onClick === "function" && this.props.onClick({
            data: selectSubMenu
        });
    };
    WebAdminLeftMenu.prototype.render = function () {
        return require("./views/left.html");
    };
    WebAdminLeftMenu.prototype.showHideMenu = function (menuData, isExpand, updateState) {
        var sourceData = JSON.parse(JSON.stringify(this.state.menuData));
        for (var key in sourceData) {
            if (parseInt(key, 10) === menuData.key) {
                sourceData[key].isExpand = isExpand;
                break;
            }
        }
        if (updateState) {
            this.setState({
                menuData: sourceData
            });
        }
        else {
            this.state.menuData = sourceData;
        }
    };
    WebAdminLeftMenu.propType = {
        data: {
            defaultValue: [],
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        onSwitchClick: {
            rule: elmer_ui_core_1.PropTypes.func
        },
        onClick: {
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], WebAdminLeftMenu.prototype, "$", void 0);
    return WebAdminLeftMenu;
}(elmer_ui_core_1.Component));
exports.default = WebAdminLeftMenu;
