"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var elmer_ui_core_1 = require("elmer-ui-core");
var WebAdminTop = (function (_super) {
    __extends(WebAdminTop, _super);
    function WebAdminTop(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            menuList: [],
            selectedMenu: {}
        };
        _this.scrollIndex = 0;
        _this.position = 0;
        _this.sessionDataID = "b0f0038c-99c5-f04a-337e-c1cd55d2";
        _this.state.menuList = props.menuList || [];
        if (props.selectedMenu) {
            _this.state.selectedMenu = props.selectedMenu;
        }
        else {
            _this.state.selectedMenu = _this.state.menuList[0];
        }
        return _this;
    }
    WebAdminTop.prototype.handleOnCloseClick = function () {
        typeof this.props.onClose === "function" && this.props.onClose(this.state.selectedMenu);
    };
    WebAdminTop.prototype.$onPropsChanged = function (props) {
        if (!this.isEqual(props.menuList, this.state.menuList)) {
            this.setState({
                menuList: props.menuList,
                selectedMenu: props.selectedMenu
            });
        }
        else {
            if (!this.isEqual(props.selectedMenu, this.state.selectedMenu)) {
                this.setState({
                    selectedMenu: props.selectedMenu
                });
            }
        }
    };
    WebAdminTop.prototype.handleOnMenuItemClick = function (evt) {
        var menuData = evt.data.item;
        if (menuData.id !== this.state.selectedMenu.id) {
            this.setState({
                selectedMenu: menuData
            });
            typeof this.props.onChange === "function" && this.props.onChange(menuData);
            var saveValue = sessionStorage.getItem(this.sessionDataID);
            if (!this.isEmpty(saveValue)) {
                var saveData = JSON.parse(saveValue);
                if (menuData.id === this.state.menuList[0].id) {
                    saveData.selectSubMenu = menuData;
                    saveData.selectMenu = {};
                }
                sessionStorage.setItem(this.sessionDataID, JSON.stringify(saveData));
            }
            else {
                sessionStorage.setItem(this.sessionDataID, JSON.stringify({
                    selectSubMenu: menuData,
                    selectMenu: {}
                }));
            }
        }
    };
    WebAdminTop.prototype.handleOnScollTopClick = function () {
        var itemHeight = this.getMenuItemHeight();
        var scrollParent = this.dom["topMenuCT"];
        if (scrollParent && this.scrollIndex > 0) {
            var toIndex = this.scrollIndex - 1;
            var toTop = toIndex * itemHeight;
            this.scrollIndex = toIndex;
            this.$.css(scrollParent, "margin-top", -toTop);
        }
    };
    WebAdminTop.prototype.handleOnScollBottomClick = function () {
        var itemHeight = this.getMenuItemHeight();
        var scrollParent = this.dom["topMenuCT"];
        var maxIndex = this.getScrollMaxLine();
        if (scrollParent && this.scrollIndex < maxIndex - 1) {
            var toIndex = this.scrollIndex + 1;
            var toTop = toIndex * itemHeight;
            this.scrollIndex = toIndex;
            this.$.css(scrollParent, "margin-top", -toTop);
        }
    };
    WebAdminTop.prototype.render = function () {
        return require("./views/top.html");
    };
    WebAdminTop.prototype.getScrollMaxLine = function () {
        var itemHeight = this.getMenuItemHeight();
        var listHeight = this.getScrollHeight();
        var maxLine = Math.ceil(listHeight / itemHeight);
        if (maxLine === 2 && listHeight < itemHeight * 2) {
            maxLine = 1;
        }
        return maxLine;
    };
    WebAdminTop.prototype.getMenuItemHeight = function () {
        var scrollDom = this.dom["topMenuCT"];
        var firstDom = scrollDom.firstChild;
        return firstDom ? firstDom.clientHeight : 37;
    };
    WebAdminTop.prototype.getScrollHeight = function () {
        var scrollDom = this.dom["topMenuCT"];
        return scrollDom.clientHeight;
    };
    WebAdminTop.propType = {
        menuList: {
            defaultValue: [],
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        onChange: {
            description: "菜单切换事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        companyName: {
            defaultValue: "江涛工作室",
            description: "公司名称",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        systemName: {
            defaultValue: "后台管理系统",
            description: "系统名称",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        selectedMenu: {
            description: "默认菜单",
            rule: elmer_ui_core_1.PropTypes.any
        },
        onLoginout: {
            description: "点击注销按钮事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        loginoutName: {
            defaultValue: "注销",
            description: "注销按钮名称",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        adminHome: {
            defaultValue: "管理首页",
            description: "管理系统首页名称",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        onAdminHome: {
            description: "点击管理首页事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        systemHome: {
            defaultValue: "网站首页",
            description: "系统首页名称",
            rule: elmer_ui_core_1.PropTypes.string
        },
        onSystemHome: {
            description: "点击系统首页事件",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onClose: {
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], WebAdminTop.prototype, "$", void 0);
    return WebAdminTop;
}(elmer_ui_core_1.Component));
exports.default = WebAdminTop;
