import { Component, IElmerEvent, IPropCheckRule } from "elmer-ui-core";
import "./index.less";
declare type TypeLoginProps = {
    userNamePH: IPropCheckRule;
    userName: IPropCheckRule;
    passwordPH: IPropCheckRule;
    loginText: IPropCheckRule;
    loginApiEndPoint: IPropCheckRule;
    loginApiNamespace: IPropCheckRule;
    registeText: IPropCheckRule;
    registeURL: IPropCheckRule;
    forgetText: IPropCheckRule;
    forgetURL: IPropCheckRule;
    onRegisteClick: IPropCheckRule;
    onForgetClick: IPropCheckRule;
    onBeforeLogin: IPropCheckRule;
    onAfterLogin: IPropCheckRule;
};
declare type TypeLoginStateKeys = Exclude<keyof TypeLoginProps, "onRegisteClick" | "onForgetClick">;
declare type TypeLoginState = {
    [P in TypeLoginStateKeys]?: any;
} & {
    password?: string;
    isLoading?: boolean;
    formTheme?: string;
    isDoLogin?: boolean;
};
export declare class LoginComponent extends Component {
    static propType: TypeLoginProps;
    state: TypeLoginState;
    props: {
        [P in keyof TypeLoginProps]: any;
    };
    logoId: string;
    isDoLogin: boolean;
    private ajax;
    constructor(props: any);
    onLoginClick(): void;
    onRegisteClick(evt: IElmerEvent): void;
    onForgetClick(evt: IElmerEvent): void;
    $after(): void;
    private onLogoTransitionEnd;
    private doLogin;
}
export {};
