"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoginComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var toast_1 = require("../../../components/toast");
require("./index.less");
var LoginComponent = (function (_super) {
    __extends(LoginComponent, _super);
    function LoginComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            userName: "",
            password: "",
            isDoLogin: false
        };
        _this.logoId = _this.getRandomID();
        _this.isDoLogin = false;
        for (var key in props) {
            if (["onRegisteClick", "onForgetClick", "children"].indexOf(key) < 0) {
                _this.state[key] = props[key];
            }
        }
        return _this;
    }
    LoginComponent.prototype.onLoginClick = function () {
        this.setState({
            formTheme: "eui-login-loading-layout",
            isDoLogin: true
        });
    };
    LoginComponent.prototype.onRegisteClick = function (evt) {
        typeof this.props.onRegisteClick === "function" && this.props.onRegisteClick(evt);
    };
    LoginComponent.prototype.onForgetClick = function (evt) {
        typeof this.props.onForgetClick === "function" && this.props.onForgetClick(evt);
    };
    LoginComponent.prototype.$after = function () {
    };
    LoginComponent.prototype.onLogoTransitionEnd = function () {
        if (this.state.isDoLogin) {
            this.state.isDoLogin = false;
            this.doLogin();
        }
    };
    LoginComponent.prototype.doLogin = function () {
        var _this = this;
        var sendData = {
            userName: this.state.userName,
            password: this.state.password
        };
        var beforeEvent = {
            data: sendData,
            cancel: false
        };
        typeof this.props.onBeforeLogin === "function" && this.props.onBeforeLogin(beforeEvent);
        try {
            if (beforeEvent.cancel) {
                return;
            }
            else {
                if (this.isEmpty(sendData.userName)) {
                    throw new Error("请输入登录帐号");
                }
            }
            this.setState({
                formTheme: "eui-login-loading-layout eui-login-loading-form",
                isLoading: true
            });
            this.ajax.sendRequest({
                endPoint: this.state.loginApiEndPoint,
                namespace: this.state.loginApiNamespace,
                type: "POST",
                data: sendData,
                success: function (resp) {
                    if (typeof _this.props.onAfterLogin === "function") {
                        var result = _this.props.onAfterLogin(resp);
                        if (result && typeof result.then === "function") {
                            result.then(function () {
                                _this.setState({
                                    isLoading: false,
                                    formTheme: ""
                                });
                            }).catch(function () {
                                _this.setState({
                                    isLoading: false,
                                    formTheme: ""
                                });
                            });
                        }
                        else {
                            _this.setState({
                                isLoading: false,
                                formTheme: ""
                            });
                        }
                    }
                    else {
                        if (resp.statusCode === 200 || resp.success) {
                            toast_1.showToast("登录成功", {
                                icon: "Success"
                            });
                        }
                        else {
                            toast_1.showToast(resp.message || resp.info || "未知错误信息", {
                                icon: "Error"
                            });
                        }
                        _this.setState({
                            isLoading: false,
                            formTheme: ""
                        });
                    }
                }, fail: function (err) {
                    toast_1.showToast(err.message || err.info || err.statusText || "未知错误信息", {
                        icon: "Error"
                    });
                    _this.setState({
                        isLoading: false,
                        formTheme: ""
                    });
                }
            });
        }
        catch (e) {
            toast_1.showToast(e.message);
            this.setState({
                isLoading: false,
                formTheme: ""
            });
        }
    };
    LoginComponent.propType = {
        userNamePH: {
            defaultValue: "邮箱或手机号码",
            description: "UserName Placeholder",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        userName: {
            defaultValue: "",
            description: "默认登录用户名",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        passwordPH: {
            defaultValue: "登录密码",
            description: "password Placeholder",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        loginText: {
            defaultValue: "登录",
            description: "Login button title",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        loginApiEndPoint: {
            description: "the link for send login request",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        loginApiNamespace: {
            description: "set namespace for the api endPoint config",
            rule: elmer_ui_core_1.PropTypes.string
        },
        registeText: {
            defaultValue: "注册账户",
            description: "registe link title",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        registeURL: {
            defaultValue: "javascript:void(0);",
            description: "registe link url",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        forgetText: {
            defaultValue: "忘记密码？",
            description: "forget link title",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        forgetURL: {
            defaultValue: "javascript:void(0);",
            description: "forget link url",
            rule: elmer_ui_core_1.PropTypes.string.isRequired
        },
        onRegisteClick: {
            description: "Handle on registe link click event",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onForgetClick: {
            description: "Handle on forget link click event",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onBeforeLogin: {
            description: "before login event",
            rule: elmer_ui_core_1.PropTypes.func
        },
        onAfterLogin: {
            description: "after login action when login success",
            rule: elmer_ui_core_1.PropTypes.func
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerServiceRequest),
        __metadata("design:type", elmer_ui_core_1.ElmerServiceRequest)
    ], LoginComponent.prototype, "ajax", void 0);
    LoginComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "login",
            template: {
                url: "./index.html",
                fromLoader: true
            }
        }),
        __metadata("design:paramtypes", [Object])
    ], LoginComponent);
    return LoginComponent;
}(elmer_ui_core_1.Component));
exports.LoginComponent = LoginComponent;
