"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Win10ToolBarComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var Win10ToolBarComponent = (function (_super) {
    __extends(Win10ToolBarComponent, _super);
    function Win10ToolBarComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            tabs: [],
            activeId: ""
        };
        if (_this.isArray(props.data) && props.data.length > 0) {
            _this.state.tabs = props.data;
        }
        if (_this.isString(props.activeId)) {
            _this.state.activeId = props.activeId;
        }
        return _this;
    }
    Win10ToolBarComponent.prototype.$onPropsChanged = function (props) {
        if (JSON.stringify(props.data) !== JSON.stringify(this.state.tabs)) {
            this.setState({
                tabs: props.data,
                activeId: props.activeId
            });
        }
        else {
            if (props.activeId !== this.state.activeId) {
                this.setState({
                    activeId: props.activeId
                });
            }
        }
    };
    Win10ToolBarComponent.prototype.handleOnTabClick = function (evt) {
        var eventPath = typeof evt.nativeEvent.composedPath === "function" ? evt.nativeEvent.composedPath() : evt.nativeEvent.path;
        if (eventPath) {
            if (this.isArray(eventPath)) {
                var index = 0, maxLength = eventPath.length;
                var target = void 0;
                while (index < maxLength && !target) {
                    if (eventPath[index].tagName === "LI") {
                        target = eventPath[index];
                        break;
                    }
                    index += 1;
                }
                maxLength = null;
                if (!target) {
                    console.warn("Can not get the app Item,Maybe browser compatibility issues.");
                }
                else {
                    var dataKey = target.getAttribute("data-id");
                    this.setState({
                        activeId: dataKey
                    });
                    typeof this.props.onClick === "function" && this.props.onClick(__assign(__assign({}, evt), { data: dataKey }));
                    dataKey = null;
                }
            }
        }
        else {
            console.warn("Browser not support");
        }
        eventPath = null;
    };
    Win10ToolBarComponent.prototype.render = function () {
        return require("./views/toolBar.html");
    };
    Win10ToolBarComponent.propType = {
        activeId: {
            description: "Current App ID",
            rule: elmer_ui_core_1.propTypes.string
        },
        data: {
            defaultValue: [],
            description: "Source data",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        onClick: {
            description: "Click Event",
            rule: elmer_ui_core_1.propTypes.func
        }
    };
    Win10ToolBarComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "win10-toolbar"
        }),
        __metadata("design:paramtypes", [Object])
    ], Win10ToolBarComponent);
    return Win10ToolBarComponent;
}(elmer_ui_core_1.Component));
exports.Win10ToolBarComponent = Win10ToolBarComponent;
