import { Component, IElmerEvent, IElmerMouseEvent, IPropCheckRule } from "elmer-ui-core";
import { IContentMenuItem } from "../../components/menu";
import { DesktopApp } from "../DesktopApp";
import "./styles/win10.less";
import "./Toolbar";
import "./WinStartMenu";
declare type DeskTopWin10State = {
    windowTime: string;
    windowDate: string;
    wWidth?: number;
    wHeight?: number;
    isInitAppPosition?: boolean;
    desktopApp: DesktopApp[];
    openWindows: DesktopApp[];
    activeAppId: string;
    showCalendar: boolean;
    showStartMenu: boolean;
    startMenuList: DesktopApp[];
    desktopMenuVisible: boolean;
    desktopMenuStyle: string;
};
declare type TypeDesktopWin10PropsRules = {
    autoRunAppList: IPropCheckRule;
    deskTopAppList: IPropCheckRule;
    startMenuList: IPropCheckRule;
    quickStartMenu: IPropCheckRule;
};
declare type TypeDesktopWin10Props = {
    [P in keyof TypeDesktopWin10PropsRules]: any;
};
export declare class DeskTopWin10 extends Component {
    static propType: TypeDesktopWin10PropsRules;
    timeHandler: any;
    state: DeskTopWin10State;
    openAppList: any;
    windowMaxZIndex: number;
    windowNormalZIndex: number;
    desktopMenu: IContentMenuItem[];
    props: TypeDesktopWin10Props;
    private $;
    constructor(props: TypeDesktopWin10Props);
    $after(): void;
    $dispose(): void;
    $resize(): Function;
    handleOnStartMenuClick(data: DesktopApp): void;
    handleOnDesktopMenuClick(evt: IElmerEvent): void;
    handleOnDesktopMouseUp(evt: IElmerMouseEvent): void;
    handleOnStartMenuOutClick(): void;
    handleOnAppTimeOutClick(): void;
    handleOnStartButtonClick(evt: IElmerEvent): void;
    handleOnAppTimeClick(evt: IElmerEvent): void;
    handleOnAppItemClick(evt: IElmerEvent): void;
    handleOnToolBarClick(evt: IElmerEvent): void;
    timeTick(): void;
    render(): string;
    private openApp;
    private createWindow;
    private moveWindowToTop;
    private removeAppWindow;
    private resetAppPosition;
}
export {};
