"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeskTopWin10 = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var dialog_1 = require("../../components/dialog/dialog");
var menu_1 = require("../../components/menu");
var DesktopApp_1 = require("../DesktopApp");
require("./styles/win10.less");
require("./Toolbar");
require("./WinStartMenu");
var DeskTopWin10 = (function (_super) {
    __extends(DeskTopWin10, _super);
    function DeskTopWin10(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            windowTime: "",
            windowDate: "",
            desktopApp: [],
            openWindows: [],
            activeAppId: "",
            startMenuList: [],
            showCalendar: false,
            showStartMenu: false,
            desktopMenuVisible: false,
            desktopMenuStyle: ""
        };
        _this.openAppList = {};
        _this.windowMaxZIndex = 6;
        _this.windowNormalZIndex = 5;
        _this.desktopMenu = DesktopApp_1.DesktopMenus;
        var now = new Date();
        _this.state.windowTime = now.format("H:i");
        _this.state.windowDate = now.format("YYYY:MM:DD");
        _this.state.wWidth = document.body.clientWidth;
        _this.state.wHeight = document.body.clientHeight;
        _this.state.desktopApp = props.deskTopAppList;
        _this.state.startMenuList = props.startMenuList;
        _this.timeHandler = setInterval(_this.timeTick.bind(_this), 6000);
        now = null;
        return _this;
    }
    DeskTopWin10.prototype.$after = function () {
        var _this = this;
        var autoRunAppList = this.props.autoRunAppList;
        if (!this.state.isInitAppPosition) {
            this.state.isInitAppPosition = true;
            this.resetAppPosition();
            if (autoRunAppList && autoRunAppList.length > 0) {
                autoRunAppList.map(function (tmpApp) {
                    _this.openApp(tmpApp);
                });
            }
        }
        autoRunAppList = null;
    };
    DeskTopWin10.prototype.$dispose = function () {
        this.timeHandler && clearInterval(this.timeHandler);
    };
    DeskTopWin10.prototype.$resize = function () {
        var _this = this;
        return function (width, height) {
            _this.state.wWidth = width;
            _this.state.wHeight = height;
            _this.resetAppPosition();
        };
    };
    DeskTopWin10.prototype.handleOnStartMenuClick = function (data) {
        this.setState({
            showStartMenu: false
        });
        this.openApp(data);
    };
    DeskTopWin10.prototype.handleOnDesktopMenuClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            desktopMenuVisible: false
        });
    };
    DeskTopWin10.prototype.handleOnDesktopMouseUp = function (evt) {
        var mouseX = evt.nativeEvent.clientX, mouseY = evt.nativeEvent.clientY;
        if (evt.nativeEvent.target.tagName === "UL") {
            if (evt.nativeEvent.button === 2) {
                this.setState({
                    desktopMenuStyle: "left: " + mouseX + "px;top: " + mouseY + "px;position:fixed;z-index:10;",
                    desktopMenuVisible: true
                });
            }
            else {
                if (this.state.desktopMenuVisible) {
                    this.setState({
                        desktopMenuVisible: false
                    });
                }
            }
        }
    };
    DeskTopWin10.prototype.handleOnStartMenuOutClick = function () {
        if (this.state.showStartMenu) {
            this.setState({
                showStartMenu: false
            });
        }
    };
    DeskTopWin10.prototype.handleOnAppTimeOutClick = function () {
        if (this.state.showCalendar) {
            this.setState({
                showCalendar: false
            });
        }
    };
    DeskTopWin10.prototype.handleOnStartButtonClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            showStartMenu: !this.state.showStartMenu
        });
    };
    DeskTopWin10.prototype.handleOnAppTimeClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            showCalendar: !this.state.showCalendar
        });
    };
    DeskTopWin10.prototype.handleOnAppItemClick = function (evt) {
        var eventPath = typeof evt.nativeEvent.composedPath === "function" ? evt.nativeEvent.composedPath() : evt.nativeEvent.path;
        var targetDataType = evt.nativeEvent.target.getAttribute("data-type");
        if (evt.nativeEvent.target.tagName !== "UL" && targetDataType !== "AppList") {
            if (this.isArray(eventPath)) {
                var index = 0, maxLength = eventPath.length;
                var target = void 0;
                while (index < maxLength && !target) {
                    if (eventPath[index].tagName === "LI") {
                        target = eventPath[index];
                        break;
                    }
                    index += 1;
                }
                maxLength = null;
                if (!target) {
                    console.warn("Can not get the app Item,Maybe browser compatibility issues.");
                }
                else {
                    var dataKey = target.getAttribute("data-key");
                    var data = this.isNumeric(dataKey) ? this.state.desktopApp[parseInt(dataKey, 10)] : this.state.desktopApp[dataKey];
                    this.openApp(data);
                    dataKey = null;
                    data = null;
                }
            }
        }
        targetDataType = null;
        eventPath = null;
    };
    DeskTopWin10.prototype.handleOnToolBarClick = function (evt) {
        var mouseButton = evt.nativeEvent.button;
        if (mouseButton === 0) {
            this.moveWindowToTop(evt.data);
        }
    };
    DeskTopWin10.prototype.timeTick = function () {
        var now = new Date();
        this.setState({
            windowTime: now.format("H:i"),
            windowDate: now.format("YYYY:MM:DD")
        });
        now = null;
    };
    DeskTopWin10.prototype.render = function () {
        return require("./views/layout.html");
    };
    DeskTopWin10.prototype.openApp = function (appData) {
        this.createWindow(appData);
    };
    DeskTopWin10.prototype.createWindow = function (appData) {
        var _this = this;
        if (appData.data && appData.data.type === "CallMethod") {
            if (typeof appData.data.component === "function") {
                appData.data.component.call(this);
            }
            else {
                typeof window[appData.data.component] === "function" && window[appData.data.component]();
            }
        }
        else {
            var parent_1 = this.dom.container;
            if (parent_1) {
                var openWindow = this.openAppList[appData.id];
                if (!openWindow) {
                    var win = dialog_1.default.open({
                        attrs: appData,
                        parent: parent_1,
                        options: {
                            title: appData.title,
                            icon: appData.icon,
                            showIcon: true,
                            zIndex: this.windowMaxZIndex,
                            width: appData.data && !this.isEmpty(appData.data.width) ? appData.data.width : 400,
                            height: appData.data && !this.isEmpty(appData.data.height) ? appData.data.height : 300,
                        },
                        htmlCode: DesktopApp_1.createDesktopAppContent(appData),
                        onClose: function (data) {
                            _this.removeAppWindow(data.id);
                        },
                        onFocus: function (data) {
                            _this.moveWindowToTop(data.id);
                        }
                    });
                    this.openAppList[appData.id] = win;
                    var stateWindows = JSON.parse(JSON.stringify(this.state.openWindows)) || [];
                    stateWindows.push(appData);
                    this.setState({
                        openWindows: stateWindows,
                        activeAppId: appData.id
                    });
                    this.moveWindowToTop(appData.id);
                    stateWindows = null;
                    win = null;
                }
                else {
                    openWindow.show({
                        options: {
                            zIndex: this.windowMaxZIndex
                        }
                    });
                    this.moveWindowToTop(appData.id);
                }
                openWindow = null;
            }
            parent_1 = null;
            self = null;
        }
    };
    DeskTopWin10.prototype.moveWindowToTop = function (id) {
        var _this = this;
        if (this.openAppList) {
            var maxZIndex_1 = this.windowMaxZIndex;
            var normalZIndex_1 = this.windowNormalZIndex;
            Object.keys(this.openAppList).map(function (appId) {
                var app = _this.openAppList[appId];
                if (app) {
                    if (id === appId) {
                        if (!app.component.options.visible) {
                            app.setZIndex(maxZIndex_1, true);
                        }
                        else {
                            app.zIndex !== maxZIndex_1 && app.setZIndex(maxZIndex_1);
                        }
                    }
                    else {
                        app.zIndex !== normalZIndex_1 && app.setZIndex(normalZIndex_1);
                    }
                }
                app = null;
            });
        }
    };
    DeskTopWin10.prototype.removeAppWindow = function (id) {
        if (this.openAppList && this.openAppList[id]) {
            delete this.openAppList[id];
        }
        var stateWindows = this.state.openWindows || [];
        var updateStateWindows = [];
        for (var i = 0, mLen = stateWindows.length; i < mLen; i++) {
            if (stateWindows[i].id !== id) {
                updateStateWindows.push(stateWindows[i]);
            }
        }
        this.setState({
            openWindows: updateStateWindows
        });
        stateWindows = null;
        updateStateWindows = null;
    };
    DeskTopWin10.prototype.resetAppPosition = function () {
        var appContent = this.dom.appContent;
        if (appContent) {
            var maxAppLineHeight = appContent.clientHeight;
            var maxAppWidth = appContent.clientWidth;
            var appListDom = this.$.find(appContent, ">.eui-desktop-win10-content-app-list");
            if (appListDom && appListDom.length > 0) {
                for (var i = 0, mLen = appListDom.length; i < mLen; i++) {
                    var appList = appListDom[i];
                    var parents = this.$.query("ul", appList);
                    if (parents && parents[0]) {
                        var parent_2 = parents[0];
                        var items = this.$.query("li", parent_2);
                        if (items && items.length > 0) {
                            var line = 0, lineCol = 0, lineHeight = 0, maxNums = items.length;
                            var appItemWidth = 0, allItemWidth = 0;
                            for (var j = 0; j < maxNums; j++) {
                                var appItem = items[j];
                                var appHeight = appItem.clientHeight;
                                var appWidth = appItem.clientWidth;
                                appItemWidth = appWidth;
                                if (lineHeight + appHeight <= maxAppLineHeight) {
                                    this.$.css(appItem, {
                                        left: line * appWidth,
                                        top: lineCol * appHeight,
                                        opacity: 1
                                    });
                                    lineCol += 1;
                                    lineHeight += appHeight;
                                }
                                else {
                                    line += 1;
                                    lineCol = 0;
                                    lineHeight = 0;
                                    this.$.css(appItem, {
                                        left: line * appWidth,
                                        top: lineCol * appHeight,
                                        opacity: 1
                                    });
                                    lineCol += 1;
                                    lineHeight += appHeight;
                                }
                                appItem.style.setProperty("opacity", "1");
                            }
                            maxNums = null;
                            allItemWidth = (line + 1) * appItemWidth;
                            if (allItemWidth > maxAppWidth) {
                                this.$.css(parent_2, "width", allItemWidth);
                            }
                        }
                    }
                }
            }
        }
    };
    DeskTopWin10.propType = {
        autoRunAppList: {
            defaultValue: [],
            description: "页面加载后自动运行的App列表",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        deskTopAppList: {
            defaultValue: [],
            description: "显示在桌面的程序列表",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        startMenuList: {
            defaultValue: [],
            description: "开始菜单数据",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        },
        quickStartMenu: {
            defaultValue: [],
            description: "快速启动菜单",
            rule: elmer_ui_core_1.PropTypes.array.isRequired
        }
    };
    __decorate([
        elmer_ui_core_1.autowired(elmer_ui_core_1.ElmerDOM),
        __metadata("design:type", elmer_ui_core_1.ElmerDOM)
    ], DeskTopWin10.prototype, "$", void 0);
    DeskTopWin10 = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "desktop-win10",
            components: [
                { selector: "menu", component: menu_1.ContentMenu }
            ]
        }),
        __metadata("design:paramtypes", [Object])
    ], DeskTopWin10);
    return DeskTopWin10;
}(elmer_ui_core_1.Component));
exports.DeskTopWin10 = DeskTopWin10;
