"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WinStartmenuComponent = void 0;
var elmer_ui_core_1 = require("elmer-ui-core");
var DesktopApp_1 = require("../DesktopApp");
var WinStartmenuComponent = (function (_super) {
    __extends(WinStartmenuComponent, _super);
    function WinStartmenuComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            data: [],
            leftSideData: DesktopApp_1.winStartmenuSideButtons,
            menuList: [],
            quickStartList: [],
            activeGroupId: "",
            visible: false,
            showAnimation: "",
            theme: ""
        };
        _this.state.theme = !_this.isEmpty(props.theme) ? props.theme : "";
        _this.state.showAnimation = props.visible ? props.showAnimation : "";
        _this.state.quickStartList = props.quickStartList;
        _this.state.menuList = props.menuList || [];
        return _this;
    }
    WinStartmenuComponent.prototype.$onPropsChanged = function (props) {
        if (props.visible !== this.state.visible) {
            this.setState({
                visible: props.visible,
                showAnimation: props.visible ? props.showAnimation : ""
            });
        }
    };
    WinStartmenuComponent.prototype.$after = function () {
        this.addEvent(this, document.body, "click", this.handleOnBodyClick);
    };
    WinStartmenuComponent.prototype.handleOnMenuGroupClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        if (evt.dataSet.id !== this.state.activeGroupId) {
            this.setState({
                activeGroupId: evt.dataSet.id
            });
        }
        else {
            if (!this.isEmpty(this.state.activeGroupId)) {
                this.setState({
                    activeGroupId: ""
                });
            }
        }
    };
    WinStartmenuComponent.prototype.handleOnMenuItemClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            visible: false,
            showAnimation: ""
        });
        typeof this.props.onClick === "function" && this.props.onClick(evt.data.subItem);
    };
    WinStartmenuComponent.prototype.handleOnLeftSideClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
        this.setState({
            visible: false,
            showAnimation: ""
        });
        typeof this.props.onClick === "function" && this.props.onClick(evt.data.item);
    };
    WinStartmenuComponent.prototype.handleOnMenuClick = function (evt) {
        evt.nativeEvent.cancelBubble = true;
        evt.nativeEvent.stopPropagation();
    };
    WinStartmenuComponent.prototype.handleOnBodyClick = function () {
        typeof this.props.onOutClick === "function" && this.props.onOutClick();
    };
    WinStartmenuComponent.prototype.render = function () {
        return require("./views/startMenu.html");
    };
    WinStartmenuComponent.propType = {
        data: {
            defaultValue: [],
            description: "All menu data",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        onClick: {
            description: "Menu item click event",
            rule: elmer_ui_core_1.propTypes.func
        },
        onOutClick: {
            description: "click not in menu area",
            rule: elmer_ui_core_1.propTypes.func
        },
        theme: {
            defaultValue: "",
            description: "User define theme",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        menuList: {
            defaultValue: [],
            description: "All application list",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        },
        visible: {
            defaultValue: false,
            description: "Show hiden menu",
            rule: elmer_ui_core_1.propTypes.bool.isRequired
        },
        showAnimation: {
            defaultValue: "",
            description: "set animation to menu when it's visible equal true",
            rule: elmer_ui_core_1.propTypes.string.isRequired
        },
        quickStartList: {
            defaultValue: [],
            description: "Quick start menu list",
            rule: elmer_ui_core_1.propTypes.array.isRequired
        }
    };
    WinStartmenuComponent = __decorate([
        elmer_ui_core_1.declareComponent({
            selector: "win10-startmenu"
        }),
        __metadata("design:paramtypes", [Object])
    ], WinStartmenuComponent);
    return WinStartmenuComponent;
}(elmer_ui_core_1.Component));
exports.WinStartmenuComponent = WinStartmenuComponent;
